// @license magnet:?xt=urn:btih:87f119ba0b429ba17a44b4bffcab33165ebdacc0&dn=freebsd.txt BSD-2-Clause
(function(h) {
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function e(e) {
        return e.split("");
    }
    function ke(e, n) {
        return n.indexOf(e) >= 0;
    }
    function oe(e, n) {
        for (var t = n.length; --t >= 0; ) if (e(n[t])) return n[t];
    }
    function K(e, n) {
        if (n <= 0) return "";
        if (n == 1) return e;
        var t = K(e, n >> 1);
        t += t;
        return n & 1 ? t + e : t;
    }
    function n(e) {
        Object.defineProperty(e.prototype, "stack", {
            get: function() {
                var e = new Error(this.message);
                e.name = this.name;
                try {
                    throw e;
                } catch (e) {
                    return e.stack;
                }
            }
        });
    }
    function r(e, n) {
        this.message = e;
        this.defs = n;
    }
    r.prototype = Object.create(Error.prototype);
    r.prototype.constructor = r;
    r.prototype.name = "DefaultsError";
    n(r);
    function re(e, n, t) {
        if (t) for (var i in e) {
            if (ze(e, i) && !ze(n, i)) throw new r("`" + i + "` is not a supported option", n);
        }
        for (var i in e) {
            if (ze(e, i)) n[i] = e[i];
        }
        return n;
    }
    function t(e, n) {
        var t = 0;
        for (var i in n) if (ze(n, i)) {
            e[i] = n[i];
            t++;
        }
        return t;
    }
    function ae() {}
    function Ee() {
        return false;
    }
    function se() {
        return true;
    }
    function Y() {
        return this;
    }
    function fe() {
        return null;
    }
    var Se = function() {
        function e(e, n) {
            var t = [];
            for (var i = 0; i < e.length; i++) {
                var r = n(e[i], i);
                if (r === o) continue;
                if (r instanceof a) {
                    t.push.apply(t, r.v);
                } else {
                    t.push(r);
                }
            }
            return t;
        }
        e.is_op = function(e) {
            return e === o || e instanceof a;
        };
        e.splice = function(e) {
            return new a(e);
        };
        var o = e.skip = {};
        function a(e) {
            this.v = e;
        }
        return e;
    }();
    function ue(e, n) {
        if (e.indexOf(n) < 0) return e.push(n);
    }
    function ce(e, t) {
        return e.replace(/\{(.+?)\}/g, function(e, n) {
            return t && t[n];
        });
    }
    function Te(e, n) {
        var t = e.indexOf(n);
        if (t >= 0) e.splice(t, 1);
    }
    function Oe(e) {
        if (!Array.isArray(e)) e = e.split(" ");
        var n = Object.create(null);
        e.forEach(function(e) {
            n[e] = true;
        });
        return n;
    }
    function De(e, n) {
        for (var t = e.length; --t >= 0; ) if (!n(e[t], t)) return false;
        return true;
    }
    function Ae() {
        this._values = Object.create(null);
        this._size = 0;
    }
    Ae.prototype = {
        set: function(e, n) {
            if (!this.has(e)) ++this._size;
            this._values["$" + e] = n;
            return this;
        },
        add: function(e, n) {
            if (this.has(e)) {
                this.get(e).push(n);
            } else {
                this.set(e, [ n ]);
            }
            return this;
        },
        get: function(e) {
            return this._values["$" + e];
        },
        del: function(e) {
            if (this.has(e)) {
                --this._size;
                delete this._values["$" + e];
            }
            return this;
        },
        has: function(e) {
            return "$" + e in this._values;
        },
        all: function(e) {
            for (var n in this._values) if (!e(this._values[n], n.substr(1))) return false;
            return true;
        },
        each: function(e) {
            for (var n in this._values) e(this._values[n], n.substr(1));
        },
        size: function() {
            return this._size;
        },
        map: function(e) {
            var n = [];
            for (var t in this._values) n.push(e(this._values[t], t.substr(1)));
            return n;
        },
        clone: function() {
            var e = new Ae();
            for (var n in this._values) e._values[n] = this._values[n];
            e._size = this._size;
            return e;
        },
        toObject: function() {
            return this._values;
        }
    };
    Ae.fromObject = function(e) {
        var n = new Ae();
        n._size = t(n._values, e);
        return n;
    };
    function ze(e, n) {
        return Object.prototype.hasOwnProperty.call(e, n);
    }
    function $e(e) {
        var n = e.parent(-1);
        for (var t = 0, i; i = e.parent(t++); n = i) {
            if (i.TYPE == "Call") {
                if (i.expression === n) continue;
            } else if (i instanceof qn) {
                if (i.left === n) continue;
            } else if (i instanceof jn) {
                if (i.condition === n) continue;
            } else if (i instanceof Tn) {
                if (i.expression === n) continue;
            } else if (i instanceof Sn) {
                if (i.expressions[0] === n) continue;
            } else if (i instanceof je) {
                return i.body === n;
            } else if (i instanceof $n) {
                if (i.expression === n) continue;
            }
            return false;
        }
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function i(e, n, t, i) {
        if (typeof i === "undefined") i = qe;
        n = n ? n.split(/\s+/) : [];
        var r = n;
        if (i && i.PROPS) n = n.concat(i.PROPS);
        var o = [ "return function AST_", e, "(props){", "if(props){" ];
        n.forEach(function(e) {
            o.push("this.", e, "=props.", e, ";");
        });
        var a = i && new i();
        if (a && a.initialize || t && t.initialize) o.push("this.initialize();");
        o.push("}}");
        var s = new Function(o.join(""))();
        if (a) {
            s.prototype = a;
            s.BASE = i;
        }
        if (i) i.SUBCLASSES.push(s);
        s.prototype.CTOR = s;
        s.PROPS = n || null;
        s.SELF_PROPS = r;
        s.SUBCLASSES = [];
        if (e) {
            s.prototype.TYPE = s.TYPE = e;
        }
        if (t) for (var f in t) if (ze(t, f)) {
            if (/^\$/.test(f)) {
                s[f.substr(1)] = t[f];
            } else {
                s.prototype[f] = t[f];
            }
        }
        s.DEFMETHOD = function(e, n) {
            this.prototype[e] = n;
        };
        if (typeof h !== "undefined") {
            h["AST_" + e] = s;
        }
        return s;
    }
    var Q = i("Token", "type value line col pos endline endcol endpos nlb comments_before comments_after file raw", {}, null);
    var qe = i("Node", "start end", {
        _clone: function(e) {
            if (e) {
                var n = this.clone();
                return n.transform(new ht(function(e) {
                    if (e !== n) {
                        return e.clone(true);
                    }
                }));
            }
            return new this.CTOR(this);
        },
        clone: function(e) {
            return this._clone(e);
        },
        $documentation: "Base class of all AST nodes",
        $propdoc: {
            start: "[AST_Token] The first token of this node",
            end: "[AST_Token] The last token of this node"
        },
        walk: function(e) {
            e.visit(this);
        },
        _validate: ae,
        validate: function() {
            var e = this.CTOR;
            do {
                e.prototype._validate.call(this);
            } while (e = e.BASE);
        },
        validate_ast: function() {
            var n = {};
            this.walk(new ft(function(e) {
                if (e.validate_visited === n) {
                    throw new Error(ce("cannot reuse {type} from [{file}:{line},{col}]", {
                        type: "AST_" + e.TYPE,
                        file: e.start.file,
                        line: e.start.line,
                        col: e.start.col
                    }));
                }
                e.validate_visited = n;
            }));
        }
    }, null);
    (qe.log_function = function(n, e) {
        var t = Object.create(null);
        if (n) {
            qe.info = e ? function(e, n) {
                i("INFO: " + ce(e, n));
            } : ae;
            qe.warn = function(e, n) {
                i("WARN: " + ce(e, n));
            };
        } else {
            qe.info = qe.warn = ae;
        }
        function i(e) {
            if (t[e]) return;
            t[e] = true;
            n(e);
        }
    })();
    var o = [];
    qe.enable_validation = function() {
        qe.disable_validation();
        (function e(n) {
            var i = n.prototype.transform;
            n.prototype.transform = function(e, n) {
                var t = i.call(this, e, n);
                if (t instanceof qe) {
                    t.validate();
                } else if (!(t === null || n && Se.is_op(t))) {
                    throw new Error("invalid transformed value: " + t);
                }
                return t;
            };
            o.push(function() {
                n.prototype.transform = i;
            });
            n.SUBCLASSES.forEach(e);
        })(this);
    };
    qe.disable_validation = function() {
        var e;
        while (e = o.pop()) e();
    };
    var je = i("Statement", null, {
        $documentation: "Base class of all statements"
    });
    var Me = i("Debugger", null, {
        $documentation: "Represents a debugger statement"
    }, je);
    var Ce = i("Directive", "value quote", {
        $documentation: 'Represents a directive, like "use strict";',
        $propdoc: {
            value: "[string] The value of this directive as a plain string (it's not an AST_String!)",
            quote: "[string] the original quote character"
        },
        _validate: function() {
            if (typeof this.value != "string") throw new Error("value must be string");
        }
    }, je);
    var Fe = i("EmptyStatement", null, {
        $documentation: "The empty statement (empty block or simply a semicolon)"
    }, je);
    function a(e, n) {
        if (!(e[n] instanceof qe)) throw new Error(n + " must be AST_Node");
        if (e[n] instanceof je && !(e[n] instanceof en)) {
            throw new Error(n + " cannot be AST_Statement");
        }
    }
    var Pe = i("SimpleStatement", "body", {
        $documentation: "A statement consisting of an expression, i.e. a = 1 + 2",
        $propdoc: {
            body: "[AST_Node] an expression node (should not be instanceof AST_Statement)"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.body.walk(e);
            });
        },
        _validate: function() {
            a(this, "body");
        }
    }, je);
    var Ne = i("BlockScope", "enclosed functions make_def parent_scope variables", {
        $documentation: "Base class for all statements introducing a lexical scope",
        $propdoc: {
            enclosed: "[SymbolDef*/S] a list of all symbol definitions that are accessed from this scope or any subscopes",
            functions: "[Object/S] like `variables`, but only lists function declarations",
            parent_scope: "[AST_Scope?/S] link to the parent scope",
            variables: "[Object/S] a map of name -> SymbolDef for all variables/functions defined in this scope"
        },
        clone: function(e) {
            var n = this._clone(e);
            if (this.enclosed) n.enclosed = this.enclosed.slice();
            if (this.functions) n.functions = this.functions.clone();
            if (this.variables) n.variables = this.variables.clone();
            return n;
        },
        pinned: function() {
            return this.resolve().pinned();
        },
        resolve: function() {
            return this.parent_scope.resolve();
        },
        _validate: function() {
            if (this.parent_scope == null) return;
            if (!(this.parent_scope instanceof Ne)) throw new Error("parent_scope must be AST_BlockScope");
            if (!(this.resolve() instanceof Xe)) throw new Error("must be contained within AST_Scope");
        }
    }, je);
    function He(e, n) {
        e.body.forEach(function(e) {
            e.walk(n);
        });
    }
    var Ie = i("Block", "body", {
        $documentation: "A body of statements (usually braced)",
        $propdoc: {
            body: "[AST_Statement*] an array of statements"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                He(n, e);
            });
        },
        _validate: function() {
            this.body.forEach(function(e) {
                if (!(e instanceof je)) throw new Error("body must be AST_Statement[]");
                if (e instanceof en) throw new Error("body cannot contain AST_Function");
            });
        }
    }, Ne);
    var Re = i("BlockStatement", null, {
        $documentation: "A block statement"
    }, Ie);
    var y = i("StatementWithBody", "body", {
        $documentation: "Base class for all statements that contain one nested body: `For`, `ForIn`, `Do`, `While`, `With`",
        $propdoc: {
            body: "[AST_Statement] the body; this should always be present, even if it's an AST_EmptyStatement"
        },
        _validate: function() {
            if (!(this.body instanceof je)) throw new Error("body must be AST_Statement");
            if (this.body instanceof en) throw new Error("body cannot be AST_Function");
        }
    }, Ne);
    var Ue = i("LabeledStatement", "label", {
        $documentation: "Statement with a label",
        $propdoc: {
            label: "[AST_Label] a label definition"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.label.walk(e);
                n.body.walk(e);
            });
        },
        clone: function(e) {
            var n = this._clone(e);
            if (e) {
                var t = n.label;
                var i = this.label;
                n.walk(new ft(function(e) {
                    if (e instanceof sn) {
                        if (!e.label || e.label.thedef !== i) return;
                        e.label.thedef = t;
                        t.references.push(e);
                        return true;
                    }
                    if (e instanceof Xe) return true;
                }));
            }
            return n;
        },
        _validate: function() {
            if (!(this.label instanceof he)) throw new Error("label must be AST_Label");
        }
    }, y);
    var Be = i("IterationStatement", null, {
        $documentation: "Internal class.  All loops inherit from it."
    }, y);
    var Ye = i("DWLoop", "condition", {
        $documentation: "Base class for do/while statements",
        $propdoc: {
            condition: "[AST_Node] the loop condition.  Should not be instanceof AST_Statement"
        },
        _validate: function() {
            a(this, "condition");
        }
    }, Be);
    var Le = i("Do", null, {
        $documentation: "A `do` statement",
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.body.walk(e);
                n.condition.walk(e);
            });
        }
    }, Ye);
    var Ve = i("While", null, {
        $documentation: "A `while` statement",
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.condition.walk(e);
                n.body.walk(e);
            });
        }
    }, Ye);
    var We = i("For", "init condition step", {
        $documentation: "A `for` statement",
        $propdoc: {
            init: "[AST_Node?] the `for` initialization code, or null if empty",
            condition: "[AST_Node?] the `for` termination clause, or null if empty",
            step: "[AST_Node?] the `for` update clause, or null if empty"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.init) n.init.walk(e);
                if (n.condition) n.condition.walk(e);
                if (n.step) n.step.walk(e);
                n.body.walk(e);
            });
        },
        _validate: function() {
            if (this.init != null) {
                if (!(this.init instanceof qe)) throw new Error("init must be AST_Node");
                if (this.init instanceof je && !(this.init instanceof gn || this.init instanceof en)) {
                    throw new Error("init cannot be AST_Statement");
                }
            }
            if (this.condition != null) a(this, "condition");
            if (this.step != null) a(this, "step");
        }
    }, Be);
    var Je = i("ForIn", "init object", {
        $documentation: "A `for ... in` statement",
        $propdoc: {
            init: "[AST_Node] the `for/in` initialization code",
            object: "[AST_Node] the object that we're looping through"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.init.walk(e);
                n.object.walk(e);
                n.body.walk(e);
            });
        },
        _validate: function() {
            if (this.init instanceof gn) {
                if (this.init.definitions.length != 1) throw new Error("init must have single declaration");
            } else if (!(this.init instanceof Tn || this.init instanceof Jn)) {
                throw new Error("init must be assignable");
            }
            a(this, "object");
        }
    }, Be);
    var Ge = i("With", "expression", {
        $documentation: "A `with` statement",
        $propdoc: {
            expression: "[AST_Node] the `with` expression"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                n.body.walk(e);
            });
        },
        _validate: function() {
            a(this, "expression");
        }
    }, y);
    var Xe = i("Scope", "uses_eval uses_with", {
        $documentation: "Base class for all statements introducing a lexical scope",
        $propdoc: {
            uses_eval: "[boolean/S] tells whether this scope contains a direct call to the global `eval`",
            uses_with: "[boolean/S] tells whether this scope uses the `with` statement"
        },
        pinned: function() {
            return this.uses_eval || this.uses_with;
        },
        resolve: Y
    }, Ie);
    var Ke = i("Toplevel", "globals", {
        $documentation: "The toplevel scope",
        $propdoc: {
            globals: "[Object/S] a map of name -> SymbolDef for all undeclared names"
        },
        wrap: function(e) {
            var n = this.body;
            return dt([ "(function(exports){'$ORIG';})(typeof ", e, "=='undefined'?(", e, "={}):", e, ");" ].join(""), {
                filename: "wrap=" + JSON.stringify(e)
            }).transform(new ht(function(e) {
                if (e instanceof Ce && e.value == "$ORIG") {
                    return Se.splice(n);
                }
            }));
        },
        enclose: function(e) {
            if (typeof e != "string") e = "";
            var n = e.indexOf(":");
            if (n < 0) n = e.length;
            var t = this.body;
            return dt([ "(function(", e.slice(0, n), '){"$ORIG"})(', e.slice(n + 1), ")" ].join(""), {
                filename: "enclose=" + JSON.stringify(e)
            }).transform(new ht(function(e) {
                if (e instanceof Ce && e.value == "$ORIG") {
                    return Se.splice(t);
                }
            }));
        }
    }, Xe);
    var Qe = i("Lambda", "name argnames uses_arguments length_read", {
        $documentation: "Base class for functions",
        $propdoc: {
            name: "[AST_SymbolDeclaration?] the name of this function",
            argnames: "[AST_SymbolFunarg*] array of function arguments",
            uses_arguments: "[boolean/S] tells whether this function accesses the arguments array"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                if (e.name) e.name.walk(n);
                e.argnames.forEach(function(e) {
                    e.walk(n);
                });
                He(e, n);
            });
        },
        _validate: function() {
            this.argnames.forEach(function(e) {
                if (!(e instanceof Yn)) throw new Error("argnames must be AST_SymbolFunarg[]");
            });
        }
    }, Xe);
    var Ze = i("Accessor", null, {
        $documentation: "A setter/getter function.  The `name` property is always null.",
        _validate: function() {
            if (this.name != null) throw new Error("name must be null");
        }
    }, Qe);
    var en = i("Function", "inlined", {
        $documentation: "A function expression",
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof Vn)) throw new Error("name must be AST_SymbolLambda");
            }
        }
    }, Qe);
    var nn = i("Defun", "inlined", {
        $documentation: "A function definition",
        _validate: function() {
            if (!(this.name instanceof Ln)) throw new Error("name must be AST_SymbolDefun");
        }
    }, Qe);
    var tn = i("Jump", null, {
        $documentation: "Base class for “jumps” (for now that's `return`, `throw`, `break` and `continue`)"
    }, je);
    var rn = i("Exit", "value", {
        $documentation: "Base class for “exits” (`return` and `throw`)",
        $propdoc: {
            value: "[AST_Node?] the value returned or thrown by this statement; could be null for AST_Return"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.value) n.value.walk(e);
            });
        }
    }, tn);
    var on = i("Return", null, {
        $documentation: "A `return` statement",
        _validate: function() {
            if (this.value != null) a(this, "value");
        }
    }, rn);
    var an = i("Throw", null, {
        $documentation: "A `throw` statement",
        _validate: function() {
            a(this, "value");
        }
    }, rn);
    var sn = i("LoopControl", "label", {
        $documentation: "Base class for loop control statements (`break` and `continue`)",
        $propdoc: {
            label: "[AST_LabelRef?] the label, or null if none"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.label) n.label.walk(e);
            });
        },
        _validate: function() {
            if (this.label != null) {
                if (!(this.label instanceof ve)) throw new Error("label must be AST_LabelRef");
            }
        }
    }, tn);
    var fn = i("Break", null, {
        $documentation: "A `break` statement"
    }, sn);
    var un = i("Continue", null, {
        $documentation: "A `continue` statement"
    }, sn);
    var cn = i("If", "condition alternative", {
        $documentation: "A `if` statement",
        $propdoc: {
            condition: "[AST_Node] the `if` condition",
            alternative: "[AST_Statement?] the `else` part, or null if not present"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.condition.walk(e);
                n.body.walk(e);
                if (n.alternative) n.alternative.walk(e);
            });
        },
        _validate: function() {
            a(this, "condition");
            if (this.alternative != null) {
                if (!(this.alternative instanceof je)) throw new Error("alternative must be AST_Statement");
                if (this.alternative instanceof en) throw new error("alternative cannot be AST_Function");
            }
        }
    }, y);
    var ln = i("Switch", "expression", {
        $documentation: "A `switch` statement",
        $propdoc: {
            expression: "[AST_Node] the `switch` “discriminant”"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                He(n, e);
            });
        },
        _validate: function() {
            a(this, "expression");
            this.body.forEach(function(e) {
                if (!(e instanceof pn)) throw new Error("body must be AST_SwitchBranch[]");
            });
        }
    }, Ie);
    var pn = i("SwitchBranch", null, {
        $documentation: "Base class for `switch` branches"
    }, Ie);
    var dn = i("Default", null, {
        $documentation: "A `default` switch branch"
    }, pn);
    var hn = i("Case", "expression", {
        $documentation: "A `case` switch branch",
        $propdoc: {
            expression: "[AST_Node] the `case` expression"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                He(n, e);
            });
        },
        _validate: function() {
            a(this, "expression");
        }
    }, pn);
    var vn = i("Try", "bcatch bfinally", {
        $documentation: "A `try` statement",
        $propdoc: {
            bcatch: "[AST_Catch?] the catch block, or null if not present",
            bfinally: "[AST_Finally?] the finally block, or null if not present"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                He(n, e);
                if (n.bcatch) n.bcatch.walk(e);
                if (n.bfinally) n.bfinally.walk(e);
            });
        },
        _validate: function() {
            if (this.bcatch != null) {
                if (!(this.bcatch instanceof _n)) throw new Error("bcatch must be AST_Catch");
            }
            if (this.bfinally != null) {
                if (!(this.bfinally instanceof mn)) throw new Error("bfinally must be AST_Finally");
            }
        }
    }, Ie);
    var _n = i("Catch", "argname", {
        $documentation: "A `catch` node; only makes sense as part of a `try` statement",
        $propdoc: {
            argname: "[AST_SymbolCatch?] symbol for the exception, or null if not present"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.argname) n.argname.walk(e);
                He(n, e);
            });
        },
        _validate: function() {
            if (this.argname != null) {
                if (!(this.argname instanceof Wn)) throw new Error("argname must be AST_SymbolCatch");
            }
        }
    }, Ie);
    var mn = i("Finally", null, {
        $documentation: "A `finally` node; only makes sense as part of a `try` statement"
    }, Ie);
    var gn = i("Definitions", "definitions", {
        $documentation: "Base class for `var` nodes (variable declarations/initializations)",
        $propdoc: {
            definitions: "[AST_VarDef*] array of variable definitions"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.definitions.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.definitions.length < 1) throw new Error("must have at least one definition");
        }
    }, je);
    var bn = i("Const", null, {
        $documentation: "A `const` statement",
        _validate: function() {
            this.definitions.forEach(function(e) {
                if (!(e instanceof xn)) throw new Error("definitions must be AST_VarDef[]");
                if (!(e.name instanceof Rn)) throw new Error("name must be AST_SymbolConst");
                a(e, "value");
            });
        }
    }, gn);
    var yn = i("Let", null, {
        $documentation: "A `let` statement",
        _validate: function() {
            this.definitions.forEach(function(e) {
                if (!(e instanceof xn)) throw new Error("definitions must be AST_VarDef[]");
                if (!(e.name instanceof Un)) throw new Error("name must be AST_SymbolLet");
                if (e.value != null) a(e, "value");
            });
        }
    }, gn);
    var wn = i("Var", null, {
        $documentation: "A `var` statement",
        _validate: function() {
            this.definitions.forEach(function(e) {
                if (!(e instanceof xn)) throw new Error("definitions must be AST_VarDef[]");
                if (!(e.name instanceof Bn)) throw new Error("name must be AST_SymbolVar");
                if (e.value != null) a(e, "value");
            });
        }
    }, gn);
    var xn = i("VarDef", "name value", {
        $documentation: "A variable declaration; only appears in a AST_Definitions node",
        $propdoc: {
            name: "[AST_SymbolVar] name of the variable",
            value: "[AST_Node?] initializer, or null of there's no initializer"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.name.walk(e);
                if (n.value) n.value.walk(e);
            });
        }
    });
    function s(e, n) {
        e[n].forEach(function(e) {
            if (!(e instanceof qe)) throw new Error(n + " must be AST_Node[]");
            if (e instanceof je && !(e instanceof en)) {
                throw new Error(n + " cannot contain AST_Statement");
            }
        });
    }
    var kn = i("Call", "expression args pure", {
        $documentation: "A function call expression",
        $propdoc: {
            expression: "[AST_Node] expression to invoke as function",
            args: "[AST_Node*] array of arguments"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.expression.walk(n);
                e.args.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            a(this, "expression");
            s(this, "args");
        }
    });
    var En = i("New", null, {
        $documentation: "An object instantiation.  Derives from a function call since it has exactly the same properties"
    }, kn);
    var Sn = i("Sequence", "expressions", {
        $documentation: "A sequence expression (comma-separated expressions)",
        $propdoc: {
            expressions: "[AST_Node*] array of expressions (at least two)"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.expressions.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.expressions.length < 2) throw new Error("expressions must contain multiple elements");
            s(this, "expressions");
        }
    });
    var Tn = i("PropAccess", "expression property", {
        $documentation: 'Base class for property access expressions, i.e. `a.foo` or `a["foo"]`',
        $propdoc: {
            expression: "[AST_Node] the “container” expression",
            property: "[AST_Node|string] the property to access.  For AST_Dot this is always a plain string, while for AST_Sub it's an arbitrary AST_Node"
        },
        getProperty: function() {
            var e = this.property;
            if (e instanceof Xn) {
                return e.value;
            }
            if (e instanceof zn && e.operator == "void" && e.expression instanceof Xn) {
                return;
            }
            return e;
        },
        _validate: function() {
            a(this, "expression");
        }
    });
    var On = i("Dot", null, {
        $documentation: "A dotted property access expression",
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            if (typeof this.property != "string") throw new Error("property must be string");
        }
    }, Tn);
    var Dn = i("Sub", null, {
        $documentation: 'Index-style property access, i.e. `a["foo"]`',
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                n.property.walk(e);
            });
        },
        _validate: function() {
            a(this, "property");
        }
    }, Tn);
    var An = i("Unary", "operator expression", {
        $documentation: "Base class for unary expressions",
        $propdoc: {
            operator: "[string] the operator",
            expression: "[AST_Node] expression that this unary operator applies to"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            if (typeof this.operator != "string") throw new Error("operator must be string");
            a(this, "expression");
        }
    });
    var zn = i("UnaryPrefix", null, {
        $documentation: "Unary prefix expression, i.e. `typeof i` or `++i`"
    }, An);
    var $n = i("UnaryPostfix", null, {
        $documentation: "Unary postfix expression, i.e. `i++`"
    }, An);
    var qn = i("Binary", "operator left right", {
        $documentation: "Binary expression, i.e. `a + b`",
        $propdoc: {
            left: "[AST_Node] left-hand side expression",
            operator: "[string] the operator",
            right: "[AST_Node] right-hand side expression"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.left.walk(e);
                n.right.walk(e);
            });
        },
        _validate: function() {
            a(this, "left");
            if (typeof this.operator != "string") throw new Error("operator must be string");
            a(this, "right");
        }
    });
    var jn = i("Conditional", "condition consequent alternative", {
        $documentation: "Conditional expression using the ternary operator, i.e. `a ? b : c`",
        $propdoc: {
            condition: "[AST_Node]",
            consequent: "[AST_Node]",
            alternative: "[AST_Node]"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.condition.walk(e);
                n.consequent.walk(e);
                n.alternative.walk(e);
            });
        },
        _validate: function() {
            a(this, "condition");
            a(this, "consequent");
            a(this, "alternative");
        }
    });
    var Mn = i("Assign", null, {
        $documentation: "An assignment expression — `a = b + 5`",
        _validate: function() {
            if (this.operator.indexOf("=") < 0) throw new Error('operator must contain "="');
        }
    }, qn);
    var Cn = i("Array", "elements", {
        $documentation: "An array literal",
        $propdoc: {
            elements: "[AST_Node*] array of elements"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.elements.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            s(this, "elements");
        }
    });
    var Fn = i("Object", "properties", {
        $documentation: "An object literal",
        $propdoc: {
            properties: "[AST_ObjectProperty*] array of properties"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.properties.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            this.properties.forEach(function(e) {
                if (!(e instanceof Pn)) throw new Error("properties must be AST_ObjectProperty[]");
            });
        }
    });
    var Pn = i("ObjectProperty", "key value", {
        $documentation: "Base class for literal object properties",
        $propdoc: {
            key: "[string|AST_SymbolAccessor] property name. For ObjectKeyVal this is a string. For getters and setters this is an AST_SymbolAccessor.",
            value: "[AST_Node] property value.  For getters and setters this is an AST_Accessor."
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.value.walk(e);
            });
        }
    });
    var Nn = i("ObjectKeyVal", "quote", {
        $documentation: "A key: value object property",
        $propdoc: {
            quote: "[string] the original quote character"
        },
        _validate: function() {
            if (typeof this.key != "string") throw new Error("key must be string");
            a(this, "value");
        }
    }, Pn);
    var le = i("ObjectSetter", null, {
        $documentation: "An object setter property",
        _validate: function() {
            if (!(this.key instanceof de)) throw new Error("key must be AST_SymbolAccessor");
            if (!(this.value instanceof Ze)) throw new Error("value must be AST_Accessor");
        }
    }, Pn);
    var pe = i("ObjectGetter", null, {
        $documentation: "An object getter property",
        _validate: function() {
            if (!(this.key instanceof de)) throw new Error("key must be AST_SymbolAccessor");
            if (!(this.value instanceof Ze)) throw new Error("value must be AST_Accessor");
        }
    }, Pn);
    var Hn = i("Symbol", "scope name thedef", {
        $documentation: "Base class for all symbols",
        $propdoc: {
            name: "[string] name of this symbol",
            scope: "[AST_Scope/S] the current scope (not necessarily the definition scope)",
            thedef: "[SymbolDef/S] the definition of this symbol"
        },
        _validate: function() {
            if (typeof this.name != "string") throw new Error("name must be string");
        }
    });
    var de = i("SymbolAccessor", null, {
        $documentation: "The name of a property accessor (setter/getter function)"
    }, Hn);
    var In = i("SymbolDeclaration", "init", {
        $documentation: "A declaration symbol (symbol in var, function name or argument, symbol in catch)"
    }, Hn);
    var Rn = i("SymbolConst", null, {
        $documentation: "Symbol defining a constant"
    }, In);
    var Un = i("SymbolLet", null, {
        $documentation: "Symbol defining a lexical-scoped variable"
    }, In);
    var Bn = i("SymbolVar", null, {
        $documentation: "Symbol defining a variable"
    }, In);
    var Yn = i("SymbolFunarg", null, {
        $documentation: "Symbol naming a function argument"
    }, Bn);
    var Ln = i("SymbolDefun", null, {
        $documentation: "Symbol defining a function"
    }, In);
    var Vn = i("SymbolLambda", null, {
        $documentation: "Symbol naming a function expression"
    }, In);
    var Wn = i("SymbolCatch", null, {
        $documentation: "Symbol naming the exception in catch"
    }, In);
    var he = i("Label", "references", {
        $documentation: "Symbol naming a label (declaration)",
        $propdoc: {
            references: "[AST_LoopControl*] a list of nodes referring to this label"
        },
        initialize: function() {
            this.references = [];
            this.thedef = this;
        }
    }, Hn);
    var Jn = i("SymbolRef", "fixed", {
        $documentation: "Reference to some symbol (not definition/declaration)"
    }, Hn);
    var ve = i("LabelRef", null, {
        $documentation: "Reference to a label symbol"
    }, Hn);
    var Gn = i("This", null, {
        $documentation: "The `this` symbol",
        _validate: function() {
            if (this.name !== "this") throw new Error('name must be "this"');
        }
    }, Hn);
    var Xn = i("Constant", null, {
        $documentation: "Base class for all constants"
    });
    var Kn = i("String", "value quote", {
        $documentation: "A string literal",
        $propdoc: {
            value: "[string] the contents of this string",
            quote: "[string] the original quote character"
        },
        _validate: function() {
            if (typeof this.value != "string") throw new Error("value must be string");
        }
    }, Xn);
    var Qn = i("Number", "value", {
        $documentation: "A number literal",
        $propdoc: {
            value: "[number] the numeric value"
        },
        _validate: function() {
            if (typeof this.value != "number") throw new Error("value must be number");
        }
    }, Xn);
    var Zn = i("RegExp", "value", {
        $documentation: "A regexp literal",
        $propdoc: {
            value: "[RegExp] the actual regexp"
        },
        _validate: function() {
            if (!(this.value instanceof RegExp)) throw new Error("value must be RegExp");
        }
    }, Xn);
    var v = i("Atom", null, {
        $documentation: "Base class for atoms"
    }, Xn);
    var et = i("Null", null, {
        $documentation: "The `null` atom",
        value: null
    }, v);
    var nt = i("NaN", null, {
        $documentation: "The impossible value",
        value: 0 / 0
    }, v);
    var tt = i("Undefined", null, {
        $documentation: "The `undefined` value",
        value: function() {}()
    }, v);
    var it = i("Hole", null, {
        $documentation: "A hole in an array",
        value: function() {}()
    }, v);
    var rt = i("Infinity", null, {
        $documentation: "The `Infinity` value",
        value: 1 / 0
    }, v);
    var ot = i("Boolean", null, {
        $documentation: "Base class for booleans"
    }, v);
    var at = i("False", null, {
        $documentation: "The `false` atom",
        value: false
    }, ot);
    var st = i("True", null, {
        $documentation: "The `true` atom",
        value: true
    }, ot);
    function ft(e) {
        this.callback = e;
        this.directives = Object.create(null);
        this.stack = [];
    }
    ft.prototype = {
        visit: function(e, n) {
            this.push(e);
            var t = this.callback(e, n || ae);
            if (!t && n) n();
            this.pop();
        },
        parent: function(e) {
            return this.stack[this.stack.length - 2 - (e || 0)];
        },
        push: function(e) {
            if (e instanceof Qe) {
                this.directives = Object.create(this.directives);
            } else if (e instanceof Ce && !this.directives[e.value]) {
                this.directives[e.value] = e;
            }
            this.stack.push(e);
        },
        pop: function() {
            if (this.stack.pop() instanceof Qe) {
                this.directives = Object.getPrototypeOf(this.directives);
            }
        },
        self: function() {
            return this.stack[this.stack.length - 1];
        },
        find_parent: function(e) {
            var n = this.stack;
            for (var t = n.length; --t >= 0; ) {
                var i = n[t];
                if (i instanceof e) return i;
            }
        },
        has_directive: function(e) {
            var n = this.directives[e];
            if (n) return n;
            var t = this.stack[this.stack.length - 1];
            if (t instanceof Xe) {
                for (var i = 0; i < t.body.length; ++i) {
                    var r = t.body[i];
                    if (!(r instanceof Ce)) break;
                    if (r.value == e) return r;
                }
            }
        },
        loopcontrol_target: function(e) {
            var n = this.stack;
            if (e.label) for (var t = n.length; --t >= 0; ) {
                var i = n[t];
                if (i instanceof Ue && i.label.name == e.label.name) return i.body;
            } else for (var t = n.length; --t >= 0; ) {
                var i = n[t];
                if (i instanceof Be || e instanceof fn && i instanceof ln) return i;
            }
        },
        in_boolean_context: function() {
            var e = this.self();
            for (var n = 0, t; t = this.parent(n); n++) {
                if (t instanceof jn && t.condition === e || t instanceof Ye && t.condition === e || t instanceof We && t.condition === e || t instanceof cn && t.condition === e || t instanceof on && t.in_bool || t instanceof Sn && t.tail_node() !== e || t instanceof Pe || t instanceof zn && t.operator == "!" && t.expression === e) {
                    return true;
                }
                if (t instanceof qn && (t.operator == "&&" || t.operator == "||") || t instanceof jn || t.tail_node() === e) {
                    e = t;
                } else if (t instanceof on) {
                    var i;
                    do {
                        i = this.parent(++n);
                        if (!i) return false;
                    } while (!(i instanceof Qe));
                    if (i.name) return false;
                    e = this.parent(++n);
                    if (!e || e.TYPE != "Call" || e.expression !== i) return false;
                } else {
                    return false;
                }
            }
        }
    };
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>
    Parser based on parse-js (http://marijn.haverbeke.nl/parse-js/).

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    var _e = "break case catch const continue debugger default delete do else finally for function if in instanceof let new return switch throw try typeof var void while with";
    var q = "false null true";
    var w = [ "abstract boolean byte char class double enum export extends final float goto implements import int interface let long native package private protected public short static super synchronized this throws transient volatile yield", q, _e ].join(" ");
    var j = "return new delete throw else case";
    _e = Oe(_e);
    w = Oe(w);
    j = Oe(j);
    q = Oe(q);
    var f = /^0b([01]+)$/i;
    var u = /^0x([0-9a-f]+)$/i;
    var c = /^0o?([0-7]+)$/i;
    var M = Oe([ "in", "instanceof", "typeof", "new", "void", "delete", "++", "--", "+", "-", "!", "~", "&", "|", "^", "*", "/", "%", ">>", "<<", ">>>", "<", ">", "<=", ">=", "==", "===", "!=", "!==", "?", "=", "+=", "-=", "/=", "*=", "%=", ">>=", "<<=", ">>>=", "|=", "^=", "&=", "&&", "||" ]);
    var C = "\n\r\u2028\u2029";
    var F = "+-*&%=<>!?|~^";
    var P = "[{(,;:";
    var N = P + ")}]";
    var H = C + "  \t\f\v​             　\ufeff";
    var I = Oe(e("./'\"" + F + N + H));
    C = Oe(e(C));
    F = Oe(e(F));
    P = Oe(e(P));
    N = Oe(e(N));
    H = Oe(e(H));
    function Z(e) {
        return e >= 55296 && e <= 56319;
    }
    function ee(e) {
        return e >= 56320 && e <= 57343;
    }
    function R(e) {
        return e >= 48 && e <= 57;
    }
    function ne(e) {
        return !I[e];
    }
    function ut(e) {
        return /^[a-z_$][a-z0-9_$]*$/i.test(e);
    }
    function U(e) {
        var n;
        if (n = f.exec(e)) return parseInt(n[1], 2);
        if (n = u.exec(e)) return parseInt(n[1], 16);
        if (n = c.exec(e)) return parseInt(n[1], 8);
        var t = parseFloat(e);
        if (t == e) return t;
    }
    function ct(e, n, t, i, r) {
        this.message = e;
        this.filename = n;
        this.line = t;
        this.col = i;
        this.pos = r;
    }
    ct.prototype = Object.create(Error.prototype);
    ct.prototype.constructor = ct;
    ct.prototype.name = "SyntaxError";
    n(ct);
    function me(e, n, t, i, r) {
        throw new ct(e, n, t, i, r);
    }
    function ge(e, n, t) {
        return e.type == n && (t == null || e.value == t);
    }
    var B = {};
    function be(r, o, a, s) {
        var f = {
            text: r,
            filename: o,
            pos: 0,
            tokpos: 0,
            line: 1,
            tokline: 0,
            col: 0,
            tokcol: 0,
            newline_before: false,
            regex_allowed: false,
            comments_before: [],
            directives: {},
            directive_stack: []
        };
        var u = false;
        function c() {
            return f.text.charAt(f.pos);
        }
        function l(e, n) {
            var t = f.text.charAt(f.pos++);
            if (e && !t) throw B;
            if (C[t]) {
                f.col = 0;
                f.line++;
                if (!n) f.newline_before = true;
                if (t == "\r" && c() == "\n") {
                    f.pos++;
                    t = "\n";
                }
            } else {
                f.col++;
            }
            return t;
        }
        function p(e) {
            while (e-- > 0) l();
        }
        function d(e) {
            return f.text.substr(f.pos, e.length) == e;
        }
        function h() {
            var e = f.text;
            for (var n = f.pos; n < f.text.length; ++n) {
                if (C[e[n]]) return n;
            }
            return -1;
        }
        function i(e, n) {
            var t = f.text.indexOf(e, f.pos);
            if (n && t == -1) throw B;
            return t;
        }
        function v() {
            f.tokline = f.line;
            f.tokcol = f.col;
            f.tokpos = f.pos;
        }
        function _(e, n, t) {
            f.regex_allowed = e == "operator" && !we[n] || e == "keyword" && j[n] || e == "punc" && P[n];
            if (e == "punc" && n == ".") u = true; else if (!t) u = false;
            var i = {
                type: e,
                value: n,
                line: f.tokline,
                col: f.tokcol,
                pos: f.tokpos,
                endline: f.line,
                endcol: f.col,
                endpos: f.pos,
                nlb: f.newline_before,
                file: o
            };
            if (/^(?:num|string|regexp)$/i.test(e)) {
                i.raw = r.substring(i.pos, i.endpos);
            }
            if (!t) {
                i.comments_before = f.comments_before;
                i.comments_after = f.comments_before = [];
            }
            f.newline_before = false;
            return new Q(i);
        }
        function m() {
            while (H[c()]) l();
        }
        function t(e) {
            var n = "", t, i = 0;
            while ((t = c()) && e(t, i++)) n += l();
            return n;
        }
        function g(e) {
            me(e, o, f.tokline, f.tokcol, f.tokpos);
        }
        function b(i) {
            var r = false, o = false, a = false, s = i == ".";
            var e = t(function(e, n) {
                var t = e.charCodeAt(0);
                switch (t) {
                  case 120:
                  case 88:
                    return a ? false : a = true;

                  case 101:
                  case 69:
                    return a ? true : r ? false : r = o = true;

                  case 45:
                    return o || n == 0 && !i;

                  case 43:
                    return o;

                  case o = false, 46:
                    return !s && !a && !r ? s = true : false;
                }
                return R(t) || /[_0-9a-fo]/i.test(e);
            });
            if (i) e = i + e;
            if (/^0[0-7_]+$/.test(e)) {
                if ($.has_directive("use strict")) g("Legacy octal literals are not allowed in strict mode");
            } else {
                e = e.replace(a ? /([1-9a-f]|.0)_(?=[0-9a-f])/gi : /([1-9]|.0)_(?=[0-9])/gi, "$1");
            }
            var n = U(e);
            if (!isNaN(n)) return _("num", n);
            g("Invalid syntax: " + e);
        }
        function y(e) {
            var n = l(true, e);
            switch (n.charCodeAt(0)) {
              case 110:
                return "\n";

              case 114:
                return "\r";

              case 116:
                return "\t";

              case 98:
                return "\b";

              case 118:
                return "\v";

              case 102:
                return "\f";

              case 120:
                return String.fromCharCode(x(2));

              case 117:
                if (c() != "{") return String.fromCharCode(x(4));
                l();
                var t = 0;
                do {
                    var i = parseInt(l(true), 16);
                    if (isNaN(i)) g("Invalid hex-character pattern in string");
                    t = t * 16 + i;
                } while (c() != "}");
                l();
                if (t < 65536) return String.fromCharCode(t);
                if (t > 1114111) g("Invalid character code: " + t);
                return String.fromCharCode((t >> 10) + 55232) + String.fromCharCode((t & 1023) + 56320);

              case 13:
                if (c() == "\n") l(true, e);

              case 10:
                return "";
            }
            if (n >= "0" && n <= "7") return w(n);
            return n;
        }
        function w(e) {
            var n = c();
            if (n >= "0" && n <= "7") {
                e += l(true);
                if (e[0] <= "3" && (n = c()) >= "0" && n <= "7") e += l(true);
            }
            if (e === "0") return "\0";
            if (e.length > 0 && $.has_directive("use strict")) g("Legacy octal escape sequences are not allowed in strict mode");
            return String.fromCharCode(parseInt(e, 8));
        }
        function x(e) {
            var n = 0;
            for (;e > 0; --e) {
                var t = parseInt(l(true), 16);
                if (isNaN(t)) g("Invalid hex-character pattern in string");
                n = n << 4 | t;
            }
            return n;
        }
        var k = n("Unterminated string constant", function(e) {
            var n = l(), t = "";
            for (;;) {
                var i = l(true, true);
                if (i == "\\") i = y(true); else if (C[i]) g("Unterminated string constant"); else if (i == n) break;
                t += i;
            }
            var r = _("string", t);
            r.quote = e;
            return r;
        });
        function E(e) {
            var n = f.regex_allowed;
            var t = h(), i;
            if (t == -1) {
                i = f.text.substr(f.pos);
                f.pos = f.text.length;
            } else {
                i = f.text.substring(f.pos, t);
                f.pos = t;
            }
            f.col = f.tokcol + (f.pos - f.tokpos);
            f.comments_before.push(_(e, i, true));
            f.regex_allowed = n;
            return $;
        }
        var e = n("Unterminated multiline comment", function() {
            var e = f.regex_allowed;
            var n = i("*/", true);
            var t = f.text.substring(f.pos, n).replace(/\r\n|\r|\u2028|\u2029/g, "\n");
            p(t.length + 2);
            f.comments_before.push(_("comment2", t, true));
            f.regex_allowed = e;
            return $;
        });
        function S() {
            var e = false, n = "", t, i = false, r;
            while (t = c()) {
                if (!e) {
                    if (t == "\\") i = e = true, l(); else if (ne(t)) n += l(); else break;
                } else {
                    if (t != "u") g("Expecting UnicodeEscapeSequence -- uXXXX");
                    t = y();
                    if (!ne(t)) g("Unicode char: " + t.charCodeAt(0) + " is not valid in identifier");
                    n += t;
                    e = false;
                }
            }
            if (_e[n] && i) {
                r = n.charCodeAt(0).toString(16).toUpperCase();
                n = "\\u" + "0000".substr(r.length) + r + n.slice(1);
            }
            return n;
        }
        var T = n("Unterminated regular expression", function(e) {
            var n = false, t, i = false;
            while (t = l(true)) if (C[t]) {
                g("Unexpected line terminator");
            } else if (n) {
                e += "\\" + t;
                n = false;
            } else if (t == "[") {
                i = true;
                e += t;
            } else if (t == "]" && i) {
                i = false;
                e += t;
            } else if (t == "/" && !i) {
                break;
            } else if (t == "\\") {
                n = true;
            } else {
                e += t;
            }
            var r = S();
            try {
                var o = new RegExp(e, r);
                o.raw_source = e;
                return _("regexp", o);
            } catch (e) {
                g(e.message);
            }
        });
        function O(e) {
            function t(e) {
                if (!c()) return e;
                var n = e + c();
                if (M[n]) {
                    l();
                    return t(n);
                } else {
                    return e;
                }
            }
            return _("operator", t(e || l()));
        }
        function D() {
            l();
            switch (c()) {
              case "/":
                l();
                return E("comment1");

              case "*":
                l();
                return e();
            }
            return f.regex_allowed ? T("") : O("/");
        }
        function A() {
            l();
            return R(c().charCodeAt(0)) ? b(".") : _("punc", ".");
        }
        function z() {
            var e = S();
            if (u) return _("name", e);
            return q[e] ? _("atom", e) : !_e[e] ? _("name", e) : M[e] ? _("operator", e) : _("keyword", e);
        }
        function n(n, t) {
            return function(e) {
                try {
                    return t(e);
                } catch (e) {
                    if (e === B) g(n); else throw e;
                }
            };
        }
        function $(e) {
            if (e != null) return T(e);
            if (s && f.pos == 0 && d("#!")) {
                v();
                p(2);
                E("comment5");
            }
            for (;;) {
                m();
                v();
                if (a) {
                    if (d("\x3c!--")) {
                        p(4);
                        E("comment3");
                        continue;
                    }
                    if (d("--\x3e") && f.newline_before) {
                        p(3);
                        E("comment4");
                        continue;
                    }
                }
                var n = c();
                if (!n) return _("eof");
                var t = n.charCodeAt(0);
                switch (t) {
                  case 34:
                  case 39:
                    return k(n);

                  case 46:
                    return A();

                  case 47:
                    var i = D();
                    if (i === $) continue;
                    return i;
                }
                if (R(t)) return b();
                if (N[n]) return _("punc", l());
                if (F[n]) return O();
                if (t == 92 || !I[n]) return z();
                break;
            }
            g("Unexpected character '" + n + "'");
        }
        $.context = function(e) {
            if (e) f = e;
            return f;
        };
        $.add_directive = function(e) {
            f.directive_stack[f.directive_stack.length - 1].push(e);
            if (f.directives[e]) f.directives[e]++; else f.directives[e] = 1;
        };
        $.push_directives_stack = function() {
            f.directive_stack.push([]);
        };
        $.pop_directives_stack = function() {
            var e = f.directive_stack.pop();
            for (var n = e.length; --n >= 0; ) {
                f.directives[e[n]]--;
            }
        };
        $.has_directive = function(e) {
            return f.directives[e] > 0;
        };
        return $;
    }
    var ye = Oe("typeof void delete -- ++ ! ~ - +");
    var we = Oe("-- ++");
    var xe = Oe("= += -= /= *= %= >>= <<= >>>= |= ^= &=");
    var lt = function(e, n) {
        for (var t = 0; t < e.length; ) {
            var i = e[t++];
            for (var r = 0; r < i.length; r++) {
                n[i[r]] = t;
            }
        }
        return n;
    }([ [ "||" ], [ "&&" ], [ "|" ], [ "^" ], [ "&" ], [ "==", "===", "!=", "!==" ], [ "<", ">", "<=", ">=", "in", "instanceof" ], [ ">>", "<<", ">>>" ], [ "+", "-" ], [ "*", "/", "%" ] ], {});
    var pt = Oe("atom num string regexp name");
    function dt(e, a) {
        a = re(a, {
            bare_returns: false,
            expression: false,
            filename: null,
            html5_comments: true,
            shebang: true,
            strict: false,
            toplevel: null
        }, true);
        var f = {
            input: typeof e == "string" ? be(e, a.filename, a.html5_comments, a.shebang) : e,
            token: null,
            prev: null,
            peeked: null,
            in_function: 0,
            in_directives: true,
            in_loop: 0,
            labels: []
        };
        f.token = c();
        function u(e, n) {
            return ge(f.token, e, n);
        }
        function s() {
            return f.peeked || (f.peeked = f.input());
        }
        function c() {
            f.prev = f.token;
            if (f.peeked) {
                f.token = f.peeked;
                f.peeked = null;
            } else {
                f.token = f.input();
            }
            f.in_directives = f.in_directives && (f.token.type == "string" || u("punc", ";"));
            return f.token;
        }
        function l() {
            return f.prev;
        }
        function p(e, n, t, i) {
            var r = f.input.context();
            me(e, r.filename, n != null ? n : r.tokline, t != null ? t : r.tokcol, i != null ? i : r.tokpos);
        }
        function t(e, n) {
            p(n, e.line, e.col);
        }
        function i(e, n) {
            return e + (n === undefined ? "" : " «" + n + "»");
        }
        function d(e) {
            if (e == null) e = f.token;
            t(e, "Unexpected token: " + i(e.type, e.value));
        }
        function h(e, n) {
            if (u(e, n)) return c();
            t(f.token, "Unexpected token: " + i(f.token.type, f.token.value) + ", expected: " + i(e, n));
        }
        function v(e) {
            return h("punc", e);
        }
        function _(e) {
            return e.nlb || !De(e.comments_before, function(e) {
                return !e.nlb;
            });
        }
        function m() {
            return !a.strict && (u("eof") || u("punc", "}") || _(f.token));
        }
        function g(e) {
            if (u("punc", ";")) c(); else if (!e && !m()) h("punc", ";");
        }
        function b() {
            v("(");
            var e = te(true);
            v(")");
            return e;
        }
        function n(i) {
            return function() {
                var e = f.token;
                var n = i.apply(null, arguments);
                var t = l();
                n.start = e;
                n.end = t;
                return n;
            };
        }
        function y() {
            if (u("operator", "/") || u("operator", "/=")) {
                f.peeked = null;
                f.token = f.input(f.token.value.substr(1));
            }
        }
        var w = n(function(e) {
            y();
            switch (f.token.type) {
              case "string":
                var n = f.in_directives;
                var t = te(true);
                if (n) {
                    if (t instanceof Kn) {
                        var i = t.start.raw.slice(1, -1);
                        f.input.add_directive(i);
                        t.value = i;
                    } else {
                        f.in_directives = n = false;
                    }
                }
                g();
                return n ? new Ce(t) : new Pe({
                    body: t
                });

              case "num":
              case "regexp":
              case "operator":
              case "atom":
                return k();

              case "name":
                return ge(s(), "punc", ":") ? x() : k();

              case "punc":
                switch (f.token.value) {
                  case "{":
                    return new Re({
                        start: f.token,
                        body: D(),
                        end: l()
                    });

                  case "[":
                  case "(":
                    return k();

                  case ";":
                    f.in_directives = false;
                    c();
                    return new Fe();

                  default:
                    d();
                }

              case "keyword":
                switch (f.token.value) {
                  case "break":
                    c();
                    return E(fn);

                  case "const":
                    c();
                    var r = q();
                    g();
                    return r;

                  case "continue":
                    c();
                    return E(un);

                  case "debugger":
                    c();
                    g();
                    return new Me();

                  case "do":
                    c();
                    var t = ie(w);
                    h("keyword", "while");
                    var o = b();
                    g(true);
                    return new Le({
                        body: t,
                        condition: o
                    });

                  case "while":
                    c();
                    return new Ve({
                        condition: b(),
                        body: ie(w)
                    });

                  case "for":
                    c();
                    return S();

                  case "function":
                    if (!e && f.input.has_directive("use strict")) {
                        p("In strict mode code, functions can only be declared at top level or immediately within another function.");
                    }
                    c();
                    return T(nn);

                  case "if":
                    c();
                    return O();

                  case "let":
                    c();
                    var r = j();
                    g();
                    return r;

                  case "return":
                    if (f.in_function == 0 && !a.bare_returns) p("'return' outside of function");
                    c();
                    var i = null;
                    if (u("punc", ";")) {
                        c();
                    } else if (!m()) {
                        i = te(true);
                        g();
                    }
                    return new on({
                        value: i
                    });

                  case "switch":
                    c();
                    return new ln({
                        expression: b(),
                        body: ie(A)
                    });

                  case "throw":
                    c();
                    if (_(f.token)) p("Illegal newline after 'throw'");
                    var i = te(true);
                    g();
                    return new an({
                        value: i
                    });

                  case "try":
                    c();
                    return z();

                  case "var":
                    c();
                    var r = M();
                    g();
                    return r;

                  case "with":
                    if (f.input.has_directive("use strict")) {
                        p("Strict mode may not include a with statement");
                    }
                    c();
                    return new Ge({
                        expression: b(),
                        body: w()
                    });
                }
            }
            d();
        });
        function x() {
            var n = V(he);
            if (!De(f.labels, function(e) {
                return e.name != n.name;
            })) {
                p("Label " + n.name + " defined twice");
            }
            v(":");
            f.labels.push(n);
            var e = w();
            f.labels.pop();
            if (!(e instanceof Be)) {
                n.references.forEach(function(e) {
                    if (e instanceof un) {
                        e = e.label.start;
                        p("Continue label `" + n.name + "` refers to non-IterationStatement.", e.line, e.col, e.pos);
                    }
                });
            }
            return new Ue({
                body: e,
                label: n
            });
        }
        function k() {
            var e = te(true);
            g();
            return new Pe({
                body: e
            });
        }
        function E(e) {
            var n = null, t;
            if (!m()) {
                n = V(ve, true);
            }
            if (n != null) {
                t = oe(function(e) {
                    return e.name == n.name;
                }, f.labels);
                if (!t) p("Undefined label " + n.name);
                n.thedef = t;
            } else if (f.in_loop == 0) p(e.TYPE + " not inside a loop or switch");
            g();
            var i = new e({
                label: n
            });
            if (t) t.references.push(i);
            return i;
        }
        function S() {
            v("(");
            var e = null;
            if (!u("punc", ";")) {
                e = u("keyword", "const") ? (c(), q(true)) : u("keyword", "var") ? (c(), M(true)) : te(true, true);
                if (u("operator", "in")) {
                    if (e instanceof wn) {
                        if (e.definitions.length > 1) p("Only one variable declaration allowed in for..in loop", e.start.line, e.start.col, e.start.pos);
                    } else if (!ee(e)) {
                        p("Invalid left-hand side in for..in loop", e.start.line, e.start.col, e.start.pos);
                    }
                    c();
                    return o(e);
                }
            }
            return r(e);
        }
        function r(e) {
            v(";");
            var n = u("punc", ";") ? null : te(true);
            v(";");
            var t = u("punc", ")") ? null : te(true);
            v(")");
            return new We({
                init: e,
                condition: n,
                step: t,
                body: ie(w)
            });
        }
        function o(e) {
            var n = te(true);
            v(")");
            return new Je({
                init: e,
                object: n,
                body: ie(w)
            });
        }
        var T = function(e) {
            var n = e === nn;
            var t = u("name") ? V(n ? Ln : Vn) : null;
            if (n && !t) h("name");
            if (t && e !== Ze && !(t instanceof In)) d(l());
            v("(");
            var i = [];
            for (var r = true; !u("punc", ")"); ) {
                if (r) r = false; else v(",");
                i.push(V(Yn));
            }
            c();
            var o = f.in_loop;
            var a = f.labels;
            ++f.in_function;
            f.in_directives = true;
            f.input.push_directives_stack();
            f.in_loop = 0;
            f.labels = [];
            var s = D(true);
            if (f.input.has_directive("use strict")) {
                if (t) L(t);
                i.forEach(L);
            }
            f.input.pop_directives_stack();
            --f.in_function;
            f.in_loop = o;
            f.labels = a;
            return new e({
                name: t,
                argnames: i,
                body: s
            });
        };
        function O() {
            var e = b(), n = w(), t = null;
            if (u("keyword", "else")) {
                c();
                t = w();
            }
            return new cn({
                condition: e,
                body: n,
                alternative: t
            });
        }
        function D(e) {
            v("{");
            var n = [];
            while (!u("punc", "}")) {
                if (u("eof")) h("punc", "}");
                n.push(w(e));
            }
            c();
            return n;
        }
        function A() {
            v("{");
            var e = [], n, t, i, r;
            while (!u("punc", "}")) {
                if (u("eof")) h("punc", "}");
                if (u("keyword", "case")) {
                    if (n) n.end = l();
                    t = [];
                    n = new hn({
                        start: (r = f.token, c(), r),
                        expression: te(true),
                        body: t
                    });
                    e.push(n);
                    v(":");
                } else if (u("keyword", "default")) {
                    if (n) n.end = l();
                    if (i) p("More than one default clause in switch statement");
                    t = [];
                    n = new dn({
                        start: (r = f.token, c(), v(":"), r),
                        body: t
                    });
                    e.push(n);
                    i = n;
                } else {
                    if (!t) d();
                    t.push(w());
                }
            }
            if (n) n.end = l();
            c();
            return e;
        }
        function z() {
            var e = D(), n = null, t = null;
            if (u("keyword", "catch")) {
                var i = f.token;
                c();
                var r = null;
                if (u("punc", "(")) {
                    c();
                    r = V(Wn);
                    v(")");
                }
                n = new _n({
                    start: i,
                    argname: r,
                    body: D(),
                    end: l()
                });
            }
            if (u("keyword", "finally")) {
                var i = f.token;
                c();
                t = new mn({
                    start: i,
                    body: D(),
                    end: l()
                });
            }
            if (!n && !t) p("Missing catch/finally blocks");
            return new vn({
                body: e,
                bcatch: n,
                bfinally: t
            });
        }
        function $(e, n, t) {
            var i = [];
            for (;;) {
                var r = f.token;
                var o = V(e);
                var a = null;
                if (u("operator", "=")) {
                    c();
                    a = te(false, n);
                } else if (t) {
                    p("Missing initializer in declaration");
                }
                i.push(new xn({
                    start: r,
                    name: o,
                    value: a,
                    end: l()
                }));
                if (!u("punc", ",")) break;
                c();
            }
            return i;
        }
        var q = function(e) {
            return new bn({
                start: l(),
                definitions: $(Rn, e, true),
                end: l()
            });
        };
        var j = function(e) {
            return new yn({
                start: l(),
                definitions: $(Un, e),
                end: l()
            });
        };
        var M = function(e) {
            return new wn({
                start: l(),
                definitions: $(Bn, e),
                end: l()
            });
        };
        var C = function(e) {
            var n = f.token;
            h("operator", "new");
            var t = P(false), i;
            if (u("punc", "(")) {
                c();
                i = N(")");
            } else {
                i = [];
            }
            var r = new En({
                start: n,
                expression: t,
                args: i,
                end: l()
            });
            W(r);
            return J(r, e);
        };
        function F() {
            var e = f.token, n;
            switch (e.type) {
              case "name":
                n = Y(Jn);
                break;

              case "num":
                n = new Qn({
                    start: e,
                    end: e,
                    value: e.value
                });
                break;

              case "string":
                n = new Kn({
                    start: e,
                    end: e,
                    value: e.value,
                    quote: e.quote
                });
                break;

              case "regexp":
                n = new Zn({
                    start: e,
                    end: e,
                    value: e.value
                });
                break;

              case "atom":
                switch (e.value) {
                  case "false":
                    n = new at({
                        start: e,
                        end: e
                    });
                    break;

                  case "true":
                    n = new st({
                        start: e,
                        end: e
                    });
                    break;

                  case "null":
                    n = new et({
                        start: e,
                        end: e
                    });
                    break;
                }
                break;
            }
            c();
            return n;
        }
        var P = function(e) {
            if (u("operator", "new")) {
                return C(e);
            }
            var n = f.token;
            if (u("punc")) {
                switch (n.value) {
                  case "(":
                    c();
                    var t = te(true);
                    var i = n.comments_before.length;
                    [].unshift.apply(t.start.comments_before, n.comments_before);
                    n.comments_before.length = 0;
                    n.comments_before = t.start.comments_before;
                    n.comments_before_length = i;
                    if (i == 0 && n.comments_before.length > 0) {
                        var r = n.comments_before[0];
                        if (!r.nlb) {
                            r.nlb = n.nlb;
                            n.nlb = false;
                        }
                    }
                    n.comments_after = t.start.comments_after;
                    t.start = n;
                    v(")");
                    var o = l();
                    o.comments_before = t.end.comments_before;
                    [].push.apply(t.end.comments_after, o.comments_after);
                    o.comments_after.length = 0;
                    o.comments_after = t.end.comments_after;
                    t.end = o;
                    if (t instanceof kn) W(t);
                    return J(t, e);

                  case "[":
                    return J(H(), e);

                  case "{":
                    return J(R(), e);
                }
                d();
            }
            if (u("keyword", "function")) {
                c();
                var a = T(en);
                a.start = n;
                a.end = l();
                return J(a, e);
            }
            if (pt[f.token.type]) {
                return J(F(), e);
            }
            d();
        };
        function N(e, n, t) {
            var i = true, r = [];
            while (!u("punc", e)) {
                if (i) i = false; else v(",");
                if (n && u("punc", e)) break;
                if (u("punc", ",") && t) {
                    r.push(new it({
                        start: f.token,
                        end: f.token
                    }));
                } else {
                    r.push(te(false));
                }
            }
            c();
            return r;
        }
        var H = n(function() {
            v("[");
            return new Cn({
                elements: N("]", !a.strict, true)
            });
        });
        var I = n(function() {
            return T(Ze);
        });
        var R = n(function() {
            v("{");
            var e = true, n = [];
            while (!u("punc", "}")) {
                if (e) e = false; else v(",");
                if (!a.strict && u("punc", "}")) break;
                var t = f.token;
                var i = t.type;
                var r = U();
                if (i == "name" && !u("punc", ":")) {
                    var o = new de({
                        start: f.token,
                        name: "" + U(),
                        end: l()
                    });
                    if (r == "get") {
                        n.push(new pe({
                            start: t,
                            key: o,
                            value: I(),
                            end: l()
                        }));
                        continue;
                    }
                    if (r == "set") {
                        n.push(new le({
                            start: t,
                            key: o,
                            value: I(),
                            end: l()
                        }));
                        continue;
                    }
                }
                v(":");
                n.push(new Nn({
                    start: t,
                    quote: t.quote,
                    key: "" + r,
                    value: te(false),
                    end: l()
                }));
            }
            c();
            return new Fn({
                properties: n
            });
        });
        function U() {
            var e = f.token;
            switch (e.type) {
              case "operator":
                if (!_e[e.value]) d();

              case "num":
              case "string":
              case "name":
              case "keyword":
              case "atom":
                c();
                return e.value;

              default:
                d();
            }
        }
        function B() {
            if (!u("name")) h("name");
            var e = f.token.value;
            c();
            return e;
        }
        function Y(e) {
            var n = f.token.value;
            return new (n == "this" ? Gn : e)({
                name: String(n),
                start: f.token,
                end: f.token
            });
        }
        function L(e) {
            if (e.name == "arguments" || e.name == "eval") p("Unexpected " + e.name + " in strict mode", e.start.line, e.start.col, e.start.pos);
        }
        function V(e, n) {
            if (!u("name")) {
                if (!n) p("Name expected");
                return null;
            }
            var t = Y(e);
            if (f.input.has_directive("use strict") && t instanceof In) {
                L(t);
            }
            c();
            return t;
        }
        function W(e) {
            var n = e.start;
            var t = n.comments_before;
            var i = ze(n, "comments_before_length") ? n.comments_before_length : t.length;
            while (--i >= 0) {
                var r = t[i];
                if (/[@#]__PURE__/.test(r.value)) {
                    e.pure = r;
                    break;
                }
            }
        }
        var J = function(e, n) {
            var t = e.start;
            if (u("punc", ".")) {
                c();
                return J(new On({
                    start: t,
                    expression: e,
                    property: B(),
                    end: l()
                }), n);
            }
            if (u("punc", "[")) {
                c();
                var i = te(true);
                v("]");
                return J(new Dn({
                    start: t,
                    expression: e,
                    property: i,
                    end: l()
                }), n);
            }
            if (n && u("punc", "(")) {
                c();
                var r = new kn({
                    start: t,
                    expression: e,
                    args: N(")"),
                    end: l()
                });
                W(r);
                return J(r, true);
            }
            return e;
        };
        var G = function(e) {
            var n = f.token;
            if (u("operator") && ye[n.value]) {
                c();
                y();
                var t = X(zn, n, G(e));
                t.start = n;
                t.end = l();
                return t;
            }
            var i = P(e);
            while (u("operator") && we[f.token.value] && !_(f.token)) {
                i = X($n, f.token, i);
                i.start = n;
                i.end = f.token;
                c();
            }
            return i;
        };
        function X(e, n, t) {
            var i = n.value;
            switch (i) {
              case "++":
              case "--":
                if (!ee(t)) p("Invalid use of " + i + " operator", n.line, n.col, n.pos);
                break;

              case "delete":
                if (t instanceof Jn && f.input.has_directive("use strict")) p("Calling delete on expression not allowed in strict mode", t.start.line, t.start.col, t.start.pos);
                break;
            }
            return new e({
                operator: i,
                expression: t
            });
        }
        var K = function(e, n, t) {
            var i = u("operator") ? f.token.value : null;
            if (i == "in" && t) i = null;
            var r = i != null ? lt[i] : null;
            if (r != null && r > n) {
                c();
                var o = K(G(true), r, t);
                return K(new qn({
                    start: e.start,
                    left: e,
                    operator: i,
                    right: o,
                    end: o.end
                }), n, t);
            }
            return e;
        };
        function Q(e) {
            return K(G(true), 0, e);
        }
        var Z = function(e) {
            var n = f.token;
            var t = Q(e);
            if (u("operator", "?")) {
                c();
                var i = te(false);
                v(":");
                return new jn({
                    start: n,
                    condition: t,
                    consequent: i,
                    alternative: te(false, e),
                    end: l()
                });
            }
            return t;
        };
        function ee(e) {
            return e instanceof Tn || e instanceof Jn;
        }
        var ne = function(e) {
            var n = f.token;
            var t = Z(e), i = f.token.value;
            if (u("operator") && xe[i]) {
                if (ee(t)) {
                    c();
                    return new Mn({
                        start: n,
                        left: t,
                        operator: i,
                        right: ne(e),
                        end: l()
                    });
                }
                p("Invalid assignment");
            }
            return t;
        };
        var te = function(e, n) {
            var t = f.token;
            var i = [];
            while (true) {
                i.push(ne(n));
                if (!e || !u("punc", ",")) break;
                c();
                e = true;
            }
            return i.length == 1 ? i[0] : new Sn({
                start: t,
                expressions: i,
                end: s()
            });
        };
        function ie(e) {
            ++f.in_loop;
            var n = e();
            --f.in_loop;
            return n;
        }
        if (a.expression) {
            y();
            return te(true);
        }
        return function() {
            var e = f.token;
            var n = [];
            f.input.push_directives_stack();
            while (!u("eof")) n.push(w(true));
            f.input.pop_directives_stack();
            var t = l();
            var i = a.toplevel;
            if (i) {
                i.body = i.body.concat(n);
                i.end = t;
            } else {
                i = new Ke({
                    start: e,
                    body: n,
                    end: t
                });
            }
            return i;
        }();
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function ht(e, n) {
        ft.call(this);
        this.before = e;
        this.after = n;
    }
    ht.prototype = new ft();
    (function(e) {
        function t(e, n) {
            return Se(e, function(e) {
                return e.transform(n, true);
            });
        }
        e(qe, ae);
        e(Ue, function(e, n) {
            e.label = e.label.transform(n);
            e.body = e.body.transform(n);
        });
        e(Pe, function(e, n) {
            e.body = e.body.transform(n);
        });
        e(Ie, function(e, n) {
            e.body = t(e.body, n);
        });
        e(Le, function(e, n) {
            e.body = e.body.transform(n);
            e.condition = e.condition.transform(n);
        });
        e(Ve, function(e, n) {
            e.condition = e.condition.transform(n);
            e.body = e.body.transform(n);
        });
        e(We, function(e, n) {
            if (e.init) e.init = e.init.transform(n);
            if (e.condition) e.condition = e.condition.transform(n);
            if (e.step) e.step = e.step.transform(n);
            e.body = e.body.transform(n);
        });
        e(Je, function(e, n) {
            e.init = e.init.transform(n);
            e.object = e.object.transform(n);
            e.body = e.body.transform(n);
        });
        e(Ge, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = e.body.transform(n);
        });
        e(rn, function(e, n) {
            if (e.value) e.value = e.value.transform(n);
        });
        e(sn, function(e, n) {
            if (e.label) e.label = e.label.transform(n);
        });
        e(cn, function(e, n) {
            e.condition = e.condition.transform(n);
            e.body = e.body.transform(n);
            if (e.alternative) e.alternative = e.alternative.transform(n);
        });
        e(ln, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = t(e.body, n);
        });
        e(hn, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = t(e.body, n);
        });
        e(vn, function(e, n) {
            e.body = t(e.body, n);
            if (e.bcatch) e.bcatch = e.bcatch.transform(n);
            if (e.bfinally) e.bfinally = e.bfinally.transform(n);
        });
        e(_n, function(e, n) {
            if (e.argname) e.argname = e.argname.transform(n);
            e.body = t(e.body, n);
        });
        e(gn, function(e, n) {
            e.definitions = t(e.definitions, n);
        });
        e(xn, function(e, n) {
            e.name = e.name.transform(n);
            if (e.value) e.value = e.value.transform(n);
        });
        e(Qe, function(e, n) {
            if (e.name) e.name = e.name.transform(n);
            e.argnames = t(e.argnames, n);
            e.body = t(e.body, n);
        });
        e(kn, function(e, n) {
            e.expression = e.expression.transform(n);
            e.args = t(e.args, n);
        });
        e(Sn, function(e, n) {
            e.expressions = t(e.expressions, n);
        });
        e(On, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(Dn, function(e, n) {
            e.expression = e.expression.transform(n);
            e.property = e.property.transform(n);
        });
        e(An, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(qn, function(e, n) {
            e.left = e.left.transform(n);
            e.right = e.right.transform(n);
        });
        e(jn, function(e, n) {
            e.condition = e.condition.transform(n);
            e.consequent = e.consequent.transform(n);
            e.alternative = e.alternative.transform(n);
        });
        e(Cn, function(e, n) {
            e.elements = t(e.elements, n);
        });
        e(Fn, function(e, n) {
            e.properties = t(e.properties, n);
        });
        e(Pn, function(e, n) {
            e.value = e.value.transform(n);
        });
    })(function(e, r) {
        e.DEFMETHOD("transform", function(e, n) {
            var t, i;
            e.push(this);
            if (e.before) t = e.before(this, r, n);
            if (typeof t === "undefined") {
                t = this;
                r(t, e);
                if (e.after) {
                    i = e.after(t, n);
                    if (typeof i !== "undefined") t = i;
                }
            }
            e.pop();
            return t;
        });
    });
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function l(e, n, t, i) {
        this.eliminated = 0;
        this.global = false;
        this.id = e;
        this.init = i;
        this.lambda = t instanceof Vn;
        this.mangled_name = null;
        this.name = t.name;
        this.orig = [ t ];
        this.references = [];
        this.replaced = 0;
        this.scope = n;
        this.undeclared = false;
    }
    l.prototype = {
        forEach: function(e) {
            this.orig.forEach(e);
            this.references.forEach(e);
        },
        mangle: function(e) {
            var n = e.cache && e.cache.props;
            if (this.global && n && n.has(this.name)) {
                this.mangled_name = n.get(this.name);
            } else if (!this.mangled_name && !this.unmangleable(e)) {
                var t = this.redefined();
                if (t) {
                    this.mangled_name = t.mangled_name || t.name;
                } else {
                    this.mangled_name = m(this.scope, e, this);
                }
                if (this.global && n) {
                    n.set(this.name, this.mangled_name);
                }
            }
        },
        redefined: function() {
            var e = this.defun;
            if (!e) return;
            var n = this.name;
            var t = e.variables.get(n) || e instanceof Ke && e.globals.get(n) || this.orig[0] instanceof Rn && oe(function(e) {
                return e.name == n;
            }, e.enclosed);
            if (t && t !== this) return t.redefined() || t;
        },
        unmangleable: function(e) {
            return this.global && !e.toplevel || this.undeclared || !e.eval && this.scope.pinned() || e.keep_fnames && (this.orig[0] instanceof Vn || this.orig[0] instanceof Ln);
        }
    };
    Ke.DEFMETHOD("figure_out_scope", function(s) {
        s = re(s, {
            cache: null,
            ie8: false
        });
        var f = this;
        var a = null;
        var t = 0;
        var u = f.parent_scope = null;
        var c = new ft(function(i, e) {
            if (i instanceof nn) {
                i.name.walk(c);
                r(function() {
                    i.argnames.forEach(function(e) {
                        e.walk(c);
                    });
                    He(i, c);
                });
                return true;
            }
            if (i instanceof pn) {
                i.init_vars(u);
                e();
                return true;
            }
            if (i instanceof vn) {
                r(function() {
                    He(i, c);
                });
                if (i.bcatch) i.bcatch.walk(c);
                if (i.bfinally) i.bfinally.walk(c);
                return true;
            }
            if (i instanceof Ge) {
                var n = u;
                do {
                    n = n.resolve();
                    if (n.uses_with) break;
                    n.uses_with = true;
                } while (n = n.parent_scope);
                r(e);
                return true;
            }
            if (i instanceof Ne) {
                r(e);
                return true;
            }
            if (i instanceof Hn) {
                i.scope = u;
            }
            if (i instanceof he) {
                i.thedef = i;
                i.references = [];
            }
            if (i instanceof Wn) {
                u.def_variable(i).defun = a;
            } else if (i instanceof Rn) {
                u.def_variable(i).defun = a;
            } else if (i instanceof Ln) {
                a.def_function(i, c.parent());
                o(a, u);
            } else if (i instanceof Yn) {
                a.def_variable(i);
                o(a, u);
            } else if (i instanceof Vn) {
                var t = a.def_function(i, i.name == "arguments" ? undefined : a);
                if (s.ie8) t.defun = a.parent_scope.resolve();
            } else if (i instanceof Un) {
                u.def_variable(i);
            } else if (i instanceof Bn) {
                a.def_variable(i, null);
                o(a, u);
            }
            function r(e) {
                i.init_vars(u);
                var n = a;
                var t = u;
                if (i instanceof Xe) a = i;
                u = i;
                e();
                u = t;
                a = n;
            }
            function o(e, n) {
                if (e === n) return;
                i.mark_enclosed(s);
                var t = n.find_variable(i);
                if (i.thedef === t) return;
                i.thedef = t;
                t.orig.push(i);
                i.mark_enclosed(s);
            }
        });
        f.make_def = function(e, n) {
            return new l(++t, this, e, n);
        };
        f.walk(c);
        f.globals = new Ae();
        var c = new ft(function(e) {
            if (e instanceof sn) {
                if (e.label) e.label.thedef.references.push(e);
                return true;
            }
            if (e instanceof Jn) {
                var n = e.name;
                var t = e.scope.find_variable(n);
                if (!t) {
                    t = f.def_global(e);
                } else if (n == "arguments" && t.scope instanceof Qe) {
                    t.scope.uses_arguments = true;
                }
                if (n == "eval") {
                    var i = c.parent();
                    if (i.TYPE == "Call" && i.expression === e) {
                        var r = e.scope;
                        do {
                            r = r.resolve();
                            if (r.uses_eval) break;
                            r.uses_eval = true;
                        } while (r = r.parent_scope);
                    } else if (t.undeclared) {
                        f.uses_eval = true;
                    }
                }
                e.thedef = t;
                e.reference(s);
                return true;
            }
            if (e instanceof Wn) {
                var o = e.definition().redefined();
                if (o) for (var r = e.scope; r; r = r.parent_scope) {
                    ue(r.enclosed, o);
                    if (r === o.scope) break;
                }
                return true;
            }
            if (e instanceof Rn) {
                var a = e.definition().redefined();
                if (a) a.const_redefs = true;
                return true;
            }
        });
        f.walk(c);
        if (s.ie8) f.walk(new ft(function(e) {
            if (e instanceof Wn) {
                var n = e.thedef.defun;
                if (n.name instanceof Vn && n.name.name == e.name) {
                    n = n.parent_scope.resolve();
                }
                i(e, n);
                return true;
            }
            if (e instanceof Vn) {
                var t = e.thedef;
                i(e, e.scope.parent_scope.resolve());
                if (typeof e.thedef.init !== "undefined") {
                    e.thedef.init = false;
                } else if (t.init) {
                    e.thedef.init = t.init;
                }
                return true;
            }
        }));
        function i(e, n) {
            var t = e.name;
            var i = e.thedef;
            if (!De(i.orig, function(e) {
                return !(e instanceof Rn || e instanceof Un);
            })) return;
            var r = n.find_variable(t);
            if (r) {
                var o = r.redefined();
                if (o) r = o;
            } else {
                r = f.globals.get(t);
            }
            if (r) {
                r.orig.push(e);
            } else {
                r = n.def_variable(e);
            }
            i.defun = r.scope;
            i.forEach(function(e) {
                e.redef = true;
                e.thedef = r;
                e.reference(s);
            });
            if (i.lambda) r.lambda = true;
            if (r.undeclared) f.variables.set(t, r);
        }
    });
    Ke.DEFMETHOD("def_global", function(e) {
        var n = this.globals, t = e.name;
        if (n.has(t)) {
            return n.get(t);
        } else {
            var i = this.make_def(e);
            i.undeclared = true;
            i.global = true;
            n.set(t, i);
            return i;
        }
    });
    function p(e, n) {
        e.enclosed = [];
        e.parent_scope = n;
        e.functions = new Ae();
        e.variables = new Ae();
        if (n) e.make_def = n.make_def;
    }
    function d(e, n) {
        p(e, n);
        e.uses_eval = false;
        e.uses_with = false;
    }
    Ne.DEFMETHOD("init_vars", function(e) {
        p(this, e);
    });
    Xe.DEFMETHOD("init_vars", function(e) {
        d(this, e);
    });
    Qe.DEFMETHOD("init_vars", function(e) {
        d(this, e);
        this.uses_arguments = false;
        this.def_variable(new Yn({
            name: "arguments",
            start: this.start,
            end: this.end
        }));
        return this;
    });
    Hn.DEFMETHOD("mark_enclosed", function(e) {
        var n = this.definition();
        for (var t = this.scope; t; t = t.parent_scope) {
            ue(t.enclosed, n);
            if (e.keep_fnames) {
                t.functions.each(function(e) {
                    ue(n.scope.enclosed, e);
                });
            }
            if (t === n.scope) break;
        }
    });
    Hn.DEFMETHOD("reference", function(e) {
        this.definition().references.push(this);
        this.mark_enclosed(e);
    });
    Ne.DEFMETHOD("find_variable", function(e) {
        if (e instanceof Hn) e = e.name;
        return this.variables.get(e) || this.parent_scope && this.parent_scope.find_variable(e);
    });
    Ne.DEFMETHOD("def_function", function(e, n) {
        var t = this.def_variable(e, n);
        if (!t.init || t.init instanceof nn) t.init = n;
        this.functions.set(e.name, t);
        return t;
    });
    Ne.DEFMETHOD("def_variable", function(e, n) {
        var t = this.variables.get(e.name);
        if (t) {
            t.orig.push(e);
            if (t.init instanceof en) t.init = n;
        } else {
            t = this.make_def(e, n);
            this.variables.set(e.name, t);
            t.global = !this.parent_scope;
        }
        return e.thedef = t;
    });
    function _(e, n) {
        var t = e.names_in_use;
        if (!t) {
            e.cname = -1;
            e.cname_holes = [];
            e.names_in_use = t = Object.create(null);
            var i = n.cache && n.cache.props;
            e.enclosed.forEach(function(e) {
                if (e.unmangleable(n)) t[e.name] = true;
                if (e.global && i && i.has(e.name)) {
                    t[i.get(e.name)] = true;
                }
            });
        }
        return t;
    }
    function m(e, i, n) {
        var t = _(e, i);
        var r = e.cname_holes;
        var o = Object.create(null);
        var a = [ e ];
        n.forEach(function(e) {
            var n = e.scope;
            do {
                if (a.indexOf(n) < 0) {
                    for (var t in _(n, i)) {
                        o[t] = true;
                    }
                    a.push(n);
                } else break;
            } while (n = n.parent_scope);
        });
        var s;
        for (var f = 0; f < r.length; f++) {
            s = b(r[f]);
            if (o[s]) continue;
            r.splice(f, 1);
            t[s] = true;
            return s;
        }
        while (true) {
            s = b(++e.cname);
            if (t[s] || w[s] || i.reserved.has[s]) continue;
            if (!o[s]) break;
            r.push(e.cname);
        }
        t[s] = true;
        return s;
    }
    Hn.DEFMETHOD("unmangleable", function(e) {
        var n = this.definition();
        return !n || n.unmangleable(e);
    });
    he.DEFMETHOD("unmangleable", Ee);
    Hn.DEFMETHOD("definition", function() {
        return this.thedef;
    });
    function g(e) {
        e = re(e, {
            eval: false,
            ie8: false,
            keep_fnames: false,
            reserved: [],
            toplevel: false
        });
        if (!Array.isArray(e.reserved)) e.reserved = [];
        ue(e.reserved, "arguments");
        e.reserved.has = Oe(e.reserved);
        return e;
    }
    Ke.DEFMETHOD("mangle_names", function(a) {
        a = g(a);
        var s = -1;
        if (a.cache && a.cache.props) {
            var n = _(this, a);
            a.cache.props.each(function(e) {
                n[e] = true;
            });
        }
        var r = [];
        var f = new ft(function(e, n) {
            if (e instanceof Ue) {
                var t = s;
                n();
                s = t;
                return true;
            }
            if (e instanceof Ne) {
                var i = [];
                e.variables.each(function(e) {
                    if (!c(e)) i.push(e);
                });
                n();
                if (a.cache && e instanceof Ke) {
                    e.globals.each(u);
                }
                if (e instanceof nn && f.has_directive("use asm")) {
                    var r = new Jn(e.name);
                    r.scope = e;
                    r.reference(a);
                }
                i.forEach(u);
                return true;
            }
            if (e instanceof he) {
                var o;
                do {
                    o = b(++s);
                } while (w[o]);
                e.mangled_name = o;
                return true;
            }
        });
        this.walk(f);
        r.forEach(u);
        function u(e) {
            if (a.reserved.has[e.name]) return;
            e.mangle(a);
        }
        function c(n, e) {
            var t = n.redefined();
            if (!t) return false;
            r.push(n);
            n.references.forEach(i);
            var e = n.orig[0];
            if (e instanceof Wn || e instanceof Rn) i(e);
            return true;
            function i(e) {
                e.thedef = t;
                e.reference(a);
                e.thedef = n;
            }
        }
    });
    Ke.DEFMETHOD("find_colliding_names", function(t) {
        var i = t.cache && t.cache.props;
        var n = Object.create(w);
        t.reserved.forEach(r);
        this.globals.each(o);
        this.walk(new ft(function(e) {
            if (e instanceof Ne) e.variables.each(o);
        }));
        return n;
        function r(e) {
            n[e] = true;
        }
        function o(e) {
            var n = e.name;
            if (e.global && i && i.has(n)) n = i.get(n); else if (!e.unmangleable(t)) return;
            r(n);
        }
    });
    Ke.DEFMETHOD("expand_names", function(i) {
        b.reset();
        b.sort();
        i = g(i);
        var n = this.find_colliding_names(i);
        var t = 0;
        this.globals.each(o);
        this.walk(new ft(function(e) {
            if (e instanceof Ne) e.variables.each(o);
        }));
        function r() {
            var e;
            do {
                e = b(t++);
            } while (n[e]);
            return e;
        }
        function o(n) {
            if (n.global && i.cache) return;
            if (n.unmangleable(i)) return;
            if (i.reserved.has[n.name]) return;
            var e = n.redefined();
            var t = e ? e.rename || e.name : r();
            n.rename = t;
            n.forEach(function(e) {
                if (e.definition() === n) e.name = t;
            });
        }
    });
    qe.DEFMETHOD("tail_node", Y);
    Sn.DEFMETHOD("tail_node", function() {
        return this.expressions[this.expressions.length - 1];
    });
    Ke.DEFMETHOD("compute_char_frequency", function(e) {
        e = g(e);
        b.reset();
        var n = Hn.prototype.add_source_map;
        try {
            Hn.prototype.add_source_map = function() {
                if (!this.unmangleable(e)) b.consider(this.name, -1);
            };
            if (e.properties) {
                On.prototype.add_source_map = function() {
                    b.consider(this.property, -1);
                };
                Dn.prototype.add_source_map = function() {
                    t(this.property);
                };
            }
            b.consider(this.print_to_string(), 1);
        } finally {
            Hn.prototype.add_source_map = n;
            delete On.prototype.add_source_map;
            delete Dn.prototype.add_source_map;
        }
        b.sort();
        function t(e) {
            if (e instanceof Kn) {
                b.consider(e.value, -1);
            } else if (e instanceof jn) {
                t(e.consequent);
                t(e.alternative);
            } else if (e instanceof Sn) {
                t(e.tail_node());
            }
        }
    });
    var b = function() {
        var r = Object.create(null);
        function e(e) {
            var n = [];
            for (var t = 0; t < e.length; t++) {
                var i = e[t];
                n.push(i);
                r[i] = -.01 * t;
            }
            return n;
        }
        var n = e("0123456789");
        var t = e("abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ$_");
        var i, o;
        function a() {
            o = Object.create(r);
        }
        f.consider = function(e, n) {
            for (var t = e.length; --t >= 0; ) {
                o[e[t]] += n;
            }
        };
        function s(e, n) {
            return o[n] - o[e];
        }
        f.sort = function() {
            i = t.sort(s).concat(n.sort(s));
        };
        f.reset = a;
        a();
        function f(e) {
            var n = "", t = 54;
            e++;
            do {
                e--;
                n += i[e % t];
                e = Math.floor(e / t);
                t = 64;
            } while (e > 0);
            return n;
        }
        return f;
    }();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function te(e) {
        return e.type == "comment2" && /@preserve|@license|@cc_on/i.test(e.value);
    }
    function vt(f) {
        var e = !f;
        f = re(f, {
            ascii_only: false,
            beautify: false,
            braces: false,
            comments: false,
            ie8: false,
            indent_level: 4,
            indent_start: 0,
            inline_script: true,
            keep_quoted_props: false,
            max_line_len: false,
            preamble: null,
            preserve_line: false,
            quote_keys: false,
            quote_style: 0,
            semicolons: true,
            shebang: true,
            source_map: null,
            webkit: false,
            width: 80,
            wrap_iife: false
        }, true);
        var u = Ee;
        if (f.comments) {
            var n = f.comments;
            if (typeof f.comments === "string" && /^\/.*\/[a-zA-Z]*$/.test(f.comments)) {
                var t = f.comments.lastIndexOf("/");
                n = new RegExp(f.comments.substr(1, t - 1), f.comments.substr(t + 1));
            }
            if (n instanceof RegExp) {
                u = function(e) {
                    return e.type != "comment5" && n.test(e.value);
                };
            } else if (typeof n === "function") {
                u = function(e) {
                    return e.type != "comment5" && n(this, e);
                };
            } else if (n === "some") {
                u = te;
            } else {
                u = se;
            }
        }
        var r = f.indent_start;
        var o = 0;
        var a = 1;
        var c = 0;
        var s = "";
        var l = f.ascii_only ? function(e, t) {
            if (t) e = e.replace(/[\ud800-\udbff][\udc00-\udfff]/g, function(e) {
                return "\\u{" + (e.charCodeAt(0) - 55232 << 10 | e.charCodeAt(1) - 56320).toString(16) + "}";
            });
            return e.replace(/[\u0000-\u001f\u007f-\uffff]/g, function(e) {
                var n = e.charCodeAt(0).toString(16);
                if (n.length <= 2 && !t) {
                    while (n.length < 2) n = "0" + n;
                    return "\\x" + n;
                } else {
                    while (n.length < 4) n = "0" + n;
                    return "\\u" + n;
                }
            });
        } : function(e) {
            var n = "";
            for (var t = 0, i = 0; t < e.length; t++) {
                var r = e.charCodeAt(t);
                if (Z(r)) {
                    if (ee(e.charCodeAt(t + 1))) {
                        t++;
                        continue;
                    }
                } else if (!ee(r)) {
                    continue;
                }
                n += e.slice(i, t) + "\\u" + r.toString(16);
                i = t + 1;
            }
            return i == 0 ? e : n + e.slice(i);
        };
        function i(t, e) {
            var i = 0, r = 0;
            t = t.replace(/[\\\b\f\n\r\v\t\x22\x27\u2028\u2029\0\ufeff]/g, function(e, n) {
                switch (e) {
                  case '"':
                    ++i;
                    return '"';

                  case "'":
                    ++r;
                    return "'";

                  case "\\":
                    return "\\\\";

                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\t":
                    return "\\t";

                  case "\b":
                    return "\\b";

                  case "\f":
                    return "\\f";

                  case "\v":
                    return f.ie8 ? "\\x0B" : "\\v";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";

                  case "\ufeff":
                    return "\\ufeff";

                  case "\0":
                    return /[0-9]/.test(t.charAt(n + 1)) ? "\\x00" : "\\0";
                }
                return e;
            });
            function n() {
                return "'" + t.replace(/\x27/g, "\\'") + "'";
            }
            function o() {
                return '"' + t.replace(/\x22/g, '\\"') + '"';
            }
            t = l(t);
            switch (f.quote_style) {
              case 1:
                return n();

              case 2:
                return o();

              case 3:
                return e == "'" ? n() : o();

              default:
                return i > r ? n() : o();
            }
        }
        function p(e, n) {
            var t = i(e, n);
            if (f.inline_script) {
                t = t.replace(/<\x2f(script)([>\/\t\n\f\r ])/gi, "<\\/$1$2");
                t = t.replace(/\x3c!--/g, "\\x3c!--");
                t = t.replace(/--\x3e/g, "--\\x3e");
            }
            return t;
        }
        function d(e) {
            e = e.toString();
            e = l(e, true);
            return e;
        }
        var h = false;
        var v = 0;
        var _ = true;
        var m = false;
        var g = false;
        var b = false;
        var y = false;
        var w = -1;
        var x = "";
        var k, E, S = f.source_map && [];
        var T = S ? function(n, t) {
            S.forEach(function(e) {
                e.line += n;
                e.col += t;
            });
        } : ae;
        var O = S ? function() {
            S.forEach(function(e) {
                f.source_map.add(e.token.file, e.line, e.col, e.token.line, e.token.col, !e.name && e.token.type == "name" ? e.token.value : e.name);
            });
            S = [];
        } : ae;
        function D(e) {
            var n = s.lastIndexOf("\n");
            if (v < n) v = n;
            var t = s.slice(0, v);
            var i = s.slice(v);
            T(e, i.length - o);
            a += e;
            c += e;
            o = i.length;
            s = t;
            while (e--) s += "\n";
            s += i;
        }
        var A = f.max_line_len ? function() {
            if (_) {
                if (o > f.max_line_len) {
                    qe.warn("Output exceeds {max_line_len} characters", f);
                }
                return;
            }
            if (o > f.max_line_len) D(1);
            _ = true;
            O();
        } : ae;
        var z = Oe("( [ + * / - , .");
        function $(e) {
            e = String(e);
            var n = e.charAt(0);
            if (b && n) {
                b = false;
                if (n != "\n") {
                    $("\n");
                    j();
                }
            }
            if (y && n) {
                y = false;
                if (!/[\s;})]/.test(n)) {
                    q();
                }
            }
            w = -1;
            var t = x.slice(-1);
            if (g) {
                g = false;
                if (t == ":" && n == "}" || (!n || ";}".indexOf(n) < 0) && t != ";") {
                    if (f.semicolons || z[n]) {
                        s += ";";
                        o++;
                        c++;
                    } else {
                        A();
                        s += "\n";
                        c++;
                        a++;
                        o = 0;
                        if (/^\s+$/.test(e)) {
                            g = true;
                        }
                    }
                    if (!f.beautify) m = false;
                }
            }
            if (m) {
                if (ne(t) && (ne(n) || n == "\\") || n == "/" && n == t || (n == "+" || n == "-") && n == x || e == "--" && x == "!" || e == "in" && t == "/" || x == "--" && n == ">") {
                    s += " ";
                    o++;
                    c++;
                }
                if (t != "<" || e != "!") m = false;
            }
            if (k) {
                S.push({
                    token: k,
                    name: E,
                    line: a,
                    col: o
                });
                k = false;
                if (_) O();
            }
            s += e;
            h = e.slice(-1) == "(";
            c += e.length;
            var i = e.split(/\r?\n/), r = i.length - 1;
            a += r;
            o += i[0].length;
            if (r > 0) {
                A();
                o = i[r].length;
            }
            x = e;
        }
        var q = f.beautify ? function() {
            $(" ");
        } : function() {
            m = true;
        };
        var j = f.beautify ? function(e) {
            $(K(" ", e ? r - (f.indent_level >> 1) : r));
        } : ae;
        var M = f.beautify ? function(e, n) {
            if (e === true) e = H();
            var t = r;
            r = e;
            var i = n();
            r = t;
            return i;
        } : function(e, n) {
            return n();
        };
        var C = f.max_line_len || f.preserve_line ? function() {
            A();
            v = s.length;
            _ = false;
        } : ae;
        var F = f.beautify ? function() {
            if (w < 0) return $("\n");
            if (s[w] != "\n") {
                s = s.slice(0, w) + "\n" + s.slice(w);
                c++;
                a++;
            }
            w++;
        } : C;
        var P = f.beautify ? function() {
            $(";");
        } : function() {
            g = true;
        };
        function N() {
            if (g) $(";");
            $(";");
        }
        function H() {
            return r + f.indent_level;
        }
        function I(e) {
            var n;
            $("{");
            F();
            M(H(), function() {
                n = e();
            });
            j();
            $("}");
            return n;
        }
        function R(e) {
            $("(");
            C();
            var n = e();
            C();
            $(")");
            return n;
        }
        function U(e) {
            $("[");
            C();
            var n = e();
            C();
            $("]");
            return n;
        }
        function B() {
            C();
            $(",");
            C();
            q();
        }
        function Y() {
            $(":");
            q();
        }
        var L = S ? function(e, n) {
            k = e;
            E = n;
        } : ae;
        function V() {
            if (!_) A();
            return s;
        }
        function W() {
            var e = s.lastIndexOf("\n");
            return /^ *$/.test(s.slice(e + 1));
        }
        function J(e) {
            var i = this;
            var r = e instanceof rn && e.value;
            var o = s(e);
            if (!o) o = [];
            if (r) {
                var a = new ft(function(e) {
                    var n = a.parent();
                    if (n instanceof rn || n instanceof qn && n.left === e || n.TYPE == "Call" && n.expression === e || n instanceof jn && n.condition === e || n instanceof On && n.expression === e || n instanceof Sn && n.expressions[0] === e || n instanceof Dn && n.expression === e || n instanceof $n) {
                        var t = s(e);
                        if (t) o = o.concat(t);
                    } else {
                        return true;
                    }
                });
                a.push(e);
                e.value.walk(a);
            }
            if (c == 0) {
                if (o.length > 0 && f.shebang && o[0].type == "comment5") {
                    $("#!" + o.shift().value + "\n");
                    j();
                }
                var n = f.preamble;
                if (n) {
                    $(n.replace(/\r\n?|[\n\u2028\u2029]|\s*$/g, "\n"));
                }
            }
            o = o.filter(u, e);
            if (o.length == 0) return;
            var t = W();
            o.forEach(function(e, n) {
                if (!t) {
                    if (e.nlb) {
                        $("\n");
                        j();
                        t = true;
                    } else if (n > 0) {
                        q();
                    }
                }
                if (/comment[134]/.test(e.type)) {
                    $("//" + e.value.replace(/[@#]__PURE__/g, " ") + "\n");
                    j();
                    t = true;
                } else if (e.type == "comment2") {
                    $("/*" + e.value.replace(/[@#]__PURE__/g, " ") + "*/");
                    t = false;
                }
            });
            if (!t) {
                if (e.start.nlb) {
                    $("\n");
                    j();
                } else {
                    q();
                }
            }
            function s(e) {
                var n = e.start;
                if (!n) {
                    if (!r) return;
                    e.start = n = new Q();
                }
                var t = n.comments_before;
                if (!t) {
                    if (!r) return;
                    n.comments_before = t = [];
                }
                if (t._dumped === i) return;
                t._dumped = i;
                return t;
            }
        }
        function G(e, t) {
            var n = this;
            var i = e.end;
            if (!i) return;
            var r = i[t ? "comments_before" : "comments_after"];
            if (!r || r._dumped === n) return;
            if (!(e instanceof je || De(r, function(e) {
                return !/comment[134]/.test(e.type);
            }))) return;
            r._dumped = n;
            var o = s.length;
            r.filter(u, e).forEach(function(e, n) {
                y = false;
                if (b) {
                    $("\n");
                    j();
                    b = false;
                } else if (e.nlb && (n > 0 || !W())) {
                    $("\n");
                    j();
                } else if (n > 0 || !t) {
                    q();
                }
                if (/comment[134]/.test(e.type)) {
                    $("//" + e.value.replace(/[@#]__PURE__/g, " "));
                    b = true;
                } else if (e.type == "comment2") {
                    $("/*" + e.value.replace(/[@#]__PURE__/g, " ") + "*/");
                    y = true;
                }
            });
            if (s.length > o) w = o;
        }
        var X = [];
        return {
            get: V,
            toString: V,
            indent: j,
            should_break: e ? ae : function() {
                return f.width && o - r >= f.width;
            },
            has_parens: function() {
                return h;
            },
            newline: F,
            print: $,
            space: q,
            comma: B,
            colon: Y,
            last: function() {
                return x;
            },
            semicolon: P,
            force_semicolon: N,
            to_utf8: l,
            print_name: function(e) {
                $(d(e));
            },
            print_string: function(e, n) {
                $(p(e, n));
            },
            next_indent: H,
            with_indent: M,
            with_block: I,
            with_parens: R,
            with_square: U,
            add_mapping: L,
            option: function(e) {
                return f[e];
            },
            prepend_comments: e ? ae : J,
            append_comments: e || u === Ee ? ae : G,
            line: function() {
                return a;
            },
            col: function() {
                return o;
            },
            pos: function() {
                return c;
            },
            push_node: function(e) {
                X.push(e);
            },
            pop_node: f.preserve_line ? function() {
                var e = X.pop();
                if (e.start && e.start.line > a) {
                    D(e.start.line - a);
                }
            } : function() {
                X.pop();
            },
            parent: function(e) {
                return X[X.length - 2 - (e || 0)];
            }
        };
    }
    (function() {
        function e(e, n) {
            e.DEFMETHOD("_codegen", n);
        }
        var s = false;
        qe.DEFMETHOD("print", function(e, n) {
            var t = this;
            e.push_node(t);
            if (n || t.needs_parens(e)) {
                e.with_parens(i);
            } else {
                i();
            }
            e.pop_node();
            function i() {
                e.prepend_comments(t);
                t.add_source_map(e);
                t._codegen(e);
                e.append_comments(t);
            }
        });
        qe.DEFMETHOD("print_to_string", function(e) {
            var n = vt(e);
            this.print(n);
            return n.get();
        });
        function t(e, n) {
            if (Array.isArray(e)) {
                e.forEach(function(e) {
                    t(e, n);
                });
            } else {
                e.DEFMETHOD("needs_parens", n);
            }
        }
        t(qe, Ee);
        t(en, function(e) {
            if (!e.has_parens() && $e(e)) return true;
            if (e.option("webkit")) {
                var n = e.parent();
                if (n instanceof Tn && n.expression === this) return true;
            }
            if (e.option("wrap_iife")) {
                var n = e.parent();
                if (n instanceof kn && n.expression === this) return true;
            }
        });
        t(Fn, function(e) {
            return !e.has_parens() && $e(e);
        });
        t(An, function(e) {
            var n = e.parent();
            return (n instanceof kn || n instanceof Tn) && n.expression === this;
        });
        t(Sn, function(e) {
            var n = e.parent();
            return n instanceof Cn || n instanceof qn || n instanceof kn || n instanceof jn || n instanceof Pn || n instanceof Tn && n.expression === this || n instanceof An || n instanceof xn;
        });
        t(qn, function(e) {
            var n = e.parent();
            if (n instanceof qn) {
                var t = n.operator, i = lt[t];
                var r = this.operator, o = lt[r];
                return i > o || i == o && this === n.right;
            }
            if (n instanceof kn) return n.expression === this;
            if (n instanceof Tn) return n.expression === this;
            if (n instanceof An) return true;
        });
        t(Tn, function(e) {
            var n = this;
            var t = e.parent();
            if (t instanceof En && t.expression === n) {
                do {
                    n = n.expression;
                } while (n instanceof Tn);
                return n.TYPE == "Call";
            }
        });
        t(kn, function(e) {
            var n = e.parent();
            if (n instanceof En) return n.expression === this;
            if (e.option("webkit")) {
                var t = e.parent(1);
                return this.expression instanceof en && n instanceof Tn && n.expression === this && t instanceof Mn && t.left === n;
            }
        });
        t(En, function(e) {
            if (v(this, e)) return false;
            var n = e.parent();
            if (n instanceof kn) return n.expression === this;
            return n instanceof Tn;
        });
        t(Qn, function(e) {
            var n = e.parent();
            if (n instanceof Tn && n.expression === this) {
                var t = this.value;
                return t < 0 || /^0/.test(m(t));
            }
        });
        t([ Mn, jn ], function(e) {
            var n = e.parent();
            if (n instanceof qn) return !(n instanceof Mn);
            if (n instanceof kn) return n.expression === this;
            if (n instanceof jn) return n.condition === this;
            if (n instanceof Tn) return n.expression === this;
            if (n instanceof An) return true;
        });
        e(Ce, function(e) {
            var n = this.quote;
            var t = this.value;
            switch (e.option("quote_style")) {
              case 0:
              case 2:
                if (t.indexOf('"') == -1) n = '"';
                break;

              case 1:
                if (t.indexOf("'") == -1) n = "'";
                break;
            }
            e.print(n + t + n);
            e.semicolon();
        });
        e(Me, function(e) {
            e.print("debugger");
            e.semicolon();
        });
        function i(e, t, i, n) {
            var r = e.length - 1;
            var o = n;
            var a = s;
            e.forEach(function(e, n) {
                if (o) {
                    if (e instanceof Ce) {
                        if (e.value == "use asm") s = true;
                    } else if (!(e instanceof Fe)) {
                        if (e instanceof Pe && e.body instanceof Kn) {
                            i.force_semicolon();
                        }
                        o = false;
                    }
                }
                if (e instanceof Fe) return;
                i.indent();
                e.print(i);
                if (n == r && t) return;
                i.newline();
                if (t) i.newline();
            });
            s = a;
        }
        e(je, function(e) {
            this.body.print(e);
            e.semicolon();
        });
        e(Ke, function(e) {
            i(this.body, true, e, true);
            e.print("");
        });
        e(Ue, function(e) {
            this.label.print(e);
            e.colon();
            this.body.print(e);
        });
        e(Pe, function(e) {
            this.body.print(e);
            e.semicolon();
        });
        function r(e, n) {
            n.print("{");
            n.with_indent(n.next_indent(), function() {
                n.append_comments(e, true);
            });
            n.print("}");
        }
        function o(e, n, t) {
            if (e.body.length > 0) {
                n.with_block(function() {
                    i(e.body, false, n, t);
                });
            } else r(e, n);
        }
        e(Re, function(e) {
            o(this, e);
        });
        e(Fe, function(e) {
            e.semicolon();
        });
        e(Le, function(e) {
            var n = this;
            e.print("do");
            e.space();
            g(n.body, e);
            e.space();
            e.print("while");
            e.space();
            e.with_parens(function() {
                n.condition.print(e);
            });
            e.semicolon();
        });
        e(Ve, function(e) {
            var n = this;
            e.print("while");
            e.space();
            e.with_parens(function() {
                n.condition.print(e);
            });
            e.space();
            h(n.body, e);
        });
        e(We, function(e) {
            var n = this;
            e.print("for");
            e.space();
            e.with_parens(function() {
                if (n.init) {
                    if (n.init instanceof gn) {
                        n.init.print(e);
                    } else {
                        c(n.init, e, true);
                    }
                    e.print(";");
                    e.space();
                } else {
                    e.print(";");
                }
                if (n.condition) {
                    n.condition.print(e);
                    e.print(";");
                    e.space();
                } else {
                    e.print(";");
                }
                if (n.step) {
                    n.step.print(e);
                }
            });
            e.space();
            h(n.body, e);
        });
        e(Je, function(e) {
            var n = this;
            e.print("for");
            e.space();
            e.with_parens(function() {
                n.init.print(e);
                e.space();
                e.print("in");
                e.space();
                n.object.print(e);
            });
            e.space();
            h(n.body, e);
        });
        e(Ge, function(e) {
            var n = this;
            e.print("with");
            e.space();
            e.with_parens(function() {
                n.expression.print(e);
            });
            e.space();
            h(n.body, e);
        });
        e(Qe, function(t, e) {
            var n = this;
            if (!e) {
                t.print("function");
            }
            if (n.name) {
                t.space();
                n.name.print(t);
            }
            t.with_parens(function() {
                n.argnames.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
            });
            t.space();
            o(n, t, true);
        });
        function n(t, i) {
            return function(e) {
                e.print(t);
                var n = this[i];
                if (n) {
                    e.space();
                    n.print(e);
                }
                e.semicolon();
            };
        }
        e(on, n("return", "value"));
        e(an, n("throw", "value"));
        e(fn, n("break", "label"));
        e(un, n("continue", "label"));
        function a(e, n) {
            var t = e.body;
            if (n.option("braces") && !(t instanceof bn || t instanceof yn) || n.option("ie8") && t instanceof Le) return g(t, n);
            if (!t) return n.force_semicolon();
            while (true) {
                if (t instanceof cn) {
                    if (!t.alternative) {
                        g(e.body, n);
                        return;
                    }
                    t = t.alternative;
                } else if (t instanceof y) {
                    t = t.body;
                } else break;
            }
            h(e.body, n);
        }
        e(cn, function(e) {
            var n = this;
            e.print("if");
            e.space();
            e.with_parens(function() {
                n.condition.print(e);
            });
            e.space();
            if (n.alternative) {
                a(n, e);
                e.space();
                e.print("else");
                e.space();
                if (n.alternative instanceof cn) n.alternative.print(e); else h(n.alternative, e);
            } else {
                h(n.body, e);
            }
        });
        e(ln, function(t) {
            var e = this;
            t.print("switch");
            t.space();
            t.with_parens(function() {
                e.expression.print(t);
            });
            t.space();
            var i = e.body.length - 1;
            if (i < 0) r(e, t); else t.with_block(function() {
                e.body.forEach(function(e, n) {
                    t.indent(true);
                    e.print(t);
                    if (n < i && e.body.length > 0) t.newline();
                });
            });
        });
        function f(e, n) {
            n.newline();
            e.body.forEach(function(e) {
                n.indent();
                e.print(n);
                n.newline();
            });
        }
        e(dn, function(e) {
            e.print("default:");
            f(this, e);
        });
        e(hn, function(e) {
            var n = this;
            e.print("case");
            e.space();
            n.expression.print(e);
            e.print(":");
            f(n, e);
        });
        e(vn, function(e) {
            var n = this;
            e.print("try");
            e.space();
            o(n, e);
            if (n.bcatch) {
                e.space();
                n.bcatch.print(e);
            }
            if (n.bfinally) {
                e.space();
                n.bfinally.print(e);
            }
        });
        e(_n, function(e) {
            var n = this;
            e.print("catch");
            if (n.argname) {
                e.space();
                e.with_parens(function() {
                    n.argname.print(e);
                });
            }
            e.space();
            o(n, e);
        });
        e(mn, function(e) {
            e.print("finally");
            e.space();
            o(this, e);
        });
        function u(i) {
            return function(t) {
                var e = this;
                t.print(i);
                t.space();
                e.definitions.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
                var n = t.parent();
                if (n && n.init !== e || !(n instanceof We || n instanceof Je)) t.semicolon();
            };
        }
        e(bn, u("const"));
        e(yn, u("let"));
        e(wn, u("var"));
        function c(e, n, t) {
            var i = false;
            if (t) e.walk(new ft(function(e) {
                if (i || e instanceof Xe) return true;
                if (e instanceof qn && e.operator == "in") {
                    i = true;
                    return true;
                }
            }));
            e.print(n, i);
        }
        e(xn, function(e) {
            var n = this;
            n.name.print(e);
            if (n.value) {
                e.space();
                e.print("=");
                e.space();
                var t = e.parent(1);
                var i = t instanceof We || t instanceof Je;
                c(n.value, e, i);
            }
        });
        function l(e, t) {
            if (e.expression instanceof kn || e.expression instanceof Qe) {
                t.add_mapping(e.start);
            }
            t.with_parens(function() {
                e.args.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
            });
        }
        e(kn, function(e) {
            this.expression.print(e);
            l(this, e);
        });
        e(En, function(e) {
            var n = this;
            e.print("new");
            e.space();
            n.expression.print(e);
            if (v(n, e)) l(n, e);
        });
        e(Sn, function(t) {
            this.expressions.forEach(function(e, n) {
                if (n > 0) {
                    t.comma();
                    if (t.should_break()) {
                        t.newline();
                        t.indent();
                    }
                }
                e.print(t);
            });
        });
        e(On, function(e) {
            var n = this;
            var t = n.expression;
            t.print(e);
            var i = n.property;
            if (e.option("ie8") && w[i]) {
                e.print("[");
                e.add_mapping(n.end);
                e.print_string(i);
                e.print("]");
            } else {
                if (t instanceof Qn && t.value >= 0) {
                    if (!/[xa-f.)]/i.test(e.last())) {
                        e.print(".");
                    }
                }
                e.print(".");
                e.add_mapping(n.end);
                e.print_name(i);
            }
        });
        e(Dn, function(e) {
            this.expression.print(e);
            e.print("[");
            this.property.print(e);
            e.print("]");
        });
        e(zn, function(e) {
            var n = this.operator;
            var t = this.expression;
            e.print(n);
            if (/^[a-z]/i.test(n) || /[+-]$/.test(n) && t instanceof zn && /^[+-]/.test(t.operator)) {
                e.space();
            }
            t.print(e);
        });
        e($n, function(e) {
            this.expression.print(e);
            e.print(this.operator);
        });
        e(qn, function(e) {
            var n = this;
            n.left.print(e);
            e.space();
            e.print(n.operator);
            e.space();
            n.right.print(e);
        });
        e(jn, function(e) {
            var n = this;
            n.condition.print(e);
            e.space();
            e.print("?");
            e.space();
            n.consequent.print(e);
            e.space();
            e.colon();
            n.alternative.print(e);
        });
        e(Cn, function(t) {
            var e = this.elements, i = e.length;
            t.with_square(i > 0 ? function() {
                t.space();
                e.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                    if (n === i - 1 && e instanceof it) t.comma();
                });
                t.space();
            } : ae);
        });
        e(Fn, function(t) {
            var e = this.properties;
            if (e.length > 0) t.with_block(function() {
                e.forEach(function(e, n) {
                    if (n) {
                        t.print(",");
                        t.newline();
                    }
                    t.indent();
                    e.print(t);
                });
                t.newline();
            }); else r(this, t);
        });
        function p(e, n, t) {
            if (t.option("quote_keys")) {
                t.print_string(e);
            } else if ("" + +e == e && e >= 0) {
                t.print(m(e));
            } else if (w[e] ? !t.option("ie8") : ut(e)) {
                if (n && t.option("keep_quoted_props")) {
                    t.print_string(e, n);
                } else {
                    t.print_name(e);
                }
            } else {
                t.print_string(e, n);
            }
        }
        e(Nn, function(e) {
            var n = this;
            p(n.key, n.quote, e);
            e.colon();
            n.value.print(e);
        });
        function d(t) {
            return function(e) {
                var n = this;
                e.print(t);
                e.space();
                p(n.key.name, n.quote, e);
                n.value._codegen(e, true);
            };
        }
        e(pe, d("get"));
        e(le, d("set"));
        e(Hn, function(e) {
            var n = this.definition();
            e.print_name(n && n.mangled_name || this.name);
        });
        e(it, ae);
        e(Gn, function(e) {
            e.print("this");
        });
        e(Xn, function(e) {
            e.print(this.value);
        });
        e(Kn, function(e) {
            e.print_string(this.value, this.quote);
        });
        e(Qn, function(e) {
            var n = this.start;
            if (s && n && n.raw != null) {
                e.print(n.raw);
            } else {
                e.print(m(this.value));
            }
        });
        e(Zn, function(e) {
            var n = this.value;
            var t = n.toString();
            var i = t.lastIndexOf("/");
            if (n.raw_source) {
                t = "/" + n.raw_source + t.slice(i);
            } else if (i == 1) {
                t = "/(?:)" + t.slice(i);
            } else if (t.indexOf("/", 1) < i) {
                t = "/" + t.slice(1, i).replace(/\\\\|[^/]?\//g, function(e) {
                    return e[0] == "\\" ? e : e.slice(0, -1) + "\\/";
                }) + t.slice(i);
            }
            e.print(e.to_utf8(t).replace(/\\(?:\0(?![0-9])|[^\0])/g, function(e) {
                switch (e[1]) {
                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\t":
                    return "\t";

                  case "\b":
                    return "\b";

                  case "\f":
                    return "\f";

                  case "\0":
                    return "\0";

                  case "\v":
                    return "\v";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";

                  default:
                    return e;
                }
            }).replace(/[\n\r\u2028\u2029]/g, function(e) {
                switch (e) {
                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";
                }
            }));
            var r = e.parent();
            if (r instanceof qn && /^in/.test(r.operator) && r.left === this) e.print(" ");
        });
        function h(e, n) {
            if (n.option("braces") && !(e instanceof bn || e instanceof yn)) {
                g(e, n);
            } else if (!e || e instanceof Fe) {
                n.force_semicolon();
            } else {
                e.print(n);
            }
        }
        function v(e, n) {
            if (e.args.length > 0) return true;
            return n.option("beautify");
        }
        function _(e) {
            var n = e[0], t = n.length;
            for (var i = 1; i < e.length; ++i) {
                if (e[i].length < t) {
                    n = e[i];
                    t = n.length;
                }
            }
            return n;
        }
        function m(e) {
            var n = e.toString(10).replace(/^0\./, ".").replace("e+", "e");
            var t = [ n ];
            if (Math.floor(e) === e) {
                if (e < 0) {
                    t.push("-0x" + (-e).toString(16).toLowerCase());
                } else {
                    t.push("0x" + e.toString(16).toLowerCase());
                }
            }
            var i, r, o;
            if (i = /^\.0+/.exec(n)) {
                r = i[0].length;
                o = n.slice(r);
                t.push(o + "e-" + (o.length + r - 1));
            } else if (i = /0+$/.exec(n)) {
                r = i[0].length;
                t.push(n.slice(0, -r) + "e" + r);
            } else if (i = /^(\d)\.(\d+)e(-?\d+)$/.exec(n)) {
                t.push(i[1] + i[2] + "e" + (i[3] - i[2].length));
            }
            return _(t);
        }
        function g(e, n) {
            if (!e || e instanceof Fe) n.print("{}"); else if (e instanceof Re) e.print(n); else n.with_block(function() {
                n.indent();
                e.print(n);
                n.newline();
            });
        }
        function b(e, n) {
            e.forEach(function(e) {
                e.DEFMETHOD("add_source_map", n);
            });
        }
        b([ qe, Ue ], ae);
        b([ Cn, Re, _n, Xn, Me, gn, mn, tn, Qe, En, Fn, y, Hn, ln, pn, vn ], function(e) {
            e.add_mapping(this.start);
        });
        b([ pe, le ], function(e) {
            e.add_mapping(this.start, this.key.name);
        });
        b([ Pn ], function(e) {
            e.add_mapping(this.start, this.key);
        });
    })();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function _t(e, n) {
        if (!(this instanceof _t)) return new _t(e, n);
        ht.call(this, this.before, this.after);
        this.options = re(e, {
            arguments: !n,
            assignments: !n,
            booleans: !n,
            collapse_vars: !n,
            comparisons: !n,
            conditionals: !n,
            dead_code: !n,
            directives: !n,
            drop_console: false,
            drop_debugger: !n,
            evaluate: !n,
            expression: false,
            functions: !n,
            global_defs: false,
            hoist_funs: false,
            hoist_props: !n,
            hoist_vars: false,
            ie8: false,
            if_return: !n,
            inline: !n,
            join_vars: !n,
            keep_fargs: n || "strict",
            keep_fnames: false,
            keep_infinity: false,
            loops: !n,
            merge_vars: !n,
            negate_iife: !n,
            objects: !n,
            passes: 1,
            properties: !n,
            pure_getters: !n && "strict",
            pure_funcs: null,
            reduce_funcs: !n,
            reduce_vars: !n,
            sequences: !n,
            side_effects: !n,
            strings: !n,
            switches: !n,
            top_retain: null,
            toplevel: !!(e && e["top_retain"]),
            typeofs: !n,
            unsafe: false,
            unsafe_comps: false,
            unsafe_Function: false,
            unsafe_math: false,
            unsafe_proto: false,
            unsafe_regexp: false,
            unsafe_undefined: false,
            unused: !n,
            varify: !n
        }, true);
        var t = this.options["evaluate"];
        this.eval_threshold = /eager/.test(t) ? 1 / 0 : +t;
        var i = this.options["global_defs"];
        if (typeof i == "object") for (var r in i) {
            if (/^@/.test(r) && ze(i, r)) {
                i[r.slice(1)] = dt(i[r], {
                    expression: true
                });
            }
        }
        if (this.options["inline"] === true) this.options["inline"] = 3;
        var o = this.options["keep_fargs"];
        this.drop_fargs = o == "strict" ? function(e, n) {
            if (e.length_read) return false;
            var t = e.name;
            if (!t) return n && n.TYPE == "Call" && n.expression === e;
            if (t.fixed_value() !== e) return false;
            var i = t.definition();
            if (i.direct_access) return false;
            var r = i.escaped;
            return r && r.depth != 1;
        } : o ? Ee : se;
        var a = this.options["pure_funcs"];
        if (typeof a == "function") {
            this.pure_funcs = a;
        } else if (typeof a == "string") {
            this.pure_funcs = function(e) {
                return a !== e.expression.print_to_string();
            };
        } else if (Array.isArray(a)) {
            this.pure_funcs = function(e) {
                return !ke(e.expression.print_to_string(), a);
            };
        } else {
            this.pure_funcs = se;
        }
        var s = this.options["sequences"];
        this.sequences_limit = s == 1 ? 800 : s | 0;
        var f = this.options["top_retain"];
        if (f instanceof RegExp) {
            this.top_retain = function(e) {
                return f.test(e.name);
            };
        } else if (typeof f == "function") {
            this.top_retain = f;
        } else if (f) {
            if (typeof f == "string") {
                f = f.split(/,/);
            }
            this.top_retain = function(e) {
                return ke(e.name, f);
            };
        }
        var u = this.options["toplevel"];
        this.toplevel = typeof u == "string" ? {
            funcs: /funcs/.test(u),
            vars: /vars/.test(u)
        } : {
            funcs: u,
            vars: u
        };
    }
    _t.prototype = new ht();
    t(_t.prototype, {
        option: function(e) {
            return this.options[e];
        },
        exposed: function(e) {
            if (e.undeclared) return true;
            if (!(e.global || e.scope.resolve() instanceof Ke)) return false;
            var n = this.toplevel;
            return !De(e.orig, function(e) {
                return n[e instanceof Ln ? "funcs" : "vars"];
            });
        },
        compress: function(e) {
            e = e.resolve_defines(this);
            if (this.option("expression")) {
                e.process_expression(true);
            }
            var n = +this.options.passes || 1;
            var t = 1 / 0;
            var i = false;
            var r = {
                ie8: this.option("ie8")
            };
            for (var o = 0; o < n; o++) {
                e.figure_out_scope(r);
                if (o > 0 || this.option("reduce_vars")) e.reset_opt_flags(this);
                e = e.transform(this);
                if (n > 1) {
                    var a = 0;
                    e.walk(new ft(function() {
                        a++;
                    }));
                    qe.info("pass " + o + ": last_count: " + t + ", count: " + a);
                    if (a < t) {
                        t = a;
                        i = false;
                    } else if (i) {
                        break;
                    } else {
                        i = true;
                    }
                }
            }
            if (this.option("expression")) {
                e.process_expression(false);
            }
            return e;
        },
        before: function(e, n, t) {
            if (e._squeezed) return e;
            var i = e instanceof Xe;
            if (i) {
                e.hoist_properties(this);
                e.hoist_declarations(this);
                e.process_boolean_returns(this);
            }
            n(e, this);
            n(e, this);
            var r = e.optimize(this);
            if (i && r === e && !this.has_directive("use asm") && !r.pinned()) {
                r.merge_variables(this);
                r.drop_unused(this);
                n(r, this);
            }
            if (r === e) r._squeezed = true;
            return r;
        }
    });
    (function(e) {
        e(qe, function(e, n) {
            return e;
        });
        qe.DEFMETHOD("equivalent_to", function(e) {
            return this.TYPE == e.TYPE && this.print_to_string() == e.print_to_string();
        });
        Xe.DEFMETHOD("process_expression", function(t, i) {
            var r = this;
            var o = new ht(function(e) {
                if (t && e instanceof Pe) {
                    return he(on, e, {
                        value: e.body
                    });
                }
                if (!t && e instanceof on) {
                    return i ? i(e) : he(Pe, e, {
                        body: e.value || he(zn, e, {
                            operator: "void",
                            expression: he(Qn, e, {
                                value: 0
                            })
                        })
                    });
                }
                if (e instanceof Qe && e !== r) {
                    return e;
                }
                if (e instanceof Ie) {
                    var n = e.body.length - 1;
                    if (n >= 0) {
                        e.body[n] = e.body[n].transform(o);
                    }
                } else if (e instanceof cn) {
                    e.body = e.body.transform(o);
                    if (e.alternative) {
                        e.alternative = e.alternative.transform(o);
                    }
                } else if (e instanceof Ge) {
                    e.body = e.body.transform(o);
                }
                return e;
            });
            r.transform(o);
        });
        function E(e, n) {
            var t = n.getProperty();
            if (t instanceof qe) return;
            var i;
            if (e instanceof Cn) {
                var r = e.elements;
                if (t == "length") return S(r.length, e);
                if (typeof t == "number" && t in r) i = r[t];
            } else if (e instanceof Qe) {
                if (t == "length") {
                    e.length_read = true;
                    return S(e.argnames.length, e);
                }
            } else if (e instanceof Fn) {
                t = "" + t;
                var o = e.properties;
                for (var a = o.length; --a >= 0; ) {
                    var s = o[a];
                    if (!(s instanceof Nn)) return;
                    if (!i && o[a].key === t) i = o[a].value;
                }
            }
            return i instanceof Jn && i.fixed_value() || i;
        }
        function l(e, n) {
            if (e instanceof ot) return g.Boolean[n];
            if (e instanceof Qn) return g.Number[n];
            if (e instanceof Kn) return g.String[n];
            if (n == "valueOf") return false;
            if (e instanceof Cn) return g.Array[n];
            if (e instanceof en) return g.Function[n];
            if (e instanceof Fn) return g.Object[n];
            if (e instanceof Zn) return g.RegExp[n] && !e.value.global;
        }
        function le(e, n, t, i, r, o, a) {
            var s = n.parent(r);
            if (e.option("unsafe") && s instanceof On && l(i, s.property)) {
                return;
            }
            var f = ye(t, s);
            if (f) return f;
            if (s instanceof Cn) return le(e, n, s, s, r + 1);
            if (s instanceof kn) {
                return !o && s.expression === t && !s.is_expr_pure(e) && (!(i instanceof en) || !(s instanceof En) && i.contains_this());
            }
            if (s instanceof Je) return s.init === t;
            if (s instanceof Nn) {
                if (s.value !== t) return;
                var u = n.parent(r + 1);
                return le(e, n, u, u, r + 2);
            }
            if (s instanceof Tn) {
                if (s.expression !== t) return;
                var c = E(i, s);
                return (!o || a) && le(e, n, s, c, r + 1);
            }
        }
        function pe(e) {
            if (e.name != "arguments") return false;
            var n = e.orig;
            return n.length == 1 && n[0] instanceof Yn;
        }
        function R(e, n) {
            do {
                if (e === n) return false;
                if (n instanceof Xe) return true;
            } while (n = n.parent_scope);
        }
        (function(e) {
            e(qe, ae);
            function o(e, n, t) {
                t.assignments = 0;
                t.bool_fn = 0;
                t.cross_loop = false;
                t.direct_access = false;
                t.escaped = [];
                t.fixed = !t.const_redefs && !t.scope.pinned() && !n.exposed(t) && !(t.init instanceof en && t.init !== t.scope) && t.init;
                if (t.fixed instanceof nn && !De(t.references, function(e) {
                    var n = e.scope.resolve();
                    do {
                        if (t.scope === n) return true;
                    } while (n instanceof en && (n = n.parent_scope.resolve()));
                })) {
                    e.defun_ids[t.id] = false;
                }
                t.recursive_refs = 0;
                t.references = [];
                t.should_replace = undefined;
                t.single_use = undefined;
            }
            function f(n, t, e) {
                e.variables.each(function(e) {
                    o(n, t, e);
                    if (e.fixed === null) {
                        e.safe_ids = n.safe_ids;
                        d(n, e);
                    } else if (e.fixed) {
                        n.loop_ids[e.id] = n.in_loop;
                        d(n, e);
                    }
                });
                e.may_call_this = function() {
                    e.may_call_this = ae;
                    if (!e.contains_this()) return;
                    e.functions.each(function(e) {
                        if (e.init instanceof nn && !(e.id in n.defun_ids)) {
                            n.defun_ids[e.id] = false;
                        }
                    });
                };
                if (t.option("ie8")) e.variables.each(function(e) {
                    var n = e.orig[0].definition();
                    if (n !== e) n.fixed = false;
                });
            }
            function u(n, t) {
                if (t.id in n.defun_ids) {
                    var e = n.defun_ids[t.id];
                    if (!e) return;
                    var i = n.defun_visited[t.id];
                    if (e === n.safe_ids) {
                        if (!i) return t.fixed;
                    } else if (i) {
                        t.init.enclosed.forEach(function(e) {
                            if (t.init.variables.get(e.name) === e) return;
                            if (!v(n, e)) e.fixed = false;
                        });
                    } else {
                        n.defun_ids[t.id] = false;
                    }
                } else {
                    if (!n.in_loop) {
                        n.defun_ids[t.id] = n.safe_ids;
                        return t.fixed;
                    }
                    n.defun_ids[t.id] = false;
                }
            }
            function c(n, e) {
                e.functions.each(function(e) {
                    if (e.init instanceof nn && !n.defun_visited[e.id]) {
                        n.defun_ids[e.id] = n.safe_ids;
                        e.init.walk(n);
                    }
                });
            }
            function l(e) {
                e.safe_ids = Object.create(e.safe_ids);
            }
            function p(e) {
                e.safe_ids = Object.getPrototypeOf(e.safe_ids);
            }
            function d(e, n) {
                e.safe_ids[n.id] = {};
            }
            function h(e, n) {
                e.references.push(n);
                e.last_ref = n;
            }
            function v(e, n) {
                if (n.single_use == "m") return false;
                var t = e.safe_ids[n.id];
                if (t) {
                    if (!ze(e.safe_ids, n.id)) t.read = t.read && t.read !== e.safe_ids ? true : e.safe_ids;
                    if (n.fixed == null) {
                        if (pe(n)) return false;
                        if (n.global && n.name == "arguments") return false;
                        e.loop_ids[n.id] = null;
                        n.fixed = he(tt, n.orig[0]);
                        return true;
                    }
                    return !t.assign || t.assign === e.safe_ids;
                }
                return n.fixed instanceof nn;
            }
            function _(e, n, t) {
                if (!(t || De(n.orig, function(e) {
                    return !(e instanceof Rn);
                }))) return false;
                if (n.fixed === undefined) return t || De(n.orig, function(e) {
                    return !(e instanceof Un);
                });
                if (n.fixed === null && n.safe_ids) {
                    n.safe_ids[n.id] = false;
                    delete n.safe_ids;
                    return true;
                }
                if (n.fixed === false) return false;
                var i = e.safe_ids[n.id];
                if (!ze(e.safe_ids, n.id)) {
                    if (!i) return false;
                    if (i.read && n.scope !== e.find_parent(Xe)) return false;
                    i.assign = i.assign && i.assign !== e.safe_ids ? true : e.safe_ids;
                }
                if (n.fixed != null && i.read) {
                    if (i.read !== e.safe_ids) return false;
                    if (e.loop_ids[n.id] !== e.in_loop) return false;
                }
                return v(e, n) && De(n.orig, function(e) {
                    return !(e instanceof Vn);
                });
            }
            function m(e, n) {
                var t = he(Jn, e, e);
                t.fixed = n || he(tt, e);
                return t;
            }
            function g(e, n) {
                return e.option("unused") && !n.scope.pinned() && n.single_use !== false && n.references.length - n.recursive_refs == 1;
            }
            function b(e) {
                if (!e) return false;
                return e.is_constant() || e instanceof Qe || e instanceof Gn;
            }
            function y(e, n, t) {
                if (t instanceof Mn) return t.operator == "=" && t.right === n;
                if (t instanceof kn) return t.expression !== n || t instanceof En;
                if (t instanceof rn) return t.value === n && n.scope !== e.scope;
                if (t instanceof xn) return t.value === n;
            }
            function w(e, n) {
                if (n instanceof Cn) return true;
                if (n instanceof qn) return ge[n.operator];
                if (n instanceof jn) return n.condition !== e;
                if (n instanceof Sn) return n.tail_node() === e;
            }
            function x(e, n, t, i, r, o, a) {
                var s = e.parent(o);
                if (r && r.is_constant()) return;
                if (y(n, i, s)) {
                    n.escaped.push(s);
                    if (a > 1 && !(r && r.is_constant_expression(t))) a = 1;
                    if (!n.escaped.depth || n.escaped.depth > a) n.escaped.depth = a;
                    return;
                } else if (w(i, s)) {
                    x(e, n, t, s, s, o + 1, a);
                } else if (s instanceof Nn && s.value === i) {
                    var f = e.parent(o + 1);
                    x(e, n, t, f, f, o + 2, a);
                } else if (s instanceof Tn && s.expression === i) {
                    r = E(r, s);
                    x(e, n, t, s, r, o + 1, a + 1);
                    if (r) return;
                }
                if (o > 0) return;
                if (s instanceof kn && s.expression === i) return;
                if (s instanceof Sn && s.tail_node() !== i) return;
                if (s instanceof Pe) return;
                if (s instanceof An && !T[s.operator]) return;
                n.direct_access = true;
            }
            function k(e) {
                if (!(e instanceof Dn)) return;
                var n = e.expression;
                if (!(n instanceof Jn)) return;
                var t = n.definition();
                if (pe(t) && e.property instanceof Qn) t.reassigned = true;
            }
            e(Ze, function(e, n, t) {
                l(e);
                f(e, t, this);
                n();
                p(e);
                c(e, this);
                return true;
            });
            e(Mn, function(t, e, n) {
                var i = this;
                var r = i.operator == "=";
                var o = i.left;
                if (r && o.equivalent_to(i.right) && !o.has_side_effects(n)) {
                    i.right.walk(t);
                    c(o);
                    i.__drop = true;
                    return true;
                }
                if (!(o instanceof Jn)) {
                    k(o);
                    return;
                }
                var a = o.definition();
                a.assignments++;
                var s = a.fixed;
                var f = r ? i.right : i;
                if (le(n, t, i, f, 0)) {
                    a.fixed = false;
                    return;
                }
                var u = r || v(t, a);
                i.right.walk(t);
                if (u && _(t, a)) {
                    h(a, o);
                    d(t, a);
                    if (r) {
                        t.loop_ids[a.id] = t.in_loop;
                        x(t, a, o.scope, i, f, 0, 1);
                        o.fixed = a.fixed = function() {
                            return i.right;
                        };
                    } else {
                        if (a.single_use) a.single_use = false;
                        o.fixed = a.fixed = function() {
                            return he(qn, i, {
                                operator: i.operator.slice(0, -1),
                                left: m(o, s),
                                right: i.right
                            });
                        };
                    }
                    o.fixed.assigns = r || !s || !s.assigns ? [] : s.assigns.slice();
                    o.fixed.assigns.push(i);
                } else {
                    o.walk(t);
                    a.fixed = false;
                }
                return true;
                function c(e) {
                    if (e instanceof On) {
                        c(e.expression);
                    } else if (e instanceof Dn) {
                        c(e.expression);
                        e.property.walk(t);
                    } else if (e instanceof Jn) {
                        var n = e.definition();
                        h(n, e);
                        e.fixed = n.fixed;
                    } else {
                        e.walk(t);
                    }
                }
            });
            e(qn, function(e) {
                if (!ge[this.operator]) return;
                this.left.walk(e);
                l(e);
                this.right.walk(e);
                p(e);
                return true;
            });
            e(Ne, function(n, e, t) {
                this.variables.each(function(e) {
                    o(n, t, e);
                });
            });
            e(kn, function(n, e) {
                n.find_parent(Xe).may_call_this();
                var t = this.expression;
                if (t instanceof en) {
                    this.args.forEach(function(e) {
                        e.walk(n);
                    });
                    t.walk(n);
                    return true;
                } else if (t instanceof Jn) {
                    var i = t.definition();
                    if (this.TYPE == "Call" && n.in_boolean_context()) i.bool_fn++;
                    if (!(i.fixed instanceof nn)) return;
                    var r = u(n, i);
                    if (!r) return;
                    e();
                    r.walk(n);
                    return true;
                } else if (this.TYPE == "Call" && t instanceof Mn && t.operator == "=" && t.left instanceof Jn && n.in_boolean_context()) {
                    t.left.definition().bool_fn++;
                }
            });
            e(jn, function(e) {
                this.condition.walk(e);
                l(e);
                this.consequent.walk(e);
                p(e);
                l(e);
                this.alternative.walk(e);
                p(e);
                return true;
            });
            e(nn, function(e, n, t) {
                var i = this.name.definition().id;
                if (e.defun_visited[i]) return true;
                if (e.defun_ids[i] !== e.safe_ids) return true;
                e.defun_visited[i] = true;
                this.inlined = false;
                l(e);
                f(e, t, this);
                n();
                p(e);
                c(e, this);
                return true;
            });
            e(Le, function(e) {
                var n = e.in_loop;
                e.in_loop = this;
                l(e);
                this.body.walk(e);
                if (O(this, e.parent())) {
                    p(e);
                    l(e);
                }
                this.condition.walk(e);
                p(e);
                e.in_loop = n;
                return true;
            });
            e(We, function(n, e, t) {
                this.variables.each(function(e) {
                    o(n, t, e);
                });
                if (this.init) this.init.walk(n);
                var i = n.in_loop;
                n.in_loop = this;
                l(n);
                if (this.condition) this.condition.walk(n);
                this.body.walk(n);
                if (this.step) {
                    if (O(this, n.parent())) {
                        p(n);
                        l(n);
                    }
                    this.step.walk(n);
                }
                p(n);
                n.in_loop = i;
                return true;
            });
            e(Je, function(n, e, t) {
                this.variables.each(function(e) {
                    o(n, t, e);
                });
                this.object.walk(n);
                var i = n.in_loop;
                n.in_loop = this;
                l(n);
                var r = this.init;
                r.walk(n);
                if (r instanceof Jn) {
                    r.definition().fixed = false;
                } else if (r instanceof wn) {
                    r.definitions[0].name.definition().fixed = false;
                }
                this.body.walk(n);
                p(n);
                n.in_loop = i;
                return true;
            });
            e(en, function(r, e, n) {
                var o = this;
                o.inlined = false;
                var a;
                if (!o.name && (a = r.parent()) instanceof kn && a.expression === o) {
                    var t = false;
                    var i = false;
                    o.walk(new ft(function(e) {
                        if (t) return i = true;
                        if (e instanceof on) return t = true;
                        if (e instanceof Xe && e !== o) return true;
                    }));
                    if (i) l(r);
                    f(r, n, o);
                    o.argnames.forEach(function(n, e) {
                        var t = n.definition();
                        if (t.fixed === undefined && (!o.uses_arguments || r.has_directive("use strict"))) {
                            d(r, t);
                            r.loop_ids[t.id] = r.in_loop;
                            var i = a.args[e];
                            t.fixed = function() {
                                var e = o.argnames.indexOf(n);
                                return (e < 0 ? i : a.args[e]) || he(tt, a);
                            };
                            t.fixed.assigns = [ n ];
                        } else {
                            t.fixed = false;
                        }
                    });
                    e();
                    var s = r.safe_ids;
                    p(r);
                    c(r, o);
                    if (!i) r.safe_ids = s;
                } else {
                    l(r);
                    f(r, n, o);
                    e();
                    p(r);
                    c(r, o);
                }
                return true;
            });
            e(cn, function(e) {
                this.condition.walk(e);
                l(e);
                this.body.walk(e);
                p(e);
                if (this.alternative) {
                    l(e);
                    this.alternative.walk(e);
                    p(e);
                }
                return true;
            });
            e(Ue, function(e) {
                l(e);
                this.body.walk(e);
                p(e);
                return true;
            });
            e(ln, function(n, e, t) {
                this.variables.each(function(e) {
                    o(n, t, e);
                });
                this.expression.walk(n);
                var i = true;
                this.body.forEach(function(e) {
                    if (e instanceof dn) return;
                    e.expression.walk(n);
                    if (i) {
                        i = false;
                        l(n);
                    }
                });
                if (!i) p(n);
                He(this, n);
                return true;
            });
            e(pn, function(e) {
                l(e);
                He(this, e);
                p(e);
                return true;
            });
            e(Wn, function() {
                this.definition().fixed = false;
            });
            e(Jn, function(e, n, t) {
                var i = this.definition();
                h(i, this);
                if (i.references.length == 1 && !i.fixed && i.orig[0] instanceof Ln) {
                    e.loop_ids[i.id] = e.in_loop;
                }
                if (i.fixed === false) {
                    var r = i.redefined();
                    if (r && R(i.scope, this.scope)) r.single_use = false;
                } else if (i.fixed === undefined || !v(e, i)) {
                    i.fixed = false;
                } else if (i.fixed) {
                    var o = this.fixed_value();
                    var a = xe(e, i);
                    if (a) {
                        i.recursive_refs++;
                    } else if (o && g(t, i)) {
                        i.in_loop = e.loop_ids[i.id] !== e.in_loop;
                        i.single_use = o instanceof Qe && !o.pinned() && (!i.in_loop || e.parent() instanceof kn) || !i.in_loop && i.scope === this.scope.resolve() && o.is_constant_expression();
                    } else {
                        i.single_use = false;
                    }
                    if (le(t, e, this, o, 0, b(o), a)) {
                        if (i.single_use) {
                            i.single_use = "m";
                        } else {
                            i.fixed = false;
                        }
                    }
                    if (i.fixed && e.loop_ids[i.id] !== e.in_loop) {
                        i.cross_loop = true;
                    }
                    x(e, i, this.scope, this, o, 0, 1);
                }
                this.fixed = i.fixed;
                var s;
                if (i.fixed instanceof nn && !((s = e.parent()) instanceof kn && s.expression === this)) {
                    var f = u(e, i);
                    if (f) f.walk(e);
                }
            });
            e(Ke, function(n, e, t) {
                this.globals.each(function(e) {
                    o(n, t, e);
                });
                l(n);
                f(n, t, this);
                e();
                p(n);
                c(n, this);
                return true;
            });
            e(vn, function(n, e, t) {
                this.variables.each(function(e) {
                    o(n, t, e);
                });
                l(n);
                He(this, n);
                p(n);
                if (this.bcatch) {
                    l(n);
                    this.bcatch.walk(n);
                    p(n);
                }
                if (this.bfinally) this.bfinally.walk(n);
                return true;
            });
            e(An, function(e, n) {
                var t = this;
                if (!be[t.operator]) return;
                var i = t.expression;
                if (!(i instanceof Jn)) {
                    k(i);
                    return;
                }
                var r = i.definition();
                r.assignments++;
                var o = r.fixed;
                if (v(e, r) && _(e, r)) {
                    h(r, i);
                    d(e, r);
                    if (r.single_use) r.single_use = false;
                    r.fixed = function() {
                        return he(qn, t, {
                            operator: t.operator.slice(0, -1),
                            left: he(zn, t, {
                                operator: "+",
                                expression: m(i, o)
                            }),
                            right: he(Qn, t, {
                                value: 1
                            })
                        });
                    };
                    r.fixed.assigns = o && o.assigns ? o.assigns.slice() : [];
                    r.fixed.assigns.push(t);
                    if (t instanceof zn) {
                        i.fixed = r.fixed;
                    } else {
                        i.fixed = function() {
                            return he(zn, t, {
                                operator: "+",
                                expression: m(i, o)
                            });
                        };
                        i.fixed.assigns = o && o.assigns;
                    }
                } else {
                    i.walk(e);
                    r.fixed = false;
                }
                return true;
            });
            e(xn, function(e, n) {
                var t = this;
                if (!t.value) return;
                n();
                var i = t.name.definition();
                if (_(e, i, true)) {
                    d(e, i);
                    e.loop_ids[i.id] = e.in_loop;
                    i.fixed = function() {
                        return t.value;
                    };
                    i.fixed.assigns = [ t ];
                    if (t.name instanceof Rn && i.redefined()) i.single_use = false;
                } else {
                    i.fixed = false;
                }
                return true;
            });
            e(Ve, function(e, n) {
                var t = e.in_loop;
                e.in_loop = this;
                l(e);
                n();
                p(e);
                e.in_loop = t;
                return true;
            });
        })(function(e, n) {
            e.DEFMETHOD("reduce_vars", n);
        });
        Ke.DEFMETHOD("reset_opt_flags", function(t) {
            var i = new ft(t.option("reduce_vars") ? function(e, n) {
                r(e);
                return e.reduce_vars(i, n, t);
            } : r);
            i.defun_ids = Object.create(null);
            i.defun_visited = Object.create(null);
            i.in_loop = null;
            i.loop_ids = Object.create(null);
            i.safe_ids = Object.create(null);
            this.walk(i);
            function r(e) {
                e._squeezed = false;
                e._optimized = false;
                delete e.fixed;
                if (e instanceof Xe) delete e._var_names;
            }
        });
        Hn.DEFMETHOD("fixed_value", function() {
            var e = this.definition().fixed;
            if (!e) return e;
            if (this.fixed) e = this.fixed;
            return e instanceof qe ? e : e();
        });
        Jn.DEFMETHOD("is_immutable", function() {
            var e = this.definition();
            if (e.orig.length != 1) return false;
            var n = e.orig[0];
            return n instanceof Vn && e.scope.name === n;
        });
        function L(e) {
            var n = 0, t;
            while (t = e.parent(n++)) {
                if (t.variables) return t;
            }
        }
        function de(e, n) {
            if (e instanceof Gn) return true;
            if (e instanceof Jn) {
                var t = e.definition();
                return t.lambda || n.exposed(t) && K[t.name];
            }
            if (e instanceof Tn) {
                e = e.expression;
                if (e instanceof Jn) {
                    if (e.is_immutable()) return false;
                    e = e.fixed_value();
                }
                if (!e) return true;
                if (e.is_constant()) return true;
                return de(e, n);
            }
            return false;
        }
        function he(e, n, t) {
            if (!t) t = {};
            if (n) {
                if (!t.start) t.start = n.start;
                if (!t.end) t.end = n.end;
            }
            return new e(t);
        }
        function V(e, n) {
            if (n.length == 1) return n[0];
            return he(Sn, e, {
                expressions: n.reduce(_, [])
            });
        }
        function S(e, n) {
            switch (typeof e) {
              case "string":
                return he(Kn, n, {
                    value: e
                });

              case "number":
                if (isNaN(e)) return he(nt, n);
                if (isFinite(e)) {
                    return 1 / e < 0 ? he(zn, n, {
                        operator: "-",
                        expression: he(Qn, n, {
                            value: -e
                        })
                    }) : he(Qn, n, {
                        value: e
                    });
                }
                return e < 0 ? he(zn, n, {
                    operator: "-",
                    expression: he(rt, n)
                }) : he(rt, n);

              case "boolean":
                return he(e ? st : at, n);

              case "undefined":
                return he(tt, n);

              default:
                if (e === null) {
                    return he(et, n, {
                        value: null
                    });
                }
                if (e instanceof RegExp) {
                    return he(Zn, n, {
                        value: e
                    });
                }
                throw new Error(ce("Can't handle constant of type: {type}", {
                    type: typeof e
                }));
            }
        }
        function W(e, n) {
            return n instanceof Tn || X(n) && n.name == "eval";
        }
        function ve(e, n, t, i) {
            var r = false;
            if (n.TYPE == "Call") {
                r = n.expression === t && W(e, i);
            } else if (n instanceof zn) {
                r = n.operator == "delete" || n.operator == "typeof" && X(i);
            }
            return r ? V(t, [ he(Qn, t, {
                value: 0
            }), i ]) : i;
        }
        function _(e, n) {
            if (n instanceof Sn) {
                e.push.apply(e, n.expressions);
            } else {
                e.push(n);
            }
            return e;
        }
        function D(e) {
            if (e === null) return [];
            if (e instanceof Re) return e.body;
            if (e instanceof Fe) return [];
            if (e instanceof je) return [ e ];
            throw new Error("Can't convert thing to statement array");
        }
        function J(e) {
            if (e === null) return true;
            if (e instanceof Fe) return true;
            if (e instanceof Re) return e.body.length == 0;
            return false;
        }
        function x(e) {
            return De(e.body, function(e) {
                return J(e) || e instanceof nn || e instanceof wn && De(e.definitions, function(e) {
                    return !e.value;
                });
            });
        }
        function A(e) {
            if (e instanceof Be) {
                return e.body instanceof Re ? e.body : e;
            }
            return e;
        }
        function _e(e) {
            while (e instanceof Tn) e = e.expression;
            return e;
        }
        function G(e) {
            if (e.TYPE != "Call") return false;
            return e.expression instanceof en || G(e.expression);
        }
        function X(e) {
            return e instanceof Jn && e.definition().undeclared;
        }
        function me(e) {
            return e[e instanceof Mn ? "right" : "value"];
        }
        var n = Oe("Array Boolean clearInterval clearTimeout console Date decodeURI decodeURIComponent encodeURI encodeURIComponent Error escape eval EvalError Function isFinite isNaN JSON Math Number parseFloat parseInt RangeError ReferenceError RegExp Object setInterval setTimeout String SyntaxError TypeError unescape URIError");
        Jn.DEFMETHOD("is_declared", function(e) {
            return this.defined || !this.definition().undeclared || e.option("unsafe") && n[this.name];
        });
        var K = Oe("Infinity NaN undefined");
        function o(e) {
            return e instanceof rt || e instanceof nt || e instanceof tt;
        }
        function m(e) {
            return De(e.definitions, function(e) {
                return !e.value;
            });
        }
        function z(e) {
            return e instanceof nn || e instanceof wn && m(e);
        }
        function c(e, f) {
            var se, fe, ue;
            t();
            var ce, n = 10;
            do {
                ce = false;
                r(e);
                if (f.option("dead_code")) {
                    a(e, f);
                }
                if (f.option("if_return")) {
                    o(e, f);
                }
                if (f.sequences_limit > 0) {
                    s(e, f);
                    u(e, f);
                }
                if (f.option("join_vars")) {
                    v(e);
                }
                if (f.option("collapse_vars")) {
                    i(e, f);
                }
            } while (ce && n-- > 0);
            return e;
            function t() {
                var e = f.self(), n = 0;
                do {
                    if (e instanceof _n) {
                        if (!f.parent(n).bfinally) n++;
                    } else if (e instanceof mn) {
                        n++;
                    } else if (e instanceof Be) {
                        se = true;
                    } else if (e instanceof Xe) {
                        ue = e;
                        break;
                    } else if (e instanceof vn) {
                        if (!fe) fe = e;
                    }
                } while (e = f.parent(n++));
            }
            function i(o, c) {
                if (ue.pinned()) return o;
                var f;
                var a = Object.create(null);
                var u = [];
                var s = Object.create(null);
                var t;
                var l = o.length;
                var p = new ht(function(e, n) {
                    if ($) return e;
                    if (!z) {
                        if (e !== d[h]) return e;
                        h++;
                        if (h < d.length) return P(e, p);
                        z = true;
                        m = (_ ? Y : B)(e, 0);
                        if (m === e) $ = true;
                        return e;
                    }
                    var t = p.parent();
                    if (N(e, t)) {
                        $ = true;
                        return e;
                    }
                    if (!g && H(e, t)) {
                        g = t;
                    }
                    if (e.single_use && t instanceof xn && t.value === e) return e;
                    var i;
                    if (!(e instanceof In) && (w && b.equivalent_to(e) || x && (i = x(e, this)))) {
                        if (!M || g && (i || !T || !O)) {
                            if (!i || !_) $ = true;
                            return e;
                        }
                        if (ye(e, t)) {
                            if (_ && !i) {
                                j = true;
                                q++;
                            }
                            return e;
                        } else if (_) {
                            if (!i) q++;
                            return e;
                        } else {
                            q++;
                        }
                        ce = $ = true;
                        qe.info("Collapsing {name} [{file}:{line},{col}]", {
                            name: e.print_to_string(),
                            file: e.start.file,
                            line: e.start.line,
                            col: e.start.col
                        });
                        if (v instanceof $n) {
                            if (b instanceof Jn) b.definition().fixed = false;
                            return he(zn, v, v);
                        }
                        if (v instanceof xn) {
                            var r = v.name.definition();
                            if (r.references.length - r.replaced == 1 && !c.exposed(r)) {
                                r.replaced++;
                                return ve(c, t, e, v.value);
                            }
                            return he(Mn, v, {
                                operator: "=",
                                left: he(Jn, v.name, v.name),
                                right: v.value
                            });
                        }
                        v.write_only = false;
                        return v;
                    }
                    if (I(e, t) || D(e)) {
                        m = e;
                        if (e instanceof Xe) $ = true;
                    }
                    if (e instanceof Ze) {
                        var o = M;
                        M = false;
                        n(e, p);
                        M = o;
                        return e;
                    }
                    return P(e, p);
                }, function(e) {
                    if ($) return;
                    if (m === e) $ = true;
                    if (g === e) g = null;
                });
                var i = new ht(function(e) {
                    if ($) return e;
                    if (!z) {
                        if (e !== d[h]) return e;
                        h++;
                        switch (d.length - h) {
                          case 0:
                            z = true;
                            if (j) return e;
                            if (e instanceof xn) return e;
                            C.replaced++;
                            var n = i.parent();
                            if (n instanceof Sn && n.tail_node() !== e) {
                                _.replaced++;
                                return Se.skip;
                            }
                            return r;

                          case 1:
                            if (!j && e.body === v) {
                                z = true;
                                C.replaced++;
                                _.replaced++;
                                return null;
                            }

                          default:
                            return;
                        }
                    }
                    if (e instanceof Jn && e.name == C.name) {
                        if (!--q) $ = true;
                        if (ye(e, i.parent())) return e;
                        C.replaced++;
                        _.replaced--;
                        return r.clone();
                    }
                    if (e instanceof dn || e instanceof Xe) return e;
                }, ee);
                while (--l >= 0) {
                    if (l == 0 && c.option("unused")) R();
                    var d = [];
                    U(o[l]);
                    while (u.length > 0) {
                        d = u.pop();
                        var h = 0;
                        var v = d[d.length - 1];
                        var _ = null;
                        var m = null;
                        var g = null;
                        var b = W(v);
                        var y = b && b.has_side_effects(c);
                        var w = b && !y && !de(b, c);
                        var x = G(v);
                        if (!w && !x) continue;
                        var k = false;
                        var E = false;
                        var S = Q(v);
                        var T = ne(b);
                        var r = me(v);
                        if (!y) y = te();
                        var O = ie(v);
                        var D = v.may_throw(c) ? fe ? function(e) {
                            return e.has_side_effects(c);
                        } : ae : Ee;
                        var A = v.name instanceof Yn;
                        var z = A;
                        var $ = false;
                        var q = 0;
                        var j = false;
                        var M = !f || !z;
                        if (!M) {
                            for (var e = c.self().argnames.lastIndexOf(v.name) + 1; !$ && e < f.length; e++) {
                                f[e].transform(p);
                            }
                            M = true;
                        }
                        for (var n = l; !$ && n < o.length; n++) {
                            o[n].transform(p);
                        }
                        if (_) {
                            var C = b.definition();
                            var F = C.references.length - C.replaced;
                            if (v instanceof Mn) F--;
                            if (q && F == q) {
                                $ = false;
                            } else {
                                u.push(d);
                                t = true;
                                continue;
                            }
                            if (q) {
                                h = 0;
                                z = A;
                                for (var n = l; !$ && n < o.length; n++) {
                                    if (!o[n].transform(i)) o.splice(n--, 1);
                                }
                                if (v instanceof xn) {
                                    q = !c.exposed(C) && C.references.length == C.replaced;
                                }
                                _.single_use = false;
                            }
                        }
                        if (q && !Z(v)) o.splice(l, 1);
                    }
                }
                function P(e, n) {
                    if (!(e instanceof Ne)) return;
                    if (e instanceof Xe) return e;
                    if (!(e.variables && e.variables.all(function(e) {
                        return !S.has(e.name);
                    }))) {
                        $ = true;
                        return e;
                    }
                    if (e instanceof Je) {
                        e.object = e.object.transform(n);
                        $ = true;
                        return e;
                    }
                    if (e instanceof ln) {
                        e.expression = e.expression.transform(n);
                        for (var t = 0; !$ && t < e.body.length; t++) {
                            var i = e.body[t];
                            if (i instanceof hn) {
                                if (!z) {
                                    if (i !== d[h]) continue;
                                    h++;
                                }
                                i.expression = i.expression.transform(n);
                                if (!O) break;
                                x = false;
                            }
                        }
                        $ = true;
                        return e;
                    }
                }
                function N(e, n) {
                    if (e === r) return true;
                    if (n instanceof We) return e !== n.init;
                    if (e instanceof Mn) {
                        return e.operator != "=" && b.equivalent_to(e.left);
                    }
                    if (e instanceof kn) {
                        if (!(b instanceof Tn)) return false;
                        if (!b.equivalent_to(e.expression)) return false;
                        return !(r instanceof en && !r.contains_this());
                    }
                    if (e instanceof Me) return true;
                    if (e instanceof nn) return A && b.name === e.name.name;
                    if (e instanceof Ye) return true;
                    if (e instanceof sn) return true;
                    if (e instanceof vn) return true;
                    if (e instanceof Ge) return true;
                    if (O) return false;
                    return e instanceof Jn && !e.is_declared(c) && !(n instanceof Mn && n.operator == "=" && n.left === e);
                }
                function H(e, n) {
                    if (n instanceof qn) return ge[n.operator] && n.left !== e;
                    if (n instanceof hn) return n.expression !== e;
                    if (n instanceof jn) return n.condition !== e;
                    return n instanceof cn && n.condition !== e;
                }
                function I(e, n) {
                    if (e.TYPE == "Binary") return e.operator == "in" && !we(e.right);
                    if (e instanceof kn) {
                        var t, i = e.expression;
                        if (i instanceof Jn) {
                            t = i.definition();
                            i = i.fixed_value();
                        }
                        if (!(i instanceof Qe)) return true;
                        if (t && xe(c, t)) return true;
                        if (i.collapse_scanning) return false;
                        i.collapse_scanning = true;
                        var r = M;
                        M = false;
                        var o = m;
                        var a = g;
                        for (var s = 0; !$ && s < i.body.length; s++) {
                            var f = i.body[s];
                            if (f instanceof on) {
                                if (f.value) f.value.transform(p);
                                break;
                            }
                            f.transform(p);
                        }
                        g = a;
                        m = o;
                        M = r;
                        delete i.collapse_scanning;
                        if (!$) return false;
                        $ = false;
                        return true;
                    }
                    if (e instanceof rn) {
                        if (fe) {
                            if (fe.bfinally) return true;
                            if (fe.bcatch && e instanceof an) return true;
                        }
                        return y || b instanceof Tn || oe(b);
                    }
                    if (e instanceof en) {
                        return c.option("ie8") && e.name && S.has(e.name.name);
                    }
                    if (e instanceof Tn) {
                        return y || !_ && e.expression.may_throw_on_access(c);
                    }
                    if (e instanceof Jn) {
                        if (re(e, n)) {
                            return !(n instanceof Mn && n.operator == "=" && n.left === e);
                        }
                        if (y && oe(e)) return true;
                        var t = e.definition();
                        return (fe || t.scope.resolve() !== ue) && !De(t.orig, function(e) {
                            return !(e instanceof Rn || e instanceof Un);
                        });
                    }
                    if (e instanceof Gn) return re(e, n);
                    if (e instanceof xn) {
                        if (!e.value) return false;
                        return S.has(e.name.name) || y && oe(e.name);
                    }
                    var u = ye(e.left, e);
                    if (u instanceof Tn) return true;
                    if (!(u instanceof Jn)) return false;
                    return S.has(u.name) || k && c.exposed(u.definition());
                }
                function R() {
                    var e, t = c.self();
                    if (t instanceof en && !t.name && !t.uses_arguments && !t.pinned() && (e = c.parent()) instanceof kn && e.expression === t) {
                        var i = c.has_directive("use strict");
                        if (i && !ke(i, t.body)) i = false;
                        var n = t.argnames.length;
                        f = e.args.slice(n);
                        var r = Object.create(null);
                        for (var o = n; --o >= 0; ) {
                            var a = t.argnames[o];
                            var s = e.args[o];
                            f.unshift(he(xn, a, {
                                name: a,
                                value: s
                            }));
                            if (a.name in r) continue;
                            r[a.name] = true;
                            if (!s) {
                                s = he(tt, a).transform(c);
                            } else if (s instanceof Qe && s.pinned()) {
                                s = null;
                            } else {
                                s.walk(new ft(function(e) {
                                    if (!s) return true;
                                    if (e instanceof Jn && t.variables.has(e.name)) {
                                        var n = e.definition().scope;
                                        if (n !== ue) while (n = n.parent_scope) {
                                            if (n === ue) return true;
                                        }
                                        s = null;
                                    }
                                    if (e instanceof Gn && (i || !this.find_parent(Xe))) {
                                        s = null;
                                        return true;
                                    }
                                }));
                            }
                            if (s) u.unshift([ he(xn, a, {
                                name: a,
                                value: s
                            }) ]);
                        }
                    }
                }
                function U(e) {
                    d.push(e);
                    if (e instanceof Cn) {
                        e.elements.forEach(U);
                    } else if (e instanceof Mn) {
                        u.push(d.slice());
                        U(e.left);
                        U(e.right);
                        if (e.left instanceof Jn) {
                            a[e.left.name] = (a[e.left.name] || 0) + 1;
                        }
                    } else if (e instanceof qn) {
                        U(e.left);
                        U(e.right);
                    } else if (e instanceof kn) {
                        U(e.expression);
                        e.args.forEach(U);
                    } else if (e instanceof hn) {
                        U(e.expression);
                    } else if (e instanceof jn) {
                        U(e.condition);
                        U(e.consequent);
                        U(e.alternative);
                    } else if (e instanceof On) {
                        U(e.expression);
                    } else if (e instanceof Ye) {
                        U(e.condition);
                        if (!(e.body instanceof Ie)) {
                            U(e.body);
                        }
                    } else if (e instanceof rn) {
                        if (e.value) U(e.value);
                    } else if (e instanceof We) {
                        if (e.init) U(e.init);
                        if (e.condition) U(e.condition);
                        if (e.step) U(e.step);
                        if (!(e.body instanceof Ie)) {
                            U(e.body);
                        }
                    } else if (e instanceof Je) {
                        U(e.object);
                        if (!(e.body instanceof Ie)) {
                            U(e.body);
                        }
                    } else if (e instanceof cn) {
                        U(e.condition);
                        if (!(e.body instanceof Ie)) {
                            U(e.body);
                        }
                        if (e.alternative && !(e.alternative instanceof Ie)) {
                            U(e.alternative);
                        }
                    } else if (e instanceof Fn) {
                        e.properties.forEach(function(e) {
                            if (e instanceof Nn) {
                                d.push(e);
                                U(e.value);
                                d.pop();
                            }
                        });
                    } else if (e instanceof Sn) {
                        e.expressions.forEach(U);
                    } else if (e instanceof Pe) {
                        U(e.body);
                    } else if (e instanceof Dn) {
                        U(e.expression);
                        U(e.property);
                    } else if (e instanceof ln) {
                        U(e.expression);
                        e.body.forEach(U);
                    } else if (e instanceof An) {
                        if (be[e.operator]) {
                            u.push(d.slice());
                        } else {
                            U(e.expression);
                        }
                    } else if (e instanceof wn) {
                        e.definitions.forEach(U);
                    } else if (e instanceof xn) {
                        if (e.value) {
                            var n = e.name.definition();
                            if (n.references.length > n.replaced) {
                                u.push(d.slice());
                            }
                            U(e.value);
                        } else {
                            s[e.name.name] = (s[e.name.name] || 0) + 1;
                        }
                    }
                    d.pop();
                }
                function B(e, n) {
                    var t = p.parent(n);
                    if (t instanceof Cn) return e;
                    if (t instanceof Mn) return e;
                    if (t instanceof qn) return e;
                    if (t instanceof kn) return e;
                    if (t instanceof hn) return e;
                    if (t instanceof jn) return e;
                    if (t instanceof gn) return L(t, n + 1);
                    if (t instanceof rn) return e;
                    if (t instanceof cn) return e;
                    if (t instanceof Be) return e;
                    if (t instanceof Nn) return e;
                    if (t instanceof Tn) return e;
                    if (t instanceof Sn) {
                        return (t.tail_node() === e ? B : L)(t, n + 1);
                    }
                    if (t instanceof Pe) return L(t, n + 1);
                    if (t instanceof ln) return e;
                    if (t instanceof An) return e;
                    if (t instanceof xn) return e;
                    return null;
                }
                function Y(e, n) {
                    var t = p.parent(n);
                    if (t instanceof Cn) return Y(t, n + 1);
                    if (t instanceof Mn) {
                        if (D(t)) return e;
                        if (t.left instanceof Jn) {
                            var i = t.left.name;
                            if (b.name == i) return e;
                            if (_.name == i) return e;
                        }
                        return Y(t, n + 1);
                    }
                    if (t instanceof qn) {
                        if (ge[t.operator] && t.left !== e) {
                            do {
                                e = t;
                                t = p.parent(++n);
                            } while (t instanceof qn && t.operator == e.operator);
                            return e;
                        }
                        return Y(t, n + 1);
                    }
                    if (t instanceof kn) return t;
                    if (t instanceof hn) {
                        if (t.expression !== e) return e;
                        return Y(t, n + 1);
                    }
                    if (t instanceof jn) {
                        if (t.condition !== e) return e;
                        return Y(t, n + 1);
                    }
                    if (t instanceof gn) return L(t, n + 1);
                    if (t instanceof Le) return e;
                    if (t instanceof rn) return L(t, n + 1);
                    if (t instanceof We) {
                        if (t.init !== e && t.condition !== e) return e;
                        return Y(t, n + 1);
                    }
                    if (t instanceof Je) {
                        if (t.init !== e) return e;
                        return Y(t, n + 1);
                    }
                    if (t instanceof cn) {
                        if (t.condition !== e) return e;
                        return Y(t, n + 1);
                    }
                    if (t instanceof Nn) {
                        var r = p.parent(n + 1);
                        return De(r.properties, function(e) {
                            return e instanceof Nn;
                        }) ? Y(r, n + 2) : r;
                    }
                    if (t instanceof Tn) return Y(t, n + 1);
                    if (t instanceof Sn) {
                        return (t.tail_node() === e ? Y : L)(t, n + 1);
                    }
                    if (t instanceof Pe) return L(t, n + 1);
                    if (t instanceof ln) {
                        if (t.expression !== e) return e;
                        return Y(t, n + 1);
                    }
                    if (t instanceof An) {
                        if (t.operator == "delete") return e;
                        return Y(t, n + 1);
                    }
                    if (t instanceof xn) {
                        var i = t.name.name;
                        if (b.name == i) return e;
                        if (_.name == i) return e;
                        return Y(t, n + 1);
                    }
                    if (t instanceof Ve) {
                        if (t.condition !== e) return e;
                        return Y(t, n + 1);
                    }
                    return null;
                }
                function L(e, n) {
                    var t = p.parent(n);
                    if (I(e, t)) return e;
                    if (H(e, t)) return e;
                    if (t instanceof Cn) return L(t, n + 1);
                    if (t instanceof Mn) {
                        return D(t) ? e : L(t, n + 1);
                    }
                    if (t instanceof qn) return L(t, n + 1);
                    if (t instanceof kn) return L(t, n + 1);
                    if (t instanceof hn) return L(t, n + 1);
                    if (t instanceof jn) return L(t, n + 1);
                    if (t instanceof gn) return L(t, n + 1);
                    if (t instanceof rn) return L(t, n + 1);
                    if (t instanceof cn) return L(t, n + 1);
                    if (t instanceof Be) return e;
                    if (t instanceof Nn) {
                        var i = p.parent(n + 1);
                        return De(i.properties, function(e) {
                            return e instanceof Nn;
                        }) ? L(i, n + 2) : i;
                    }
                    if (t instanceof Tn) {
                        var r = t.expression;
                        if (r === e) return L(t, n + 1);
                        var o = _e(r);
                        if (!(o instanceof Jn)) return L(t, n + 1);
                        var a = S.get(o.name);
                        return !a || De(a, function(e) {
                            return !(e instanceof Tn);
                        }) ? L(t, n + 1) : e;
                    }
                    if (t instanceof Sn) return L(t, n + 1);
                    if (t instanceof Pe) return L(t, n + 1);
                    if (t instanceof ln) return L(t, n + 1);
                    if (t instanceof An) return L(t, n + 1);
                    if (t instanceof xn) {
                        return D(t) ? e : L(t, n + 1);
                    }
                    return null;
                }
                function V(e) {
                    if (t) {
                        t = false;
                        return;
                    }
                    if (!(e instanceof Jn)) return;
                    var n = e.definition();
                    if (n.undeclared) return;
                    if (pe(n)) return;
                    return _ = n;
                }
                function W(e) {
                    if (e instanceof xn) {
                        var n = e.name.definition();
                        if (n.const_redefs) return;
                        if (!ke(e.name, n.orig)) return;
                        var t = n.orig.length - n.eliminated - (s[n.name] || 0);
                        var i = n.references.length - n.replaced - (a[n.name] || 0);
                        if (t > 1 && !(e.name instanceof Yn)) {
                            V(e.value);
                            return he(Jn, e.name, e.name);
                        }
                        if (V(e.value) || i == 1 && !c.exposed(n)) {
                            return he(Jn, e.name, e.name);
                        }
                    } else if (e instanceof Mn) {
                        var n, r = e.left;
                        if (e.operator == "=" && r instanceof Jn && (n = r.definition()).references[0] === r && !c.exposed(n)) {
                            var i = n.references.length - n.replaced;
                            if (i > 1) V(e.right);
                        }
                        return r;
                    } else {
                        return e.expression;
                    }
                }
                function J(e) {
                    if (e instanceof Cn) return false;
                    if (e instanceof qn && ge[e.operator]) {
                        return J(e.left) && J(e.right);
                    }
                    if (e instanceof kn) return false;
                    if (e instanceof jn) {
                        return J(e.consequent) && J(e.alternative);
                    }
                    if (e instanceof Fn) return false;
                    return !e.has_side_effects(c);
                }
                function G(n) {
                    if (n instanceof Mn && n.right.single_use) return;
                    var t = Object.create(null);
                    var e = new ft(function(e) {
                        if (e instanceof Jn) t[e.definition().id] = true;
                    });
                    while (n instanceof Mn && n.operator == "=") {
                        n.left.walk(e);
                        n = n.right;
                    }
                    if (n instanceof Jn) {
                        var i = n.evaluate(c);
                        if (i === n) return o;
                        return X(i, o);
                    }
                    if (n instanceof Gn) return o;
                    if (n.is_truthy()) return X(true, Ee);
                    if (n.is_constant()) {
                        return X(n.evaluate(c), o);
                    }
                    if (!(b instanceof Jn)) return false;
                    if (!J(n)) return false;
                    var r;
                    n.walk(new ft(function(e) {
                        if (r) return true;
                        if (e instanceof Jn && t[e.definition().id]) r = true;
                    }));
                    return !r && o;
                    function o(e) {
                        return n.equivalent_to(e);
                    }
                }
                function X(t, i) {
                    return function(e, n) {
                        if (n.in_boolean_context()) {
                            if (t && e.is_truthy() && !e.has_side_effects(c)) {
                                return true;
                            }
                            if (e.is_constant()) {
                                return !e.evaluate(c) == !t;
                            }
                        }
                        return i(e);
                    };
                }
                function K(e) {
                    if (e instanceof Jn) {
                        e = e.fixed_value();
                        if (!e) return true;
                    }
                    if (e instanceof Mn) return e.operator == "=" && K(e.right);
                    return e instanceof Tn || e instanceof Gn;
                }
                function Q(i) {
                    var r = new Ae();
                    if (i instanceof xn) r.add(i.name.name, b);
                    var o = ue.uses_arguments && !c.has_directive("use strict");
                    var a = ue instanceof Ke;
                    var s = new ft(function(e) {
                        var n;
                        if (e instanceof Jn) {
                            n = e.fixed_value() || e;
                        } else if (e instanceof Gn) {
                            n = e;
                        }
                        if (n) r.add(e.name, le(c, s, e, n, 0));
                        if (o && e instanceof Dn) {
                            ue.argnames.forEach(function(e) {
                                if (!c.option("reduce_vars") || e.definition().assignments) {
                                    r.add(e.name, true);
                                }
                            });
                            o = false;
                        }
                        if (!a) return;
                        if (e.TYPE == "Call") {
                            if (E) return;
                            var t = e.expression;
                            if (t instanceof Tn) return;
                            if (t instanceof en && !t.contains_this()) return;
                            E = true;
                        } else if (e instanceof Tn && K(e.expression)) {
                            if (e === b && !(i instanceof An)) {
                                E = true;
                            } else {
                                k = true;
                            }
                        }
                    });
                    i.walk(s);
                    return r;
                }
                function Z(e) {
                    if (e.name instanceof Yn) {
                        var n = c.self().argnames.indexOf(e.name);
                        var t = c.parent().args;
                        if (t[n]) {
                            t[n] = he(Qn, t[n], {
                                value: 0
                            });
                            e.name.definition().fixed = false;
                        }
                        return true;
                    }
                    var i = d.length - 1;
                    if (d[i - 1].body === d[i]) i--;
                    var r = new ht(function(e, n, t) {
                        if (z) return e;
                        if (e !== d[h]) return e;
                        h++;
                        if (h <= i) return P(e, r);
                        z = true;
                        if (e instanceof xn) {
                            e.value = null;
                            s[e.name.name] = (s[e.name.name] || 0) + 1;
                            if (_) _.replaced++;
                            return e;
                        }
                        return t ? Se.skip : null;
                    }, ee);
                    $ = false;
                    z = false;
                    h = 0;
                    return o[l].transform(r);
                }
                function ee(e) {
                    if (e instanceof Sn) switch (e.expressions.length) {
                      case 0:
                        return null;

                      case 1:
                        return e.expressions[0];
                    }
                }
                function ne(e) {
                    var n = _e(e);
                    return n instanceof Jn && n.definition().scope === ue && !(se && (S.has(n.name) && S.get(n.name)[0] !== e || v instanceof An || v instanceof Mn && v.operator != "="));
                }
                function te() {
                    if (v instanceof An) return false;
                    return r.has_side_effects(c);
                }
                function ie(e) {
                    if (e instanceof An) return false;
                    if (y) return false;
                    if (_) return true;
                    if (!(b instanceof Jn)) return false;
                    var n;
                    if (e instanceof xn) {
                        n = 1;
                    } else if (e.operator == "=") {
                        n = 2;
                    } else {
                        return false;
                    }
                    var t = b.definition();
                    return t.references.length - t.replaced == n;
                }
                function re(e, n) {
                    var t = S.get(e.name);
                    if (!t || De(t, function(e) {
                        return !e;
                    })) return;
                    if (t[0] !== b) return true;
                    x = false;
                }
                function oe(e) {
                    var n = e.definition();
                    if (n.orig.length == 1 && n.orig[0] instanceof Ln) return false;
                    if (n.scope !== ue) return true;
                    if (E && c.exposed(n)) return true;
                    return !De(n.references, function(e) {
                        return e.scope.resolve() === ue;
                    });
                }
                function ae(e, n) {
                    if (e instanceof Mn) return ae(e.left, true);
                    if (e instanceof An) return ae(e.expression, true);
                    if (e instanceof xn) return e.value && ae(e.value);
                    if (n) {
                        if (e instanceof On) return ae(e.expression, true);
                        if (e instanceof Dn) return ae(e.expression, true);
                        if (e instanceof Jn) return e.definition().scope !== ue;
                    }
                    return false;
                }
            }
            function r(e) {
                var n = [];
                for (var t = 0; t < e.length; ) {
                    var i = e[t];
                    if (i instanceof Re) {
                        if (De(i.body, function(e) {
                            return !(e instanceof bn || e instanceof yn);
                        })) {
                            ce = true;
                            r(i.body);
                            [].splice.apply(e, [ t, 1 ].concat(i.body));
                            t += i.body.length;
                            continue;
                        }
                    }
                    if (i instanceof Ce) {
                        if (ke(i.value, n)) {
                            ce = true;
                            e.splice(t, 1);
                            continue;
                        }
                        n.push(i.value);
                    }
                    if (i instanceof Fe) {
                        ce = true;
                        e.splice(t, 1);
                        continue;
                    }
                    t++;
                }
            }
            function o(t, r) {
                var o = r.self();
                var e = r.parent();
                var i = w(function(e) {
                    return e instanceof Qe;
                });
                var n = i && e && e.TYPE == "Call";
                var a = g(t);
                for (var s = t.length; --s >= 0; ) {
                    var f = t[s];
                    var u = T(s);
                    var c = t[u];
                    if (i && !c && f instanceof on) {
                        if (!f.value) {
                            ce = true;
                            t.splice(s, 1);
                            continue;
                        }
                        if (f.value instanceof zn && f.value.operator == "void") {
                            ce = true;
                            t[s] = he(Pe, f, {
                                body: f.value.expression
                            });
                            continue;
                        }
                    }
                    if (f instanceof cn) {
                        var l = q(f.body);
                        if (k(l)) {
                            if (l.label) Te(l.label.thedef.references, l);
                            ce = true;
                            f = f.clone();
                            f.condition = f.condition.negate(r);
                            var p = S(f.body, l);
                            f.body = he(Re, f, {
                                body: D(f.alternative).concat(E())
                            });
                            f.alternative = he(Re, f, {
                                body: p
                            });
                            t[s] = f;
                            t[s] = f.transform(r);
                            continue;
                        }
                        if (l && !f.alternative && f.body instanceof Re && c instanceof tn) {
                            var d = f.condition.negate(r);
                            if (d.print_to_string().length <= f.condition.print_to_string().length) {
                                ce = true;
                                f = f.clone();
                                f.condition = d;
                                t[u] = f.body;
                                f.body = c;
                                t[s] = f;
                                t[s] = f.transform(r);
                                continue;
                            }
                        }
                        var h = q(f.alternative);
                        if (k(h)) {
                            if (h.label) Te(h.label.thedef.references, h);
                            ce = true;
                            f = f.clone();
                            f.body = he(Re, f.body, {
                                body: D(f.body).concat(E())
                            });
                            var p = S(f.alternative, h);
                            f.alternative = he(Re, f.alternative, {
                                body: p
                            });
                            t[s] = f;
                            t[s] = f.transform(r);
                            continue;
                        }
                        if (r.option("typeofs")) {
                            if (l && !h) {
                                j(f.condition, null, he(Re, o, {
                                    body: t.slice(s + 1)
                                }));
                            }
                            if (!l && h) {
                                j(f.condition, he(Re, o, {
                                    body: t.slice(s + 1)
                                }));
                            }
                        }
                    }
                    if (f instanceof cn && f.body instanceof on) {
                        var v = f.body.value;
                        var _ = f.body.in_bool || c instanceof on && c.in_bool;
                        if (!v && !f.alternative && (i && !c || c instanceof on && !c.value)) {
                            ce = true;
                            t[s] = he(Pe, f.condition, {
                                body: f.condition
                            });
                            continue;
                        }
                        if (!f.alternative && c instanceof on) {
                            ce = true;
                            f = f.clone();
                            f.alternative = c;
                            t.splice(s, 1, f.transform(r));
                            t.splice(u, 1);
                            continue;
                        }
                        if (!f.alternative && !c && i && (_ || v && a)) {
                            ce = true;
                            f = f.clone();
                            f.alternative = he(on, f, {
                                value: null
                            });
                            t.splice(s, 1, f.transform(r));
                            continue;
                        }
                        var m = t[O(s)];
                        if (r.option("sequences") && i && !f.alternative && (!m && n || m instanceof cn && m.body instanceof on) && T(u) == t.length && c instanceof Pe) {
                            ce = true;
                            f = f.clone();
                            f.alternative = he(Re, c, {
                                body: [ c, he(on, c, {
                                    value: null
                                }) ]
                            });
                            t.splice(s, 1, f.transform(r));
                            t.splice(u, 1);
                            continue;
                        }
                    }
                }
                function g(e) {
                    var n = 0;
                    for (var t = e.length; --t >= 0; ) {
                        var i = e[t];
                        if (i instanceof cn && i.body instanceof on) {
                            if (++n > 1) return true;
                        }
                    }
                    return false;
                }
                function b(e) {
                    return !e || e instanceof zn && e.operator == "void";
                }
                function y(e, n) {
                    var t = e.lastIndexOf(n);
                    if (t < 0) return false;
                    while (++t < e.length) {
                        if (!z(e[t])) return false;
                    }
                    return true;
                }
                function w(e) {
                    var n = o, t, i = 0;
                    do {
                        do {
                            if (e(n)) return true;
                            n = r.parent(i++);
                        } while (n instanceof cn && (t = n));
                    } while ((n instanceof Re || n instanceof Xe) && y(n.body, t));
                }
                function x(n) {
                    return w(function(e) {
                        return e === n;
                    });
                }
                function k(e) {
                    if (e instanceof on) return i && b(e.value);
                    if (!(e instanceof sn)) return false;
                    var n = r.loopcontrol_target(e);
                    if (e instanceof un) return x(A(n));
                    if (n instanceof Be) return false;
                    return x(n);
                }
                function E() {
                    var e = t.slice(s + 1);
                    t.length = s + 1;
                    return e.filter(function(e) {
                        if (e instanceof nn) {
                            t.push(e);
                            return false;
                        }
                        return true;
                    });
                }
                function S(e, n) {
                    var t = D(e);
                    var i = t, r;
                    while ((r = i[i.length - 1]) !== n) {
                        i = r.body;
                    }
                    i.pop();
                    if (n.value) t.push(he(Pe, n.value, {
                        body: n.value.expression
                    }));
                    return t;
                }
                function T(e) {
                    for (var n = e + 1; n < t.length; n++) {
                        if (!z(t[n])) break;
                    }
                    return n;
                }
                function O(e) {
                    for (var n = e; --n >= 0; ) {
                        if (!z(t[n])) break;
                    }
                    return n;
                }
            }
            function a(n, t) {
                var e;
                var i = t.self();
                for (var r = 0, o = 0, a = n.length; r < a; r++) {
                    var s = n[r];
                    if (s instanceof sn) {
                        var f = t.loopcontrol_target(s);
                        if (s instanceof fn && !(f instanceof Be) && A(f) === i || s instanceof un && A(f) === i) {
                            if (s.label) Te(s.label.thedef.references, s);
                        } else {
                            n[o++] = s;
                        }
                    } else {
                        n[o++] = s;
                    }
                    if (q(s)) {
                        e = n.slice(r + 1);
                        break;
                    }
                }
                n.length = o;
                ce = o != a;
                if (e) e.forEach(function(e) {
                    k(t, e, n);
                });
            }
            function s(n, e) {
                if (n.length < 2) return;
                var t = [], i = 0;
                function r() {
                    if (!t.length) return;
                    var e = V(t[0], t);
                    n[i++] = he(Pe, e, {
                        body: e
                    });
                    t = [];
                }
                for (var o = 0, a = n.length; o < a; o++) {
                    var s = n[o];
                    if (s instanceof Pe) {
                        if (t.length >= e.sequences_limit) r();
                        var f = s.body;
                        if (t.length > 0) f = f.drop_side_effect_free(e);
                        if (f) _(t, f);
                    } else if (z(s)) {
                        n[i++] = s;
                    } else {
                        r();
                        n[i++] = s;
                    }
                }
                r();
                n.length = i;
                if (i != a) ce = true;
            }
            function p(e, n) {
                if (!(e instanceof Re)) return e;
                var t = null;
                for (var i = 0; i < e.body.length; i++) {
                    var r = e.body[i];
                    if (r instanceof wn && m(r)) {
                        n.push(r);
                    } else if (t || r instanceof bn || r instanceof yn) {
                        return false;
                    } else {
                        t = r;
                    }
                }
                return t;
            }
            function u(e, n) {
                function t(e) {
                    i--;
                    ce = true;
                    var n = r.body;
                    return V(n, [ n, e ]);
                }
                var i = 0, r;
                for (var o = 0; o < e.length; o++) {
                    var a = e[o];
                    if (r) {
                        if (a instanceof rn) {
                            a.value = t(a.value || he(tt, a)).transform(n);
                        } else if (a instanceof We) {
                            if (!(a.init instanceof gn)) {
                                var s = false;
                                r.body.walk(new ft(function(e) {
                                    if (s || e instanceof Xe) return true;
                                    if (e instanceof qn && e.operator == "in") {
                                        s = true;
                                        return true;
                                    }
                                }));
                                if (!s) {
                                    if (a.init) a.init = t(a.init); else {
                                        a.init = r.body;
                                        i--;
                                        ce = true;
                                    }
                                }
                            }
                        } else if (a instanceof Je) {
                            a.object = t(a.object);
                        } else if (a instanceof cn) {
                            a.condition = t(a.condition);
                        } else if (a instanceof ln) {
                            a.expression = t(a.expression);
                        } else if (a instanceof Ge) {
                            a.expression = t(a.expression);
                        }
                    }
                    if (n.option("conditionals") && a instanceof cn) {
                        var f = [];
                        var u = p(a.body, f);
                        var c = p(a.alternative, f);
                        if (u !== false && c !== false && f.length > 0) {
                            var l = f.length;
                            f.push(he(cn, a, {
                                condition: a.condition,
                                body: u || he(Fe, a.body),
                                alternative: c
                            }));
                            f.unshift(i, 1);
                            [].splice.apply(e, f);
                            o += l;
                            i += l + 1;
                            r = null;
                            ce = true;
                            continue;
                        }
                    }
                    e[i++] = a;
                    r = a instanceof Pe ? a : null;
                }
                e.length = i;
            }
            function l(e, n, t) {
                var i;
                if (n instanceof Mn) {
                    i = [ n ];
                } else if (n instanceof Sn) {
                    i = n.expressions.slice();
                }
                if (!i) return;
                var r = false;
                for (var o = i.length - 1; --o >= 0; ) {
                    var a = i[o];
                    if (!(a instanceof Mn)) continue;
                    if (a.operator != "=") continue;
                    if (!(a.left instanceof Jn)) continue;
                    var s = i.slice(o + 1);
                    if (!h(a.left, a.right, s)) continue;
                    r = true;
                    i = i.slice(0, o + 1).concat(s);
                }
                if (e instanceof gn) {
                    t = t || 0;
                    for (var o = e.definitions.length; --o >= 0; ) {
                        var f = e.definitions[o];
                        if (!f.value) continue;
                        if (h(f.name, f.value, i)) r = true;
                        if (c(f, i, t)) r = true;
                        break;
                    }
                    if (e instanceof wn && d(e.definitions, i, t)) r = true;
                }
                return r && i;
            }
            function c(e, n, t) {
                if (!f.option("conditionals")) return;
                var i = false;
                var r = e.name.definition();
                while (n.length > t) {
                    var o = w(f, r, e.value, n[0]);
                    if (!o) break;
                    e.value = o;
                    n.shift();
                    i = true;
                }
                return i;
            }
            function d(e, n, t) {
                var i = false;
                while (n.length > t) {
                    var r = n[0];
                    if (!(r instanceof Mn)) break;
                    if (r.operator != "=") break;
                    var o = r.left;
                    if (!(o instanceof Jn)) break;
                    if (X(o)) break;
                    if (o.scope.resolve() !== ue) break;
                    var a = o.definition();
                    if (a.scope !== ue) break;
                    if (a.orig.length > a.eliminated + 1) break;
                    if (a.orig[0].TYPE != "SymbolVar") break;
                    var s = he(Bn, o, o);
                    e.push(he(xn, r, {
                        name: s,
                        value: r.right
                    }));
                    a.orig.push(s);
                    a.replaced++;
                    n.shift();
                    i = true;
                }
                return i;
            }
            function h(e, n, t) {
                if (!(n instanceof Fn)) return;
                var i = false;
                do {
                    var r = t[0];
                    if (!(r instanceof Mn)) break;
                    if (r.operator != "=") break;
                    if (!(r.left instanceof Tn)) break;
                    var o = r.left.expression;
                    if (!(o instanceof Jn)) break;
                    if (e.name != o.name) break;
                    if (!r.right.is_constant_expression(ue)) break;
                    var a = r.left.property;
                    if (a instanceof qe) {
                        a = a.evaluate(f);
                    }
                    if (a instanceof qe) break;
                    a = "" + a;
                    var s = a == "__proto__" || f.has_directive("use strict") ? function(e) {
                        return e.key != a && e.key.name != a;
                    } : function(e) {
                        return e.key.name != a;
                    };
                    if (!De(n.properties, s)) break;
                    n.properties.push(he(Nn, r, {
                        key: a,
                        value: r.right
                    }));
                    t.shift();
                    i = true;
                } while (t.length);
                return i;
            }
            function v(e) {
                var r;
                for (var n = 0, t = -1; n < e.length; n++) {
                    var i = e[n];
                    var o = e[t];
                    if (i instanceof gn) {
                        if (o && o.TYPE == i.TYPE) {
                            o.definitions = o.definitions.concat(i.definitions);
                            ce = true;
                        } else if (r && r.TYPE == i.TYPE && m(i)) {
                            r.definitions = r.definitions.concat(i.definitions);
                            ce = true;
                        } else {
                            e[++t] = i;
                            if (i instanceof wn) r = i;
                        }
                        continue;
                    } else if (i instanceof rn) {
                        i.value = u(i.value);
                    } else if (i instanceof We) {
                        var a = l(o, i.init);
                        if (a) {
                            ce = true;
                            i.init = a.length ? V(i.init, a) : null;
                        } else if (o instanceof wn && (!i.init || i.init.TYPE == o.TYPE)) {
                            if (i.init) {
                                o.definitions = o.definitions.concat(i.init.definitions);
                            }
                            r = i.init = o;
                            e[t] = c(i);
                            ce = true;
                            continue;
                        } else if (r && i.init && r.TYPE == i.init.TYPE && m(i.init)) {
                            r.definitions = r.definitions.concat(i.init.definitions);
                            i.init = null;
                            ce = true;
                        } else if (i.init instanceof wn) {
                            r = i.init;
                        }
                    } else if (i instanceof Je) {
                        if (r && r.TYPE == i.init.TYPE) {
                            r.definitions = r.definitions.concat(i.init.definitions);
                            var s = i.init.definitions[0].name;
                            var f = he(Jn, s, s);
                            s.definition().references.push(f);
                            i.init = f;
                            ce = true;
                        }
                        i.object = u(i.object);
                    } else if (i instanceof cn) {
                        i.condition = u(i.condition);
                    } else if (i instanceof Pe) {
                        var a = l(o, i.body);
                        if (a) {
                            ce = true;
                            if (!a.length) continue;
                            i.body = V(i.body, a);
                        }
                    } else if (i instanceof ln) {
                        i.expression = u(i.expression);
                    } else if (i instanceof Ge) {
                        i.expression = u(i.expression);
                    }
                    e[++t] = r ? c(i) : i;
                }
                e.length = t + 1;
                function u(e) {
                    var n = l(o, e, 1);
                    if (!n) return e;
                    ce = true;
                    var t = e.tail_node();
                    if (n[n.length - 1] !== t) n.push(t.left);
                    return V(e, n);
                }
                function c(e) {
                    return e.transform(new ht(function(e, n, t) {
                        if (e instanceof gn) {
                            if (r === e) return e;
                            if (r.TYPE != e.TYPE) return e;
                            var i = this.parent();
                            if (i instanceof Je && i.init === e) return e;
                            if (!m(e)) return e;
                            r.definitions = r.definitions.concat(e.definitions);
                            ce = true;
                            if (i instanceof We && i.init === e) return null;
                            return t ? Se.skip : he(Fe, e);
                        }
                        if (e instanceof Xe) return e;
                        if (!(e instanceof je)) return e;
                    }));
                }
            }
        }
        function k(i, r, o) {
            if (!(r instanceof nn)) {
                qe.warn("Dropping unreachable code [{file}:{line},{col}]", r.start);
            }
            var a;
            r.walk(new ft(function(e, n) {
                if (e instanceof gn) {
                    qe.warn("Declarations in unreachable code! [{file}:{line},{col}]", e.start);
                    e.remove_initializers(i);
                    s(e);
                    return true;
                }
                if (e instanceof nn) {
                    s(e);
                    return true;
                }
                if (e instanceof Xe) return true;
                if (e instanceof Ne) {
                    var t = a;
                    a = [];
                    n();
                    if (a.required) {
                        o.push(he(Re, r, {
                            body: a
                        }));
                    } else if (a.length) {
                        [].push.apply(o, a);
                    }
                    a = t;
                    return true;
                }
            }));
            function s(e) {
                if (a) {
                    a.push(e);
                    if (e instanceof bn || e instanceof yn) a.required = true;
                } else {
                    o.push(e);
                }
            }
        }
        function $(e, n) {
            return e.is_undefined || e instanceof tt || e instanceof zn && e.operator == "void" && !e.expression.has_side_effects(n);
        }
        (function(e) {
            e(qe, Ee);
            e(Cn, se);
            e(Mn, function() {
                return this.operator == "=" && this.right.is_truthy();
            });
            e(Qe, se);
            e(Fn, se);
            e(Zn, se);
            e(Sn, function() {
                return this.tail_node().is_truthy();
            });
            e(Jn, function() {
                var e = this.fixed_value();
                if (!e) return false;
                this.is_truthy = Ee;
                var n = e.is_truthy();
                delete this.is_truthy;
                return n;
            });
        })(function(e, n) {
            e.DEFMETHOD("is_truthy", n);
        });
        (function(e) {
            e(qe, se);
            e(Cn, Ee);
            function n(e, n, t) {
                switch (e) {
                  case "-":
                    return n.is_negative_zero() && (!(t instanceof Xn) || t.value == 0);

                  case "&&":
                  case "||":
                    return n.is_negative_zero() || t.is_negative_zero();

                  case "*":
                  case "/":
                  case "%":
                    return true;

                  default:
                    return false;
                }
            }
            e(Mn, function() {
                var e = this.operator;
                if (e == "=") return this.right.is_negative_zero();
                return n(e.slice(0, -1), this.left, this.right);
            });
            e(qn, function() {
                return n(this.operator, this.left, this.right);
            });
            e(Xn, function() {
                return this.value == 0 && 1 / this.value < 0;
            });
            e(Qe, Ee);
            e(Fn, Ee);
            e(Zn, Ee);
            e(Sn, function() {
                return this.tail_node().is_negative_zero();
            });
            e(Jn, function() {
                var e = this.fixed_value();
                if (!e) return true;
                this.is_negative_zero = se;
                var n = e.is_negative_zero();
                delete this.is_negative_zero;
                return n;
            });
            e(zn, function() {
                return this.operator == "+" && this.expression.is_negative_zero() || this.operator == "-";
            });
        })(function(e, n) {
            e.DEFMETHOD("is_negative_zero", n);
        });
        (function(e) {
            qe.DEFMETHOD("may_throw_on_access", function(e) {
                return !e.option("pure_getters") || this._dot_throw(e);
            });
            function t(e) {
                return /strict/.test(e.option("pure_getters"));
            }
            e(qe, t);
            e(Cn, Ee);
            e(Mn, function(e) {
                if (this.operator != "=") return false;
                var n = this.right;
                if (!n._dot_throw(e)) return false;
                var t = this.left;
                if (!(t instanceof Jn)) return true;
                if (n instanceof qn && n.operator == "||" && t.name == n.left.name) {
                    return n.right._dot_throw(e);
                }
                return true;
            });
            e(qn, function(e) {
                switch (this.operator) {
                  case "&&":
                    return this.left._dot_throw(e) || this.right._dot_throw(e);

                  case "||":
                    return this.right._dot_throw(e);

                  default:
                    return false;
                }
            });
            e(jn, function(e) {
                return this.consequent._dot_throw(e) || this.alternative._dot_throw(e);
            });
            e(Xn, Ee);
            e(On, function(e) {
                if (!t(e)) return false;
                var n = this.expression;
                if (n instanceof Jn) n = n.fixed_value();
                return !(n instanceof Qe && this.property == "prototype");
            });
            e(Qe, Ee);
            e(et, se);
            e(Fn, function(e) {
                if (!t(e)) return false;
                for (var n = this.properties.length; --n >= 0; ) if (this.properties[n].value instanceof Ze) return true;
                return false;
            });
            e(Sn, function(e) {
                return this.tail_node()._dot_throw(e);
            });
            e(Jn, function(e) {
                if (this.is_undefined) return true;
                if (!t(e)) return false;
                if (X(this) && this.is_declared(e)) return false;
                if (this.is_immutable()) return false;
                if (pe(this.definition())) return false;
                var n = this.fixed_value();
                if (!n) return true;
                this._dot_throw = se;
                if (n._dot_throw(e)) {
                    delete this._dot_throw;
                    return true;
                }
                this._dot_throw = Ee;
                return false;
            });
            e(Gn, function(e) {
                return t(e) && !this.scope.new;
            });
            e(zn, function() {
                return this.operator == "void";
            });
            e($n, Ee);
            e(tt, se);
        })(function(e, n) {
            e.DEFMETHOD("_dot_throw", n);
        });
        (function(e) {
            e(qe, Ee);
            e(Cn, se);
            e(Mn, function(e) {
                return this.operator != "=" || this.right.is_defined(e);
            });
            e(qn, function(e) {
                switch (this.operator) {
                  case "&&":
                    return this.left.is_defined(e) && this.right.is_defined(e);

                  case "||":
                    return this.left.is_truthy() || this.right.is_defined(e);

                  default:
                    return true;
                }
            });
            e(jn, function(e) {
                return this.consequent.is_defined(e) && this.alternative.is_defined(e);
            });
            e(Xn, se);
            e(Qe, se);
            e(Fn, se);
            e(Sn, function(e) {
                return this.tail_node().is_defined(e);
            });
            e(Jn, function(e) {
                if (this.is_undefined) return false;
                if (X(this) && this.is_declared(e)) return true;
                if (this.is_immutable()) return true;
                var n = this.fixed_value();
                if (!n) return false;
                this.is_defined = Ee;
                var t = n.is_defined(e);
                delete this.is_defined;
                return t;
            });
            e(zn, function() {
                return this.operator != "void";
            });
            e($n, se);
            e(tt, Ee);
        })(function(e, n) {
            e.DEFMETHOD("is_defined", n);
        });
        (function(e) {
            e(qe, Ee);
            e(Mn, function(e) {
                return this.operator == "=" && this.right.is_boolean(e);
            });
            var n = Oe("in instanceof == != === !== < <= >= >");
            e(qn, function(e) {
                return n[this.operator] || ge[this.operator] && this.left.is_boolean(e) && this.right.is_boolean(e);
            });
            e(ot, se);
            var t = Oe("every hasOwnProperty isPrototypeOf propertyIsEnumerable some");
            e(kn, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof On && (t[n.property] || n.property == "test" && n.expression instanceof Zn);
            });
            e(jn, function(e) {
                return this.consequent.is_boolean(e) && this.alternative.is_boolean(e);
            });
            e(En, Ee);
            e(Sn, function(e) {
                return this.tail_node().is_boolean(e);
            });
            e(Jn, function(e) {
                var n = this.fixed_value();
                if (!n) return false;
                this.is_boolean = Ee;
                var t = n.is_boolean(e);
                delete this.is_boolean;
                return t;
            });
            var i = Oe("! delete");
            e(zn, function() {
                return i[this.operator];
            });
        })(function(e, n) {
            e.DEFMETHOD("is_boolean", n);
        });
        (function(e) {
            e(qe, Ee);
            var n = Oe("- * / % & | ^ << >> >>>");
            e(Mn, function(e) {
                return n[this.operator.slice(0, -1)] || this.operator == "=" && this.right.is_number(e);
            });
            e(qn, function(e) {
                if (n[this.operator]) return true;
                if (this.operator != "+") return false;
                return (this.left.is_boolean(e) || this.left.is_number(e)) && (this.right.is_boolean(e) || this.right.is_number(e));
            });
            var t = Oe([ "charCodeAt", "getDate", "getDay", "getFullYear", "getHours", "getMilliseconds", "getMinutes", "getMonth", "getSeconds", "getTime", "getTimezoneOffset", "getUTCDate", "getUTCDay", "getUTCFullYear", "getUTCHours", "getUTCMilliseconds", "getUTCMinutes", "getUTCMonth", "getUTCSeconds", "getYear", "indexOf", "lastIndexOf", "localeCompare", "push", "search", "setDate", "setFullYear", "setHours", "setMilliseconds", "setMinutes", "setMonth", "setSeconds", "setTime", "setUTCDate", "setUTCFullYear", "setUTCHours", "setUTCMilliseconds", "setUTCMinutes", "setUTCMonth", "setUTCSeconds", "setYear", "toExponential", "toFixed", "toPrecision" ]);
            e(kn, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof On && (t[n.property] || X(n.expression) && n.expression.name == "Math");
            });
            e(jn, function(e) {
                return this.consequent.is_number(e) && this.alternative.is_number(e);
            });
            e(En, Ee);
            e(Qn, se);
            e(Sn, function(e) {
                return this.tail_node().is_number(e);
            });
            e(Jn, function(e) {
                var n = this.fixed_value();
                if (!n) return false;
                this.is_number = Ee;
                var t = n.is_number(e);
                delete this.is_number;
                return t;
            });
            var i = Oe("+ - ~ ++ --");
            e(An, function() {
                return i[this.operator];
            });
        })(function(e, n) {
            e.DEFMETHOD("is_number", n);
        });
        (function(e) {
            e(qe, Ee);
            e(Mn, function(e) {
                switch (this.operator) {
                  case "+=":
                    if (this.left.is_string(e)) return true;

                  case "=":
                    return this.right.is_string(e);
                }
            });
            e(qn, function(e) {
                return this.operator == "+" && (this.left.is_string(e) || this.right.is_string(e));
            });
            var t = Oe([ "charAt", "substr", "substring", "toLowerCase", "toString", "toUpperCase", "trim" ]);
            e(kn, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof On && t[n.property];
            });
            e(jn, function(e) {
                return this.consequent.is_string(e) && this.alternative.is_string(e);
            });
            e(Sn, function(e) {
                return this.tail_node().is_string(e);
            });
            e(Kn, se);
            e(Jn, function(e) {
                var n = this.fixed_value();
                if (!n) return false;
                this.is_string = Ee;
                var t = n.is_string(e);
                delete this.is_string;
                return t;
            });
            e(zn, function() {
                return this.operator == "typeof";
            });
        })(function(e, n) {
            e.DEFMETHOD("is_string", n);
        });
        var ge = Oe("&& ||");
        var be = Oe("++ --");
        var T = Oe("delete ++ --");
        function ye(e, n) {
            if (n instanceof An && T[n.operator]) return n.expression;
            if (n instanceof Mn && n.left === e) return e;
        }
        (function(e) {
            function r(e, n) {
                if (e instanceof qe) return e.clone(true);
                if (Array.isArray(e)) return he(Cn, n, {
                    elements: e.map(function(e) {
                        return r(e, n);
                    })
                });
                if (e && typeof e == "object") {
                    var t = [];
                    for (var i in e) if (ze(e, i)) {
                        t.push(he(Nn, n, {
                            key: i,
                            value: r(e[i], n)
                        }));
                    }
                    return he(Fn, n, {
                        properties: t
                    });
                }
                return S(e, n);
            }
            function a(e) {
                qe.warn("global_defs " + e.print_to_string() + " redefined [{file}:{line},{col}]", e.start);
            }
            Ke.DEFMETHOD("resolve_defines", function(o) {
                if (!o.option("global_defs")) return this;
                this.figure_out_scope({
                    ie8: o.option("ie8")
                });
                return this.transform(new ht(function(e) {
                    var n = e._find_defs(o, "");
                    if (!n) return;
                    var t = 0, i = e, r;
                    while (r = this.parent(t++)) {
                        if (!(r instanceof Tn)) break;
                        if (r.expression !== i) break;
                        i = r;
                    }
                    if (ye(i, r)) {
                        a(e);
                        return;
                    }
                    return n;
                }));
            });
            e(qe, ae);
            e(On, function(e, n) {
                return this.expression._find_defs(e, "." + this.property + n);
            });
            e(In, function(e) {
                if (!this.definition().global) return;
                if (ze(e.option("global_defs"), this.name)) a(this);
            });
            e(Jn, function(e, n) {
                if (!this.definition().global) return;
                var t = e.option("global_defs");
                var i = this.name + n;
                if (ze(t, i)) return r(t[i], this);
            });
        })(function(e, n) {
            e.DEFMETHOD("_find_defs", n);
        });
        function Q(e, n, t) {
            var i = n.print_to_string().length - e.print_to_string().length;
            return i < (t || 0) ? n : e;
        }
        function a(e, n, t) {
            return Q(he(Pe, e, {
                body: e
            }), he(Pe, n, {
                body: n
            }), t).body;
        }
        function Z(e, n, t, i) {
            return ($e(e) ? a : Q)(n, t, i);
        }
        function t(n) {
            var t = Object.create(null);
            Object.keys(n).forEach(function(e) {
                t[e] = Oe(n[e]);
            });
            return t;
        }
        Qe.DEFMETHOD("first_statement", function() {
            var e = this.body;
            for (var n = 0; n < e.length; n++) {
                var t = e[n];
                if (!(t instanceof Ce)) return t;
            }
        });
        function ee(e, n) {
            var t = n.evaluate(e);
            if (t === n) return n;
            t = S(t, n).optimize(e);
            return Z(e, n, t, e.eval_threshold);
        }
        var i = [ "constructor", "toString", "valueOf" ];
        var g = t({
            Array: [ "indexOf", "join", "lastIndexOf", "slice" ].concat(i),
            Boolean: i,
            Function: i,
            Number: [ "toExponential", "toFixed", "toPrecision" ].concat(i),
            Object: i,
            RegExp: [ "exec", "test" ].concat(i),
            String: [ "charAt", "charCodeAt", "concat", "indexOf", "italics", "lastIndexOf", "match", "replace", "search", "slice", "split", "substr", "substring", "toLowerCase", "toUpperCase", "trim" ].concat(i)
        });
        var b = t({
            Array: [ "isArray" ],
            Math: [ "abs", "acos", "asin", "atan", "ceil", "cos", "exp", "floor", "log", "round", "sin", "sqrt", "tan", "atan2", "pow", "max", "min" ],
            Number: [ "isFinite", "isNaN" ],
            Object: [ "create", "getOwnPropertyDescriptor", "getOwnPropertyNames", "getPrototypeOf", "isExtensible", "isFrozen", "isSealed", "keys" ],
            String: [ "fromCharCode" ]
        });
        (function(e) {
            qe.DEFMETHOD("evaluate", function(e, n) {
                if (!e.option("evaluate")) return this;
                var t = [];
                var i = this._eval(e, n, t, 1);
                t.forEach(function(e) {
                    delete e._eval;
                });
                if (n) return i;
                if (!i || i instanceof RegExp) return i;
                if (typeof i == "function" || typeof i == "object") return this;
                return i;
            });
            var n = Oe("! ~ - + void");
            qe.DEFMETHOD("is_constant", function() {
                if (this instanceof Xn) {
                    return !(this instanceof Zn);
                } else {
                    return this instanceof zn && this.expression instanceof Xn && n[this.operator];
                }
            });
            var u = new ft(function(e) {
                if (e instanceof Mn) c(e.left);
                if (e instanceof An && be[e.operator]) c(e.expression);
            });
            function c(e) {
                if (e instanceof Tn) {
                    c(e.expression);
                } else if (e instanceof Jn) {
                    e.definition().references.forEach(function(e) {
                        delete e._eval;
                    });
                }
            }
            e(je, function() {
                throw new Error(ce("Cannot evaluate a statement [{file}:{line},{col}]", this.start));
            });
            e(Ze, Y);
            e(qe, Y);
            e(Xn, function() {
                return this.value;
            });
            e(Mn, function(e, n, t, i) {
                var r = this.left;
                if (!n) {
                    if (!(r instanceof Jn)) return this;
                    if (!ze(r, "_eval")) {
                        if (!r.fixed) return this;
                        var o = r.definition();
                        if (!o.fixed) return this;
                        if (o.undeclared) return this;
                        if (o.last_ref !== r) return this;
                        if (o.single_use == "m") return this;
                    }
                }
                var a = this.operator;
                var s;
                if (!ze(r, "_eval") && r instanceof Jn && r.fixed && r.definition().fixed) {
                    s = r;
                } else if (a == "=") {
                    r.walk(u);
                    s = this.right;
                } else {
                    s = he(qn, this, {
                        operator: a.slice(0, -1),
                        left: r,
                        right: this.right
                    });
                }
                var f = s._eval(e, n, t, i);
                if (typeof f == "object") return this;
                c(r);
                return f;
            });
            e(Sn, function(e, n, t, i) {
                if (!n) return this;
                var r = this.expressions;
                for (var o = 0, a = r.length - 1; o < a; o++) {
                    r[o].walk(u);
                }
                var s = r[a];
                var f = s._eval(e, n, t, i);
                return f === s ? this : f;
            });
            e(Qe, function(e) {
                if (e.option("unsafe")) {
                    var n = function() {};
                    n.node = this;
                    n.toString = function() {
                        return "function(){}";
                    };
                    return n;
                }
                return this;
            });
            e(Cn, function(e, n, t, i) {
                if (e.option("unsafe")) {
                    var r = [];
                    for (var o = 0; o < this.elements.length; o++) {
                        var a = this.elements[o];
                        if (a instanceof it) return this;
                        var s = a._eval(e, n, t, i);
                        if (a === s) return this;
                        r.push(s);
                    }
                    return r;
                }
                return this;
            });
            e(Fn, function(e, n, t, i) {
                if (e.option("unsafe")) {
                    var r = {};
                    for (var o = 0; o < this.properties.length; o++) {
                        var a = this.properties[o];
                        var s = a.key;
                        if (s instanceof Hn) s = s.name;
                        if (a.value instanceof en) {
                            if (typeof Object.prototype[s] == "function") return this;
                            continue;
                        }
                        r[s] = a.value._eval(e, n, t, i);
                        if (r[s] === a.value) return this;
                    }
                    return r;
                }
                return this;
            });
            var f = Oe("! typeof void");
            e(zn, function(e, n, t, i) {
                var r = this.expression;
                var o = this.operator;
                if (e.option("typeofs") && o == "typeof" && (r instanceof Qe || r instanceof Jn && r.fixed_value() instanceof Qe)) {
                    return typeof function() {};
                }
                var a = r instanceof Jn && r.definition();
                if (!f[o] && !(a && a.fixed)) i++;
                var s = r._eval(e, n, t, i);
                if (s === r) {
                    if (n && o == "void") return;
                    return this;
                }
                switch (o) {
                  case "!":
                    return !s;

                  case "typeof":
                    if (s instanceof RegExp) return this;
                    return typeof s;

                  case "void":
                    return;

                  case "~":
                    return ~s;

                  case "-":
                    return -s;

                  case "+":
                    return +s;

                  case "++":
                  case "--":
                    if (!a) return this;
                    if (!n) {
                        if (a.undeclared) return this;
                        if (a.last_ref !== r) return this;
                    }
                    if (ze(r, "_eval")) s = +(o[0] + 1) + +s;
                    c(r);
                    return s;
                }
                return this;
            });
            e($n, function(e, n, t, i) {
                var r = this.expression;
                if (!(r instanceof Jn)) {
                    if (!n) return this;
                } else if (!ze(r, "_eval")) {
                    if (!r.fixed) return this;
                    if (!n) {
                        var o = r.definition();
                        if (!o.fixed) return this;
                        if (o.undeclared) return this;
                        if (o.last_ref !== r) return this;
                    }
                }
                if (!(r instanceof Jn && r.definition().fixed)) i++;
                var a = r._eval(e, n, t, i);
                if (a === r) return this;
                c(r);
                return +a;
            });
            var l = Oe("&& || === !==");
            e(qn, function(e, n, t, i) {
                if (!l[this.operator]) i++;
                var r = this.left._eval(e, n, t, i);
                if (r === this.left) return this;
                if (this.operator == (r ? "||" : "&&")) return r;
                var o = n && !(r && typeof r == "object");
                var a = this.right._eval(e, o, t, i);
                if (a === this.right) return this;
                var s;
                switch (this.operator) {
                  case "&&":
                    s = r && a;
                    break;

                  case "||":
                    s = r || a;
                    break;

                  case "|":
                    s = r | a;
                    break;

                  case "&":
                    s = r & a;
                    break;

                  case "^":
                    s = r ^ a;
                    break;

                  case "+":
                    s = r + a;
                    break;

                  case "-":
                    s = r - a;
                    break;

                  case "*":
                    s = r * a;
                    break;

                  case "/":
                    s = r / a;
                    break;

                  case "%":
                    s = r % a;
                    break;

                  case "<<":
                    s = r << a;
                    break;

                  case ">>":
                    s = r >> a;
                    break;

                  case ">>>":
                    s = r >>> a;
                    break;

                  case "==":
                    s = r == a;
                    break;

                  case "===":
                    s = r === a;
                    break;

                  case "!=":
                    s = r != a;
                    break;

                  case "!==":
                    s = r !== a;
                    break;

                  case "<":
                    s = r < a;
                    break;

                  case "<=":
                    s = r <= a;
                    break;

                  case ">":
                    s = r > a;
                    break;

                  case ">=":
                    s = r >= a;
                    break;

                  case "in":
                    if (a && typeof a == "object" && ze(a, r)) {
                        s = true;
                        break;
                    }

                  default:
                    return this;
                }
                if (isNaN(s)) return e.find_parent(Ge) ? this : s;
                if (e.option("unsafe_math") && !n && s && typeof s == "number" && (this.operator == "+" || this.operator == "-")) {
                    var f = Math.max(0, u(r), u(a));
                    if (f < 16) return +s.toFixed(f);
                }
                return s;
                function u(e) {
                    var n = /(\.[0-9]*)?(e.+)?$/.exec(+e);
                    return (n[1] || ".").length - 1 - (n[2] || "").slice(1);
                }
            });
            e(jn, function(e, n, t, i) {
                var r = this.condition._eval(e, n, t, i);
                if (r === this.condition) return this;
                var o = r ? this.consequent : this.alternative;
                var a = o._eval(e, n, t, i);
                return a === o ? this : a;
            });
            function a(n, e) {
                var t = n.definition().escaped;
                switch (t.length) {
                  case 0:
                    return true;

                  case 1:
                    var i = false;
                    t[0].walk(new ft(function(e) {
                        if (i) return true;
                        if (e === n) return i = true;
                        if (e instanceof Xe) return true;
                    }));
                    return i;

                  default:
                    return e <= t.depth;
                }
            }
            e(Jn, function(e, n, t, i) {
                var r = this.fixed_value();
                if (!r) return this;
                var o;
                if (ze(r, "_eval")) {
                    o = r._eval();
                } else {
                    this._eval = Y;
                    o = r._eval(e, n, t, i);
                    delete this._eval;
                    if (o === r) return this;
                    r._eval = function() {
                        return o;
                    };
                    t.push(r);
                }
                return o && typeof o == "object" && !a(this, i) ? this : o;
            });
            var _ = {
                Array: Array,
                Math: Math,
                Number: Number,
                Object: Object,
                String: String
            };
            var p = t({
                Math: [ "E", "LN10", "LN2", "LOG2E", "LOG10E", "PI", "SQRT1_2", "SQRT2" ],
                Number: [ "MAX_VALUE", "MIN_VALUE", "NaN", "NEGATIVE_INFINITY", "POSITIVE_INFINITY" ]
            });
            var d = Oe("global ignoreCase multiline source");
            e(Tn, function(e, n, t, i) {
                if (e.option("unsafe")) {
                    var r;
                    var o = this.expression;
                    if (!X(o)) {
                        r = o._eval(e, n, t, i + 1);
                        if (r == null || r === o) return this;
                    }
                    var a = this.property;
                    if (a instanceof qe) {
                        a = a._eval(e, n, t, i);
                        if (a === this.property) return this;
                    }
                    if (r === undefined) {
                        var s = p[o.name];
                        if (!s || !s[a]) return this;
                        r = _[o.name];
                    } else if (r instanceof RegExp) {
                        if (!d[a]) return this;
                    } else if (typeof r == "object") {
                        if (!ze(r, a)) return this;
                    } else if (typeof r == "function") switch (a) {
                      case "name":
                        return r.node.name ? r.node.name.name : "";

                      case "length":
                        return r.node.argnames.length;

                      default:
                        return this;
                    }
                    return r[a];
                }
                return this;
            });
            e(kn, function(o, a, s, f) {
                var e = this.expression;
                var n = e instanceof Jn ? e.fixed_value() : e;
                if (n instanceof Qe) {
                    if (n.evaluating) return this;
                    if (n.name && n.name.definition().recursive_refs > 0) return this;
                    if (this.is_expr_pure(o)) return this;
                    var r = v(this.args);
                    if (!r && !a) return this;
                    var t = n.first_statement();
                    if (!(t instanceof on)) {
                        if (a) {
                            var i = false;
                            n.walk(new ft(function(e) {
                                if (i) return true;
                                if (e instanceof on) {
                                    if (e.value && e.value._eval(o, true, s, f) !== undefined) {
                                        i = true;
                                    }
                                    return true;
                                }
                                if (e instanceof Xe && e !== n) return true;
                            }));
                            if (!i) return;
                        }
                        return this;
                    }
                    var u = t.value;
                    if (!u) return;
                    var c = [];
                    if (!r || De(n.argnames, function(e, n) {
                        var t = r[n];
                        var i = e.definition();
                        if (i.orig[i.orig.length - 1] !== e) return false;
                        i.references.forEach(function(e) {
                            e._eval = function() {
                                return t;
                            };
                            c.push(e);
                        });
                        return true;
                    }) || a) {
                        n.evaluating = true;
                        u = u._eval(o, a, s, f);
                        delete n.evaluating;
                    }
                    c.forEach(function(e) {
                        delete e._eval;
                    });
                    return u === t.value ? this : u;
                } else if (o.option("unsafe") && e instanceof Tn) {
                    var l = e.property;
                    if (l instanceof qe) {
                        l = l._eval(o, a, s, f);
                        if (l === e.property) return this;
                    }
                    var u;
                    var p = e.expression;
                    if (X(p)) {
                        var d = b[p.name];
                        if (!d || !d[l]) return this;
                        u = _[p.name];
                    } else {
                        u = p._eval(o, a, s, f + 1);
                        if (u == null || u === p) return this;
                        var h = g[u.constructor.name];
                        if (!h || !h[l]) return this;
                        if (u instanceof RegExp && u.global && !(p instanceof Zn)) return this;
                    }
                    var r = v(this.args);
                    if (!r) return this;
                    if (l == "replace" && typeof r[1] == "function") return this;
                    try {
                        return u[l].apply(u, r);
                    } catch (e) {
                        qe.warn("Error evaluating {code} [{file}:{line},{col}]", {
                            code: this.print_to_string(),
                            file: this.start.file,
                            line: this.start.line,
                            col: this.start.col
                        });
                    } finally {
                        if (u instanceof RegExp) u.lastIndex = 0;
                    }
                }
                return this;
                function v(e) {
                    var n = [];
                    for (var t = 0; t < e.length; t++) {
                        var i = e[t];
                        var r = i._eval(o, a, s, f);
                        if (i === r) return;
                        n.push(r);
                    }
                    return n;
                }
            });
            e(En, Y);
        })(function(e, n) {
            e.DEFMETHOD("_eval", n);
        });
        (function(e) {
            function o(e) {
                return he(zn, e, {
                    operator: "!",
                    expression: e
                });
            }
            function r(e, n, t) {
                var i = o(e);
                if (t) {
                    var r = he(Pe, n, {
                        body: n
                    });
                    return Q(i, r) === r ? n : i;
                }
                return Q(i, n);
            }
            e(qe, function() {
                return o(this);
            });
            e(je, function() {
                throw new Error("Cannot negate a statement");
            });
            e(en, function() {
                return o(this);
            });
            e(zn, function() {
                if (this.operator == "!") return this.expression;
                return o(this);
            });
            e(Sn, function(e) {
                var n = this.expressions.slice();
                n.push(n.pop().negate(e));
                return V(this, n);
            });
            e(jn, function(e, n) {
                var t = this.clone();
                t.consequent = t.consequent.negate(e);
                t.alternative = t.alternative.negate(e);
                return r(this, t, n);
            });
            e(qn, function(e, n) {
                var t = this.clone(), i = this.operator;
                if (e.option("unsafe_comps")) {
                    switch (i) {
                      case "<=":
                        t.operator = ">";
                        return t;

                      case "<":
                        t.operator = ">=";
                        return t;

                      case ">=":
                        t.operator = "<";
                        return t;

                      case ">":
                        t.operator = "<=";
                        return t;
                    }
                }
                switch (i) {
                  case "==":
                    t.operator = "!=";
                    return t;

                  case "!=":
                    t.operator = "==";
                    return t;

                  case "===":
                    t.operator = "!==";
                    return t;

                  case "!==":
                    t.operator = "===";
                    return t;

                  case "&&":
                    t.operator = "||";
                    t.left = t.left.negate(e, n);
                    t.right = t.right.negate(e);
                    return r(this, t, n);

                  case "||":
                    t.operator = "&&";
                    t.left = t.left.negate(e, n);
                    t.right = t.right.negate(e);
                    return r(this, t, n);
                }
                return o(this);
            });
        })(function(e, t) {
            e.DEFMETHOD("negate", function(e, n) {
                return t.call(this, e, n);
            });
        });
        var r = Oe("Boolean decodeURI decodeURIComponent Date encodeURI encodeURIComponent Error escape EvalError isFinite isNaN Number Object parseFloat parseInt RangeError ReferenceError String SyntaxError TypeError unescape URIError");
        kn.DEFMETHOD("is_expr_pure", function(e) {
            if (e.option("unsafe")) {
                var n = this.expression;
                if (X(n) && r[n.name]) return true;
                if (n instanceof On && X(n.expression)) {
                    var t = b[n.expression.name];
                    return t && (t[n.property] || n.expression.name == "Math" && n.property == "random");
                }
            }
            return this.pure || !e.pure_funcs(this);
        });
        qe.DEFMETHOD("is_call_pure", Ee);
        kn.DEFMETHOD("is_call_pure", function(e) {
            if (!e.option("unsafe")) return false;
            var n = this.expression;
            if (!(n instanceof On)) return false;
            var t = n.expression;
            var i;
            var r = n.property;
            if (t instanceof Cn) {
                i = g.Array;
            } else if (t.is_boolean(e)) {
                i = g.Boolean;
            } else if (t.is_number(e)) {
                i = g.Number;
            } else if (t instanceof Zn) {
                i = g.RegExp;
            } else if (t.is_string(e)) {
                i = g.String;
                if (r == "replace") {
                    var o = this.args[1];
                    if (o && !o.is_string(e)) return false;
                }
            } else if (!n.may_throw_on_access(e)) {
                i = g.Object;
            }
            return i && i[r];
        });
        (function(e) {
            function n(e, n) {
                for (var t = e.length; --t >= 0; ) if (e[t].has_side_effects(n)) return true;
                return false;
            }
            e(qe, se);
            e(Cn, function(e) {
                return n(this.elements, e);
            });
            e(Mn, function(e) {
                var n = this.left;
                if (!(n instanceof Tn)) return true;
                var t = n.expression;
                return !(t instanceof Gn) || !t.scope.new || n instanceof Dn && n.property.has_side_effects(e) || this.right.has_side_effects(e);
            });
            e(qn, function(e) {
                return this.left.has_side_effects(e) || this.right.has_side_effects(e) || this.operator == "in" && !we(this.right);
            });
            e(Ie, function(e) {
                return n(this.body, e);
            });
            e(kn, function(e) {
                if (!this.is_expr_pure(e) && (!this.is_call_pure(e) || this.expression.has_side_effects(e))) {
                    return true;
                }
                return n(this.args, e);
            });
            e(hn, function(e) {
                return this.expression.has_side_effects(e) || n(this.body, e);
            });
            e(jn, function(e) {
                return this.condition.has_side_effects(e) || this.consequent.has_side_effects(e) || this.alternative.has_side_effects(e);
            });
            e(Xn, Ee);
            e(gn, function(e) {
                return n(this.definitions, e);
            });
            e(On, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.has_side_effects(e);
            });
            e(Fe, Ee);
            e(cn, function(e) {
                return this.condition.has_side_effects(e) || this.body && this.body.has_side_effects(e) || this.alternative && this.alternative.has_side_effects(e);
            });
            e(Ue, function(e) {
                return this.body.has_side_effects(e);
            });
            e(Qe, Ee);
            e(Fn, function(e) {
                return n(this.properties, e);
            });
            e(Pn, function(e) {
                return this.value.has_side_effects(e);
            });
            e(Dn, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.has_side_effects(e) || this.property.has_side_effects(e);
            });
            e(Sn, function(e) {
                return n(this.expressions, e);
            });
            e(Pe, function(e) {
                return this.body.has_side_effects(e);
            });
            e(ln, function(e) {
                return this.expression.has_side_effects(e) || n(this.body, e);
            });
            e(In, Ee);
            e(Jn, function(e) {
                return !(this.is_declared(e) && De(this.definition().orig, function(e) {
                    return !(e instanceof Rn || e instanceof Un);
                }));
            });
            e(Gn, Ee);
            e(vn, function(e) {
                return n(this.body, e) || this.bcatch && this.bcatch.has_side_effects(e) || this.bfinally && this.bfinally.has_side_effects(e);
            });
            e(An, function(e) {
                return T[this.operator] || this.expression.has_side_effects(e);
            });
            e(xn, function(e) {
                return this.value;
            });
        })(function(e, n) {
            e.DEFMETHOD("has_side_effects", n);
        });
        (function(e) {
            e(qe, se);
            e(Xn, Ee);
            e(Fe, Ee);
            e(Qe, Ee);
            e(In, Ee);
            e(Gn, Ee);
            function n(e, n) {
                for (var t = e.length; --t >= 0; ) if (e[t].may_throw(n)) return true;
                return false;
            }
            e(Cn, function(e) {
                return n(this.elements, e);
            });
            e(Mn, function(e) {
                if (this.right.may_throw(e)) return true;
                if (!e.has_directive("use strict") && this.operator == "=" && this.left instanceof Jn) {
                    return false;
                }
                return this.left.may_throw(e);
            });
            e(qn, function(e) {
                return this.left.may_throw(e) || this.right.may_throw(e) || this.operator == "in" && !we(this.right);
            });
            e(Ie, function(e) {
                return n(this.body, e);
            });
            e(kn, function(e) {
                if (n(this.args, e)) return true;
                if (this.is_expr_pure(e)) return false;
                if (this.expression.may_throw(e)) return true;
                return !(this.expression instanceof Qe) || n(this.expression.body, e);
            });
            e(hn, function(e) {
                return this.expression.may_throw(e) || n(this.body, e);
            });
            e(jn, function(e) {
                return this.condition.may_throw(e) || this.consequent.may_throw(e) || this.alternative.may_throw(e);
            });
            e(gn, function(e) {
                return n(this.definitions, e);
            });
            e(On, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.may_throw(e);
            });
            e(cn, function(e) {
                return this.condition.may_throw(e) || this.body && this.body.may_throw(e) || this.alternative && this.alternative.may_throw(e);
            });
            e(Ue, function(e) {
                return this.body.may_throw(e);
            });
            e(Fn, function(e) {
                return n(this.properties, e);
            });
            e(Pn, function(e) {
                return this.value.may_throw(e);
            });
            e(on, function(e) {
                return this.value && this.value.may_throw(e);
            });
            e(Sn, function(e) {
                return n(this.expressions, e);
            });
            e(Pe, function(e) {
                return this.body.may_throw(e);
            });
            e(Dn, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.may_throw(e) || this.property.may_throw(e);
            });
            e(ln, function(e) {
                return this.expression.may_throw(e) || n(this.body, e);
            });
            e(Jn, function(e) {
                return !this.is_declared(e);
            });
            e(vn, function(e) {
                return (this.bcatch ? this.bcatch.may_throw(e) : n(this.body, e)) || this.bfinally && this.bfinally.may_throw(e);
            });
            e(An, function(e) {
                if (this.operator == "typeof" && this.expression instanceof Jn) return false;
                return this.expression.may_throw(e);
            });
            e(xn, function(e) {
                if (!this.value) return false;
                return this.value.may_throw(e);
            });
        })(function(e, n) {
            e.DEFMETHOD("may_throw", n);
        });
        (function(e) {
            function n(e) {
                for (var n = e.length; --n >= 0; ) if (!e[n].is_constant_expression()) return false;
                return true;
            }
            e(qe, Ee);
            e(Cn, function() {
                return n(this.elements);
            });
            e(qn, function() {
                return this.left.is_constant_expression() && this.right.is_constant_expression() && (this.operator != "in" || we(this.right));
            });
            e(Xn, se);
            e(Qe, function(r) {
                var o = this;
                var a = true;
                var s = [];
                o.walk(new ft(function(e, n) {
                    if (!a) return true;
                    if (e instanceof Ne) {
                        if (e === o) return;
                        s.push(e);
                        n();
                        s.pop();
                        return true;
                    }
                    if (e instanceof Jn) {
                        if (o.inlined || e.redef) {
                            a = false;
                            return true;
                        }
                        if (o.variables.has(e.name)) return true;
                        var t = e.definition();
                        if (ke(t.scope, s)) return true;
                        if (r && !t.redefined()) {
                            var i = r.find_variable(e);
                            if (t.undeclared ? !i : i === t) {
                                a = "f";
                                return true;
                            }
                        }
                        a = false;
                        return true;
                    }
                }));
                return a;
            });
            e(Fn, function() {
                return n(this.properties);
            });
            e(Pn, function() {
                return this.value.is_constant_expression();
            });
            e(An, function() {
                return this.expression.is_constant_expression();
            });
        })(function(e, n) {
            e.DEFMETHOD("is_constant_expression", n);
        });
        function q(e) {
            return e && e.aborts();
        }
        (function(e) {
            e(je, fe);
            e(tn, Y);
            function n() {
                var e = this.body.length;
                return e > 0 && q(this.body[e - 1]);
            }
            e(Re, n);
            e(pn, n);
            e(cn, function() {
                return this.alternative && q(this.body) && q(this.alternative) && this;
            });
        })(function(e, n) {
            e.DEFMETHOD("aborts", n);
        });
        var s = Oe([ "use asm", "use strict" ]);
        e(Ce, function(e, n) {
            if (n.option("directives") && (!s[e.value] || n.has_directive(e.value) !== e)) {
                return he(Fe, e);
            }
            return e;
        });
        e(Me, function(e, n) {
            if (n.option("drop_debugger")) return he(Fe, e);
            return e;
        });
        e(Ue, function(e, n) {
            if (n.option("dead_code") && e.body instanceof fn && n.loopcontrol_target(e.body) === e.body) {
                return he(Fe, e);
            }
            return n.option("unused") && e.label.references.length == 0 ? e.body : e;
        });
        e(Ie, function(e, n) {
            e.body = c(e.body, n);
            return e;
        });
        function f(e) {
            switch (e.body.length) {
              case 0:
                return he(Fe, e);

              case 1:
                var n = e.body[0];
                if (!(n instanceof bn || n instanceof yn)) return n;
            }
            return e;
        }
        e(Re, function(e, n) {
            e.body = c(e.body, n);
            return f(e);
        });
        e(en, function(n, e) {
            n.body = c(n.body, e);
            if (e.option("inline")) for (var t = 0; t < n.body.length; t++) {
                var i = n.body[t];
                if (i instanceof Ce) continue;
                if (i instanceof on) {
                    var r = i.value;
                    if (!r || r.TYPE != "Call") break;
                    if (r.is_expr_pure(e)) break;
                    var o = r.expression;
                    if (o instanceof Jn) {
                        if (n.name && n.name.definition() === o.definition()) break;
                        o = o.fixed_value();
                    }
                    if (!(o instanceof Qe)) break;
                    if (o.uses_arguments) break;
                    if (o === r.expression) {
                        if (o.parent_scope !== n) break;
                        if (!De(o.enclosed, function(e) {
                            return e.scope !== n;
                        })) break;
                    }
                    if (o.contains_this()) break;
                    var a = o.argnames.length;
                    if (a > 0 && e.option("inline") < 2) break;
                    if (a > n.argnames.length) break;
                    for (var s = 0; s < a; s++) {
                        var f = r.args[s];
                        if (!(f instanceof Jn)) break;
                        if (f.definition() !== n.argnames[s].definition()) break;
                    }
                    if (s < a) break;
                    for (;s < r.args.length; s++) {
                        if (r.args[s].has_side_effects(e)) break;
                    }
                    if (s < r.args.length) break;
                    if (a < n.argnames.length && !e.drop_fargs(n, e.parent())) {
                        if (!e.drop_fargs(o, r)) break;
                        do {
                            var u = he(Yn, o, {
                                name: o.make_var_name("argument_" + a),
                                scope: o
                            });
                            o.argnames.push(u);
                            o.enclosed.push(o.def_variable(u));
                        } while (++a < n.argnames.length);
                    }
                    return r.expression;
                }
                break;
            }
            return n;
        });
        Xe.DEFMETHOD("merge_variables", function(o) {
            if (!o.option("merge_vars")) return;
            var u = this, c = {}, l;
            var a = [], s = [], f = 0;
            var p = new Ae();
            var d = Object.create(null);
            var h = Object.create(null);
            var v = new ft(function(e, n) {
                if (e instanceof Mn) {
                    var t = e.left;
                    if (!(t instanceof Jn)) return;
                    if (e.operator != "=") k(t, true, false);
                    e.right.walk(v);
                    k(t, false, true);
                    return true;
                }
                if (e instanceof qn) {
                    if (!ge[e.operator]) return;
                    e.left.walk(v);
                    w();
                    e.right.walk(v);
                    x();
                    return true;
                }
                if (e instanceof jn) {
                    e.condition.walk(v);
                    w();
                    e.consequent.walk(v);
                    x();
                    w();
                    e.alternative.walk(v);
                    x();
                    return true;
                }
                if (e instanceof bn) {
                    e.definitions.forEach(function(e) {
                        d[e.name.definition().id] = false;
                        e.value.walk(v);
                    });
                    return true;
                }
                if (e instanceof un) {
                    var i = v.loopcontrol_target(e);
                    if (!(i instanceof Le)) return true;
                    var r = [];
                    while (!ze(c, "block") || c.block !== i) {
                        r.push(c);
                        x();
                    }
                    c.loop = "c";
                    w();
                    while (r.length) {
                        var o = r.pop();
                        w();
                        if (ze(o, "block")) c.block = o.block;
                        if (ze(o, "loop")) c.loop = o.loop;
                    }
                    return true;
                }
                if (e instanceof Le) {
                    w();
                    c.block = e;
                    c.loop = true;
                    var a = c;
                    e.body.walk(v);
                    if (c.loop == "c") c = a;
                    e.condition.walk(v);
                    x();
                    return true;
                }
                if (e instanceof We) {
                    if (e.init) e.init.walk(v);
                    w();
                    c.block = e;
                    c.loop = true;
                    if (e.condition) e.condition.walk(v);
                    e.body.walk(v);
                    if (e.step) e.step.walk(v);
                    x();
                    return true;
                }
                if (e instanceof Je) {
                    e.object.walk(v);
                    w();
                    c.block = e;
                    c.loop = true;
                    e.init.walk(v);
                    e.body.walk(v);
                    x();
                    return true;
                }
                if (e instanceof cn) {
                    e.condition.walk(v);
                    w();
                    e.body.walk(v);
                    x();
                    if (e.alternative) {
                        w();
                        e.alternative.walk(v);
                        x();
                    }
                    return true;
                }
                if (e instanceof Ue) {
                    w();
                    c.block = e;
                    e.body.walk(v);
                    x();
                    return true;
                }
                if (e instanceof yn) {
                    e.definitions.forEach(function(e) {
                        d[e.name.definition().id] = false;
                        if (e.value) e.value.walk(v);
                    });
                    return true;
                }
                if (e instanceof Xe) {
                    w();
                    c.block = e;
                    if (e === u) l = c;
                    if (e instanceof Qe) {
                        if (e.name) d[e.name.definition().id] = false;
                        if (e.uses_arguments && !v.has_directive("use strict")) e.argnames.forEach(function(e) {
                            d[e.definition().id] = false;
                        });
                    }
                    n();
                    x();
                    return true;
                }
                if (e instanceof ln) {
                    e.expression.walk(v);
                    var a = c;
                    e.body.forEach(function(e) {
                        if (e instanceof dn) return;
                        e.expression.walk(v);
                        if (a === c) w();
                    });
                    c = a;
                    e.body.forEach(function(e) {
                        w();
                        He(e, v);
                        x();
                    });
                    return true;
                }
                if (e instanceof Yn) {
                    if (!e.__unused) k(e, false, true);
                    return true;
                }
                if (e instanceof Jn) {
                    k(e, true, false);
                    return true;
                }
                if (e instanceof vn) {
                    w();
                    c.block = e;
                    He(e, v);
                    x();
                    if (e.bcatch) {
                        if (e.bcatch.argname) {
                            var s = e.bcatch.argname.definition();
                            d[s.id] = false;
                            if (s = s.redefined()) d[s.id] = false;
                        }
                        w();
                        if (e.bfinally) c.block = e.bcatch;
                        He(e.bcatch, v);
                        x();
                    }
                    if (e.bfinally) e.bfinally.walk(v);
                    return true;
                }
                if (e instanceof An) {
                    if (!be[e.operator]) return;
                    var t = e.expression;
                    if (!(t instanceof Jn)) return;
                    k(t, true, true);
                    return true;
                }
                if (e instanceof xn) {
                    if (e.value) {
                        e.value.walk(v);
                        k(e.name, false, true);
                    } else {
                        var f = e.name.definition().id;
                        if (!(f in d)) {
                            p.add(f, e.name);
                        } else if (d[f]) {
                            d[f].push(e.name);
                        }
                    }
                    return true;
                }
                if (e instanceof Ve) {
                    w();
                    c.block = e;
                    c.loop = true;
                    n();
                    x();
                    return true;
                }
            });
            v.directives = Object.create(o.directives);
            u.walk(v);
            var e = Object.create(null);
            while (a.length && s.length) {
                var n = a.pop();
                var t = n.definition;
                if (!(t.id in h)) continue;
                if (!d[t.id]) continue;
                var i = {
                    start: d[t.id].start
                };
                while (t.id in e) t = e[t.id];
                i.end = d[t.id].end;
                var r = [];
                do {
                    var _ = s.pop();
                    if (!_) continue;
                    if (_.index > n.index) continue;
                    var m = _.definition.id;
                    var g = d[m];
                    if (!g) continue;
                    if (i.start.block !== g.start.block || !S(i, g) || i.start.loop && !S(g, i) || !De(g, function(e) {
                        return e.scope.find_variable(t.name) === t;
                    })) {
                        r.unshift(_);
                        continue;
                    }
                    var b = [], y = [];
                    g.forEach(function(e) {
                        e.thedef = t;
                        e.name = t.name;
                        if (e instanceof Jn) {
                            y.push(e);
                        } else {
                            b.push(e);
                        }
                    });
                    t.orig = b.concat(t.orig);
                    t.references = y.concat(t.references);
                    t.fixed = _.definition.fixed && t.fixed;
                    e[m] = t;
                    break;
                } while (s.length);
                if (r.length) s = s.concat(r);
            }
            function w() {
                c = Object.create(c);
            }
            function x() {
                c = Object.getPrototypeOf(c);
            }
            function k(e, n, t) {
                var i = e.definition();
                if (i.id in d) {
                    var r = d[i.id];
                    if (!r) return;
                    if (r.start.block !== c.block) return d[i.id] = false;
                    r.push(e);
                    r.end = c;
                    if (i.id in h) {
                        s[h[i.id]] = null;
                    } else if (!n) {
                        return;
                    }
                } else if (u.variables.get(i.name) !== i || o.exposed(i) || e.name == "arguments") {
                    return d[i.id] = false;
                } else {
                    var r = p.get(i.id) || [];
                    r.push(e);
                    d[i.id] = r;
                    if (!n) {
                        r.start = c;
                        return a.push({
                            index: f++,
                            definition: i
                        });
                    }
                    if (c.block !== u) return d[i.id] = false;
                    r.start = l;
                }
                h[i.id] = s.length;
                s.push({
                    index: f++,
                    definition: i
                });
            }
            function E(e, n) {
                return e === n || e.isPrototypeOf(n);
            }
            function S(e, n) {
                return E(e.start, e.end) || E(e.start, n.start);
            }
        });
        Xe.DEFMETHOD("drop_unused", function(y) {
            if (!y.option("unused")) return;
            var w = this;
            var x = !(w instanceof Ke) || y.toplevel.funcs;
            var k = !(w instanceof Ke) || y.toplevel.vars;
            var E = /keep_assign/.test(y.option("unused")) ? Ee : function(e, n) {
                var t;
                if (e instanceof Mn) {
                    if (e.write_only || e.operator == "=") t = e.left;
                } else if (e instanceof An) {
                    if (e.write_only) t = e.expression;
                }
                if (/strict/.test(y.option("pure_getters"))) {
                    while (t instanceof Tn && !t.expression.may_throw_on_access(y)) {
                        if (t instanceof Dn) n.unshift(t.property);
                        t = t.expression;
                    }
                }
                if (!(t instanceof Jn)) return;
                if (y.exposed(t.definition())) return;
                if (!De(t.definition().orig, function(e) {
                    return !(e instanceof Rn || e instanceof Vn || e instanceof Un);
                })) return;
                return t;
            };
            var S = Object.create(null);
            var T = Object.create(null);
            var p = [];
            var O = Object.create(null);
            var d = Object.create(null);
            var h = Object.create(null);
            if (w instanceof Ke && y.top_retain) {
                w.variables.each(function(e) {
                    if (y.top_retain(e) && !(e.id in O)) {
                        O[e.id] = true;
                        p.push(e);
                    }
                });
            }
            var v = new Ae();
            var D = new Ae();
            var _ = new Ae();
            var A = this;
            var m = new ft(function(i, e) {
                if (i instanceof Qe && i.uses_arguments && !m.has_directive("use strict")) {
                    i.argnames.forEach(function(e) {
                        var n = e.definition();
                        if (!(n.id in O)) {
                            O[n.id] = true;
                            p.push(n);
                        }
                    });
                }
                if (i === w) return;
                if (A === w) {
                    if (i instanceof nn) {
                        var n = i.name.definition();
                        if (!x && !(n.id in O)) {
                            O[n.id] = true;
                            p.push(n);
                        }
                        _.add(n.id, i);
                        return true;
                    }
                    if (i instanceof gn) {
                        i.definitions.forEach(function(e) {
                            var n = e.name.definition();
                            D.add(n.id, e);
                            if (i instanceof wn && n.orig[0] instanceof Wn) {
                                var t = n.redefined();
                                if (t) D.add(t.id, e);
                            }
                            if ((!k || (i instanceof bn ? n.redefined() : n.const_redefs)) && !(n.id in O)) {
                                O[n.id] = true;
                                p.push(n);
                            }
                            if (!e.value) return;
                            if (e.value.has_side_effects(y)) {
                                e.value.walk(m);
                            } else {
                                _.add(n.id, e.value);
                            }
                            v.add(n.id, e);
                        });
                        return true;
                    }
                    if (i instanceof Yn) {
                        var n = i.definition();
                        D.add(n.id, i);
                        v.add(n.id, i);
                        return true;
                    }
                }
                return t(i, e, true);
            });
            m.directives = Object.create(y.directives);
            w.walk(m);
            m = new ft(t);
            for (var e = 0; e < p.length; e++) {
                var n = _.get(p[e].id);
                if (n) n.forEach(function(e) {
                    e.walk(m);
                });
            }
            Object.keys(S).forEach(function(e) {
                var t = S[e];
                if (!t) {
                    delete S[e];
                    return;
                }
                t = t.reduce(function(n, e) {
                    e.forEach(function(e) {
                        ue(n, e);
                    });
                    return n;
                }, []);
                var n = (v.get(e) || []).filter(function(n) {
                    return oe(n instanceof An ? function(e) {
                        return e === n;
                    } : function(e) {
                        if (e === n) return true;
                        if (e instanceof An) return false;
                        return me(e) === me(n);
                    }, t);
                });
                if (t.length == n.length) {
                    S[e] = n;
                } else {
                    delete S[e];
                }
            });
            var z = y.option("keep_fnames") ? Ee : y.option("ie8") ? function(e) {
                return !y.exposed(e) && e.references.length == e.replaced;
            } : function(e) {
                return !(e.id in O) || e.orig.length > 1;
            };
            var $ = [];
            var q = [];
            var j = [];
            var M = new ht(function(c, e, n) {
                var l = M.parent();
                if (k) {
                    var t = [], i = E(c, t);
                    if (i) {
                        var r = i.definition();
                        var o = r.id in O;
                        var a;
                        if (c instanceof Mn) {
                            if (!o || c.left === i && N(r, c) < 0) {
                                a = I(c);
                                if (c.write_only === true) {
                                    a = a.drop_side_effect_free(y) || he(Qn, c, {
                                        value: 0
                                    });
                                }
                            }
                        } else if (!o || c.expression === i && N(r, c) < 0) {
                            a = he(Qn, c, {
                                value: 0
                            });
                        }
                        if (a) {
                            if (l instanceof Sn && l.tail_node() !== c) {
                                a = a.drop_side_effect_free(y);
                            }
                            if (a) t.push(a);
                            switch (t.length) {
                              case 0:
                                return Se.skip;

                              case 1:
                                return ve(y, l, c, t[0].transform(M));

                              default:
                                return V(c, t.map(function(e) {
                                    return e.transform(M);
                                }));
                            }
                        }
                    } else if (c instanceof $n && c.expression instanceof Jn && N(c.expression.definition(), c) < 0) {
                        return he(zn, c, {
                            operator: "+",
                            expression: c.expression
                        });
                    }
                }
                if (c instanceof kn) q.push(c);
                if (A !== w) return;
                if (c instanceof Qe) {
                    if (x && c !== w && c instanceof nn) {
                        var r = c.name.definition();
                        if (!(r.id in O)) {
                            C(c.name, "Dropping unused function {name}");
                            r.eliminated++;
                            return n ? Se.skip : he(Fe, c);
                        }
                    }
                    if (c instanceof en && c.name && z(c.name.definition())) {
                        $.push(c);
                    }
                    if (!(c instanceof Ze)) {
                        var s = y.drop_fargs(c, l);
                        for (var f = c.argnames, u = f.length; --u >= 0; ) {
                            var i = f[u];
                            var r = i.definition();
                            if (r.id in O) {
                                s = false;
                                if (N(r, i) < 0) i.__unused = null;
                            } else {
                                i.__unused = true;
                                if (s) {
                                    C(i, "Dropping unused function argument {name}");
                                    f.pop();
                                }
                            }
                        }
                        j.push(c);
                    }
                }
                if (c instanceof gn && !(l instanceof Je && l.init === c)) {
                    var p = [], d = [], h = [];
                    var v = [];
                    var _ = 0;
                    c.definitions.forEach(function(n) {
                        if (n.value) n.value = n.value.transform(M);
                        var e = n.name.definition();
                        if (!k || e.id in O) {
                            if (n.value && N(e, n) < 0) {
                                var t = n.value.write_only;
                                var i = n.value.drop_side_effect_free(y);
                                if (n.value !== i) {
                                    n.value = i && V(n.value, [ i, he(Qn, n.value, {
                                        value: 0
                                    }) ]);
                                } else if (n.value.write_only !== t) {
                                    n.value.write_only = t;
                                }
                            }
                            var r, o = D.get(e.id);
                            if (!n.value) {
                                if (o.length > 1) {
                                    qe.warn("Dropping duplicated declaration of variable {name} [{file}:{line},{col}]", F(n.name));
                                    Te(o, n);
                                    e.eliminated++;
                                } else {
                                    d.push(n);
                                }
                            } else if (y.option("functions") && !y.option("ie8") && !(c instanceof bn || c instanceof yn) && o.length == 1 && e.assignments == 0 && n.value instanceof en && (e.references.length ? De(e.references, function(e) {
                                return n.value === e.fixed_value();
                            }) : n.value === n.name.fixed_value()) && (!n.value.name || (r = n.value.name.definition()).assignments == 0 && (r.name == n.name.name || De(r.references, function(e) {
                                return e.scope.find_variable(n.name) === n.name.definition();
                            }))) && u() && f(n.value, n.name.name)) {
                                qe.warn("Declaring {name} as function [{file}:{line},{col}]", F(n.name));
                                var a = he(nn, n, n.value);
                                a.name = he(Ln, n.name, n.name);
                                var s = n.name.scope.resolve().def_function(a.name);
                                if (r) r.references.forEach(function(e) {
                                    e.name = s.name;
                                    e.thedef = s;
                                    e.reference({});
                                });
                                p.push(a);
                            } else {
                                if (o.length > 1 && e.orig.indexOf(n.name) > e.eliminated) {
                                    Te(o, n);
                                    _++;
                                }
                                if (v.length > 0) {
                                    if (h.length > 0) {
                                        v.push(n.value);
                                        n.value = V(n.value, v);
                                    } else {
                                        p.push(he(Pe, c, {
                                            body: V(c, v)
                                        }));
                                    }
                                    v = [];
                                }
                                h.push(n);
                            }
                        } else if (e.orig[0] instanceof Wn && e.scope.resolve() === n.name.scope.resolve()) {
                            var i = n.value && n.value.drop_side_effect_free(y);
                            if (i) v.push(i);
                            var o = D.get(e.id);
                            if (o.length > 1) {
                                qe.warn("Dropping duplicated declaration of variable {name} [{file}:{line},{col}]", F(n.name));
                                Te(o, n);
                                e.eliminated++;
                            } else {
                                n.value = null;
                                d.push(n);
                            }
                        } else {
                            var i = n.value && !n.value.single_use && n.value.drop_side_effect_free(y);
                            if (i) {
                                qe.warn("Side effects in initialization of unused variable {name} [{file}:{line},{col}]", F(n.name));
                                v.push(i);
                            } else {
                                C(n.name, "Dropping unused variable {name}");
                            }
                            e.eliminated++;
                        }
                        function f(e, n) {
                            var t = e.variables.get(n);
                            return !t || e.name && t === e.name.definition();
                        }
                        function u() {
                            if (y.has_directive("use strict")) return l instanceof Xe;
                            return l instanceof Ie || l instanceof We && l.init === c || l instanceof cn;
                        }
                    });
                    switch (d.length) {
                      case 0:
                        if (h.length == 0) break;
                        if (h.length == _) {
                            [].unshift.apply(v, h.map(function(e) {
                                qe.warn("Dropping duplicated definition of variable {name} [{file}:{line},{col}]", F(e.name));
                                var n = e.name.definition();
                                var t = he(Jn, e.name, e.name);
                                n.references.push(t);
                                var i = he(Mn, e, {
                                    operator: "=",
                                    left: t,
                                    right: e.value
                                });
                                var r = N(n, e);
                                if (r >= 0) S[n.id][r] = i;
                                n.eliminated++;
                                return i;
                            }));
                            break;
                        }

                      case 1:
                        if (h.length == 0) {
                            var m = d[0].name.definition().id;
                            if (m in T) {
                                c.definitions = d;
                                T[m].init = c;
                                break;
                            }
                        }

                      default:
                        c.definitions = d.concat(h);
                        p.push(c);
                    }
                    if (v.length > 0) {
                        p.push(he(Pe, c, {
                            body: V(c, v)
                        }));
                    }
                    return P(p, c, n);
                }
                if (c instanceof Ue && c.body instanceof We) {
                    e(c, M);
                    if (c.body instanceof Re) {
                        var g = c.body;
                        c.body = g.body.pop();
                        g.body.push(c);
                        return n ? Se.splice(g.body) : g;
                    }
                    return c;
                }
                if (c instanceof Xe) {
                    var b = A;
                    A = c;
                    e(c, M);
                    A = b;
                    return c;
                }
            }, function(e, n) {
                if (e instanceof Re) switch (e.body.length) {
                  case 0:
                    return n ? Se.skip : he(Fe, e);

                  case 1:
                    var t = e.body[0];
                    if (!(t instanceof bn || t instanceof yn)) return t;
                } else if (e instanceof We) {
                    var i;
                    if (e.init instanceof Re) {
                        i = e.init;
                        e.init = i.body.pop();
                        i.body.push(e);
                    }
                    if (e.init instanceof nn) {
                        if (!i) {
                            i = he(Re, e, {
                                body: [ e ]
                            });
                        }
                        i.body.splice(-1, 0, e.init);
                        e.init = null;
                    } else if (e.init instanceof Pe) {
                        e.init = e.init.body;
                    } else if (J(e.init)) {
                        e.init = null;
                    }
                    return !i ? e : n ? Se.splice(i.body) : i;
                } else if (e instanceof Je) {
                    if (!k || !y.option("loops")) return;
                    if (!J(e.body)) return;
                    var r = e.init;
                    if (r instanceof gn) {
                        r = r.definitions[0].name;
                    } else while (r instanceof Tn) {
                        r = r.expression.tail_node();
                    }
                    var o = r.definition();
                    if (!o) return;
                    if (o.id in O) return;
                    if (o.scope !== w && w.find_variable(r) === o) return;
                    C(r, "Dropping unused loop variable {name}");
                    if (T[o.id] === e) delete T[o.id];
                    var a = [];
                    var s = e.object.drop_side_effect_free(y);
                    if (s) {
                        qe.warn("Side effects in object of for-in loop [{file}:{line},{col}]", s.start);
                        a.push(he(Pe, e, {
                            body: s
                        }));
                    }
                    if (e.init instanceof gn && o.orig[0] instanceof Wn) {
                        a.push(e.init);
                    }
                    return P(a, e, n);
                } else if (e instanceof Sn) {
                    if (e.expressions.length == 1) return e.expressions[0];
                }
            });
            M.push(y.parent());
            w.transform(M);
            if (w instanceof Qe && w.body.length == 1 && w.body[0] instanceof Ce && w.body[0].value == "use strict") {
                w.body.length = 0;
            }
            $.forEach(function(e) {
                e.name = null;
            });
            q.forEach(function(e) {
                ie(e, y, j);
            });
            function C(e, n) {
                qe[e.definition().references.length > 0 ? "info" : "warn"](n + " [{file}:{line},{col}]", F(e));
            }
            function F(e) {
                return {
                    name: e.name,
                    file: e.start.file,
                    line: e.start.line,
                    col: e.start.col
                };
            }
            function P(e, n, t) {
                switch (e.length) {
                  case 0:
                    return t ? Se.skip : he(Fe, n);

                  case 1:
                    return e[0];

                  default:
                    return t ? Se.splice(e) : he(Re, n, {
                        body: e
                    });
                }
            }
            function g(e, n) {
                if (e.scope !== w) return false;
                if (!e.fixed || !n.fixed) S[e.id] = false;
                return S[e.id] !== false;
            }
            function b(e, n) {
                if (!S[e.id]) S[e.id] = [];
                if (n.fixed.assigns) ue(S[e.id], n.fixed.assigns);
            }
            function N(e, n) {
                var t = S[e.id];
                return t && t.indexOf(n);
            }
            function H(e, n, t) {
                if (e.id in O) return;
                if (n && t) {
                    O[e.id] = true;
                    p.push(e);
                } else {
                    d[e.id] = n;
                    h[e.id] = t;
                }
            }
            function I(e) {
                var n = e.right;
                if (!e.write_only) return n;
                if (!(n instanceof qn && ge[n.operator])) return n;
                if (!(n.left instanceof Jn)) return n;
                if (!(e.left instanceof Jn)) return n;
                var t = e.left.definition();
                if (n.left.definition() !== t) return n;
                if (n.right.has_side_effects(y)) return n;
                if (g(t, n.left)) b(t, n.left);
                return n.right;
            }
            function t(e, n, t) {
                if (e instanceof Mn && e.left instanceof Jn) {
                    var i = e.left.definition();
                    if (i.scope === w) v.add(i.id, e);
                }
                if (e instanceof An && e.expression instanceof Jn) {
                    var i = e.expression.definition();
                    if (i.scope === w) v.add(i.id, e);
                }
                var r, o = [], a = E(e, o);
                if (a && w.variables.get(a.name) === (r = a.definition())) {
                    o.forEach(function(e) {
                        e.walk(m);
                    });
                    if (e instanceof Mn) {
                        if (e.write_only === "p" && e.right.may_throw_on_access(y)) return;
                        var s = I(e);
                        if (t && e.write_only === true && r.scope === w && !s.has_side_effects(y)) {
                            _.add(r.id, s);
                        } else {
                            s.walk(m);
                        }
                        if (e.left === a) {
                            if (!e.write_only) {
                                H(r, true, h[r.id]);
                            }
                        } else {
                            var f = a.fixed_value();
                            if (!f || !f.is_constant()) {
                                H(r, d[r.id], true);
                            }
                        }
                    }
                    if (g(r, a) && ye(a, e) !== a) b(r, a);
                    return true;
                }
                if (e instanceof Je) {
                    if (e.init instanceof Jn && A === w) {
                        var u = e.init.definition().id;
                        if (!(u in T)) T[u] = e;
                    }
                    if (!k || !y.option("loops")) return;
                    if (!J(e.body)) return;
                    if (e.init.has_side_effects(y)) return;
                    e.object.walk(m);
                    return true;
                }
                if (e instanceof Jn) {
                    r = e.definition();
                    if (!(r.id in O)) {
                        O[r.id] = true;
                        p.push(r);
                    }
                    if (R(r.scope, e.scope)) {
                        var c = r.redefined();
                        if (c && !(c.id in O)) {
                            O[c.id] = true;
                            p.push(c);
                        }
                    }
                    if (g(r, e)) b(r, e);
                    return true;
                }
                if (e instanceof Xe) {
                    var l = A;
                    A = e;
                    n();
                    A = l;
                    return true;
                }
            }
        });
        Xe.DEFMETHOD("hoist_declarations", function(r) {
            if (r.has_directive("use asm")) return;
            var o = r.option("hoist_funs");
            var a = r.option("hoist_vars");
            var s = this;
            if (a) {
                var n = 0;
                s.walk(new ft(function(e) {
                    if (n > 1) return true;
                    if (e instanceof Xe && e !== s) return true;
                    if (e instanceof wn) {
                        n++;
                        return true;
                    }
                }));
                if (n <= 1) a = false;
            }
            if (!o && !a) return;
            var f = [];
            var u = [];
            var c = new Ae(), l = 0;
            var p = new ht(function(e) {
                if (e === s) return;
                if (e instanceof Ce) {
                    f.push(e);
                    return he(Fe, e);
                }
                if (o && e instanceof nn && (p.parent() === s || !r.has_directive("use strict"))) {
                    u.push(e);
                    return he(Fe, e);
                }
                if (a && e instanceof wn) {
                    e.definitions.forEach(function(e) {
                        c.set(e.name.name, e);
                        ++l;
                    });
                    var n = e.to_assignments(r);
                    var t = p.parent();
                    if (t instanceof Je && t.init === e) {
                        if (n) return n;
                        var i = e.definitions[0].name;
                        return he(Jn, i, i);
                    }
                    if (t instanceof We && t.init === e) return n;
                    if (!n) return he(Fe, e);
                    return he(Pe, e, {
                        body: n
                    });
                }
                if (e instanceof Xe) return e;
            });
            s.transform(p);
            if (l > 0) {
                var t = [];
                c.each(function(e, n) {
                    if (s instanceof Qe && !De(s.argnames, function(e) {
                        return e.name != n;
                    })) {
                        c.del(n);
                    } else {
                        e = e.clone();
                        e.value = null;
                        t.push(e);
                        c.set(n, e);
                    }
                });
                if (t.length > 0) {
                    for (var e = 0; e < s.body.length; ) {
                        if (s.body[e] instanceof Pe) {
                            var i = s.body[e].body, d, h;
                            if (i instanceof Mn && i.operator == "=" && (d = i.left) instanceof Hn && c.has(d.name)) {
                                var v = c.get(d.name);
                                if (v.value) break;
                                v.value = i.right;
                                Te(t, v);
                                t.push(v);
                                s.body.splice(e, 1);
                                continue;
                            }
                            if (i instanceof Sn && (h = i.expressions[0]) instanceof Mn && h.operator == "=" && (d = h.left) instanceof Hn && c.has(d.name)) {
                                var v = c.get(d.name);
                                if (v.value) break;
                                v.value = h.right;
                                Te(t, v);
                                t.push(v);
                                s.body[e].body = V(i, i.expressions.slice(1));
                                continue;
                            }
                        }
                        if (s.body[e] instanceof Fe) {
                            s.body.splice(e, 1);
                            continue;
                        }
                        if (s.body[e] instanceof Re) {
                            var _ = [ e, 1 ].concat(s.body[e].body);
                            s.body.splice.apply(s.body, _);
                            continue;
                        }
                        break;
                    }
                    t = he(wn, s, {
                        definitions: t
                    });
                    u.push(t);
                }
            }
            s.body = f.concat(u, s.body);
        });
        function p(n, t) {
            n.walk(new ft(function(e) {
                if (e instanceof on) {
                    t(e);
                    return true;
                }
                if (e instanceof Xe && e !== n) return true;
            }));
        }
        function u(e) {
            var i = Object.create(null);
            p(e, function(e) {
                var n = e.value;
                if (n) n = n.tail_node();
                if (n instanceof Jn) {
                    var t = n.definition().id;
                    i[t] = (i[t] || 0) + 1;
                }
            });
            return i;
        }
        function d(e, n, t) {
            return e.bool_fn + (n[e.id] || 0) === e.references.length - e.replaced && !t.exposed(e);
        }
        function h(e, i) {
            p(e, function(e) {
                e.in_bool = true;
                var n = e.value;
                if (n) {
                    var t = n.is_truthy() || n.evaluate(i, true);
                    if (!t) {
                        n = n.drop_side_effect_free(i);
                        e.value = n ? V(e.value, [ n, he(Qn, e.value, {
                            value: 0
                        }) ]) : null;
                    } else if (t && !(t instanceof qe)) {
                        n = n.drop_side_effect_free(i);
                        e.value = n ? V(e.value, [ n, he(Qn, e.value, {
                            value: 1
                        }) ]) : he(Qn, e.value, {
                            value: 1
                        });
                    }
                }
            });
        }
        Xe.DEFMETHOD("process_boolean_returns", ae);
        nn.DEFMETHOD("process_boolean_returns", function(e) {
            if (!e.option("booleans")) return;
            var n = u(this);
            if (!d(this.name.definition(), n, e)) return;
            h(this, e);
        });
        en.DEFMETHOD("process_boolean_returns", function(e) {
            if (!e.option("booleans")) return;
            var n = u(this);
            if (this.name && !d(this.name.definition(), n, e)) return;
            var t = e.parent();
            if (t instanceof Mn) {
                if (t.operator != "=") return;
                var i = t.left;
                if (!(i instanceof Jn)) return;
                if (!d(i.definition(), n, e)) return;
            } else if (t instanceof kn && t.expression !== this) {
                var r = t.expression;
                if (r instanceof Jn) r = r.fixed_value();
                if (!(r instanceof Qe)) return;
                if (r.uses_arguments || r.pinned()) return;
                var i = r.argnames[t.args.indexOf(this)];
                if (i && !d(i.definition(), n, e)) return;
            } else if (t.TYPE == "Call") {
                e.pop();
                var o = e.in_boolean_context();
                e.push(this);
                if (!o) return;
            } else return;
            h(this, e);
        });
        Ne.DEFMETHOD("var_names", function() {
            var t = this._var_names;
            if (!t) {
                this._var_names = t = Object.create(null);
                this.enclosed.forEach(function(e) {
                    t[e.name] = true;
                });
                this.variables.each(function(e, n) {
                    t[n] = true;
                });
            }
            return t;
        });
        Xe.DEFMETHOD("make_var_name", function(e) {
            var n = this.var_names();
            e = e.replace(/(?:^[^a-z_$]|[^a-z0-9_$])/gi, "_");
            var t = e;
            for (var i = 0; n[t]; i++) t = e + "$" + i;
            n[t] = true;
            return t;
        });
        Xe.DEFMETHOD("hoist_properties", function(e) {
            if (!e.option("hoist_props") || e.has_directive("use asm")) return;
            var f = this;
            var r = f instanceof Ke && e.top_retain || Ee;
            var u = Object.create(null);
            f.transform(new ht(function(i, e) {
                if (i instanceof Mn) {
                    if (i.operator != "=") return;
                    if (!i.write_only) return;
                    if (i.left.scope !== f) return;
                    if (!t(i.left, i.right, 1)) return;
                    e(i, this);
                    var r = new Ae();
                    var o = [];
                    var a = [];
                    i.right.properties.forEach(function(e) {
                        var n = s(i.left, e.key);
                        a.push(he(xn, i, {
                            name: n,
                            value: null
                        }));
                        var t = he(Jn, i, {
                            name: n.name,
                            scope: f,
                            thedef: n.definition()
                        });
                        t.reference({});
                        o.push(he(Mn, i, {
                            operator: "=",
                            left: t,
                            right: e.value
                        }));
                    });
                    u[i.left.definition().id] = r;
                    f.body.splice(f.body.indexOf(this.stack[1]) + 1, 0, he(wn, i, {
                        definitions: a
                    }));
                    return V(i, o);
                }
                if (i instanceof Xe) return i === f ? undefined : i;
                if (i instanceof xn) {
                    if (!t(i.name, i.value, 0)) return;
                    e(i, this);
                    var r = new Ae();
                    var n = [];
                    i.value.properties.forEach(function(e) {
                        n.push(he(xn, i, {
                            name: s(i.name, e.key),
                            value: e.value
                        }));
                    });
                    u[i.name.definition().id] = r;
                    return Se.splice(n);
                }
                function s(e, n) {
                    var t = he(Bn, e, {
                        name: f.make_var_name(e.name + "_" + n),
                        scope: f
                    });
                    var i = f.def_variable(t);
                    r.set(n, i);
                    f.enclosed.push(i);
                    return t;
                }
            }));
            f.transform(new ht(function(i, e) {
                if (i instanceof qn) return o("right");
                if (i instanceof Tn) {
                    if (!(i.expression instanceof Jn)) return;
                    var n = u[i.expression.definition().id];
                    if (!n) return;
                    var t = n.get(i.getProperty());
                    var r = he(Jn, i, {
                        name: t.name,
                        scope: i.expression.scope,
                        thedef: t
                    });
                    r.reference({});
                    return r;
                }
                if (i instanceof An) {
                    if (T[i.operator]) return;
                    return o("expression");
                }
                function o(e) {
                    var n = i[e];
                    if (!(n instanceof Jn)) return;
                    if (!(n.definition().id in u)) return;
                    var t = i.clone();
                    t[e] = he(Fn, n, {
                        properties: []
                    });
                    return t;
                }
            }));
            function t(e, n, t) {
                var i = e.definition();
                if (i.assignments != t) return;
                if (i.direct_access) return;
                if (i.escaped.depth == 1) return;
                if (i.references.length - i.replaced == t) return;
                if (i.single_use) return;
                if (r(i)) return;
                if (e.fixed_value() !== n) return;
                return n instanceof Fn && n.properties.length > 0 && De(n.properties, function(e) {
                    return e instanceof Nn;
                }) && De(i.references, function(e) {
                    return e.fixed_value() === n;
                }) && De(i.orig, function(e) {
                    return !(e instanceof Rn || e instanceof Un);
                });
            }
        });
        function ne(e, n) {
            if (!e.name || !n.option("ie8")) return true;
            var t = e.name.definition();
            if (n.exposed(t)) return false;
            return De(t.references, function(e) {
                return !(e instanceof Jn);
            });
        }
        (function(e) {
            function u(e, n, t) {
                var i = e.length;
                if (!i) return null;
                var r = [], o = false;
                for (var a = 0; a < i; a++) {
                    var s = e[a].drop_side_effect_free(n, t);
                    o |= s !== e[a];
                    if (s) {
                        r.push(s);
                        t = false;
                    }
                }
                return o ? r.length ? r : null : e;
            }
            e(qe, Y);
            e(Ze, fe);
            e(Cn, function(e, n) {
                var t = u(this.elements, e, n);
                return t && V(this, t);
            });
            e(Mn, function(e) {
                var n = this.left;
                if (n instanceof Tn) {
                    var t = n.expression;
                    if (t instanceof Mn && t.operator == "=" && !t.may_throw_on_access(e)) {
                        t.write_only = "p";
                    }
                    if (e.has_directive("use strict") && t.is_constant()) return this;
                }
                if (n.has_side_effects(e)) return this;
                this.write_only = true;
                if (_e(n).is_constant_expression(e.find_parent(Xe))) {
                    return this.right.drop_side_effect_free(e);
                }
                return this;
            });
            e(qn, function(e, n) {
                if (this.operator == "in" && !we(this.right)) {
                    var t = this.left.drop_side_effect_free(e, n);
                    if (t === this.left) return this;
                    var i = this.clone();
                    i.left = t || he(Qn, this.left, {
                        value: 0
                    });
                    return i;
                }
                var r = this.right.drop_side_effect_free(e, n);
                if (!r) return this.left.drop_side_effect_free(e, n);
                if (ge[this.operator] && !(r instanceof en)) {
                    var i = this;
                    if (r !== i.right) {
                        i = this.clone();
                        i.right = r.drop_side_effect_free(e);
                    }
                    return (n ? a : Q)(i, he(qn, this, {
                        operator: i.operator == "&&" ? "||" : "&&",
                        left: i.left.negate(e, n),
                        right: i.right
                    }));
                } else {
                    var t = this.left.drop_side_effect_free(e, n);
                    if (!t) return r;
                    return V(this, [ t, r.drop_side_effect_free(e) ]);
                }
            });
            e(kn, function(t, e) {
                var n = this;
                if (n.is_expr_pure(t)) {
                    if (n.pure) qe.warn("Dropping __PURE__ call [{file}:{line},{col}]", n.start);
                    var i = u(n.args, t, e);
                    return i && V(n, i);
                }
                var r = n.expression;
                if (n.is_call_pure(t)) {
                    var o = n.args.slice();
                    o.unshift(r.expression);
                    o = u(o, t, e);
                    return o && V(n, o);
                }
                var a;
                if (r instanceof en && !(r.name && (a = r.name.definition()).references.length > a.replaced)) {
                    r.process_expression(false, function(e) {
                        var n = e.value && e.value.drop_side_effect_free(t, true);
                        return n ? he(Pe, e, {
                            body: n
                        }) : he(Fe, e);
                    });
                    p(r, function(e) {
                        if (e.value) e.value = e.value.drop_side_effect_free(t);
                    });
                    n = n.clone();
                }
                if (n instanceof En) {
                    var s = r;
                    if (s instanceof Jn) s = s.fixed_value();
                    if (s instanceof Qe) {
                        s.new = true;
                        var f = De(s.body, function(e) {
                            return !e.has_side_effects(t);
                        });
                        delete s.new;
                        if (f) {
                            var o = n.args.slice();
                            o.unshift(r);
                            o = u(o, t, e);
                            return o && V(n, o);
                        }
                        if (!s.contains_this()) return he(kn, n, n);
                    }
                }
                return n;
            });
            e(jn, function(e) {
                var n = this.consequent.drop_side_effect_free(e);
                var t = this.alternative.drop_side_effect_free(e);
                if (n === this.consequent && t === this.alternative) return this;
                var i;
                if (e.option("ie8")) {
                    i = [];
                    if (n instanceof en) {
                        i.push(n);
                        n = null;
                    }
                    if (t instanceof en) {
                        i.push(t);
                        t = null;
                    }
                }
                var r;
                if (!n) {
                    r = t ? he(qn, this, {
                        operator: "||",
                        left: this.condition,
                        right: t
                    }) : this.condition.drop_side_effect_free(e);
                } else if (!t) {
                    r = he(qn, this, {
                        operator: "&&",
                        left: this.condition,
                        right: n
                    });
                } else {
                    r = this.clone();
                    r.consequent = n;
                    r.alternative = t;
                }
                if (!e.option("ie8")) return r;
                if (r) i.push(r);
                return i.length == 0 ? null : V(this, i);
            });
            e(Xn, fe);
            e(On, function(e, n) {
                var t = this.expression;
                if (t.may_throw_on_access(e)) return this;
                return t.drop_side_effect_free(e, n);
            });
            e(en, function(e) {
                return ne(this, e) ? null : this;
            });
            e(Fn, function(e, n) {
                var t = u(this.properties, e, n);
                return t && V(this, t);
            });
            e(Pn, function(e, n) {
                return this.value.drop_side_effect_free(e, n);
            });
            e(Sn, function(e, n) {
                var t = u(this.expressions, e, n);
                if (!t) return null;
                var i = t.length - 1;
                var r, o, a;
                if (e.option("conditionals") && i > 0 && (r = t[i - 1]) instanceof Mn && r.operator == "=" && (a = r.left) instanceof Jn && (o = w(e, a.definition(), r.right, t[i]))) {
                    r = r.clone();
                    r.right = o;
                    t = t.slice(0, -2);
                    t.push(r);
                }
                return t === this.expressions ? this : V(this, t);
            });
            e(Dn, function(e, n) {
                if (this.expression.may_throw_on_access(e)) return this;
                var t = this.expression.drop_side_effect_free(e, n);
                if (!t) return this.property.drop_side_effect_free(e, n);
                var i = this.property.drop_side_effect_free(e);
                if (!i) return t;
                return V(this, [ t, i ]);
            });
            function r(e) {
                return De(e.definition().orig, function(e) {
                    return !(e instanceof Rn || e instanceof Un);
                });
            }
            e(Jn, function(e) {
                return this.is_declared(e) && r(this) ? null : this;
            });
            e(Gn, fe);
            e(An, function(e, n) {
                var t = this.expression;
                if (T[this.operator]) {
                    this.write_only = !t.has_side_effects(e);
                    return this;
                }
                if (this.operator == "typeof" && t instanceof Jn && r(t)) return null;
                var i = t.drop_side_effect_free(e, n);
                if (n && i && G(i)) {
                    if (i === t && this.operator == "!") return this;
                    return i.negate(e, n);
                }
                return i;
            });
        })(function(e, n) {
            e.DEFMETHOD("drop_side_effect_free", n);
        });
        e(Pe, function(e, n) {
            if (n.option("side_effects")) {
                var t = e.body;
                var i = t.drop_side_effect_free(n, true);
                if (!i) {
                    qe.warn("Dropping side-effect-free statement [{file}:{line},{col}]", e.start);
                    return he(Fe, e);
                }
                if (i !== t) {
                    return he(Pe, e, {
                        body: i
                    });
                }
            }
            return e;
        });
        e(Ve, function(e, n) {
            return n.option("loops") ? he(We, e, e).optimize(n) : e;
        });
        function O(n, e, t) {
            if (!t) t = sn;
            var i = false;
            var r = new ft(function(e) {
                if (i || e instanceof Xe) return true;
                if (e instanceof t && r.loopcontrol_target(e) === n) {
                    return i = true;
                }
            });
            if (e instanceof Ue) r.push(e);
            r.push(n);
            n.body.walk(r);
            return i;
        }
        e(Le, function(t, e) {
            if (!e.option("loops")) return t;
            var n = t.condition.is_truthy() || t.condition.evaluate(e, true);
            if (!(n instanceof qe)) {
                if (n && !O(t, e.parent(), un)) return he(We, t, {
                    body: he(Re, t.body, {
                        body: [ t.body, he(Pe, t.condition, {
                            body: t.condition
                        }) ]
                    })
                }).optimize(e);
                if (!O(t, e.parent())) return he(Re, t.body, {
                    body: [ t.body, he(Pe, t.condition, {
                        body: t.condition
                    }) ]
                }).optimize(e);
            }
            if (t.body instanceof Re && !O(t, e.parent(), un)) {
                var i = t.body.body;
                for (var r = i.length; --r >= 0; ) {
                    var o = i[r];
                    if (o instanceof cn && !o.alternative && o.body instanceof fn && e.loopcontrol_target(o.body) === t) {
                        if (a(o.condition)) break;
                        t.condition = he(qn, t, {
                            operator: "&&",
                            left: o.condition.negate(e),
                            right: t.condition
                        });
                        i.splice(r, 1);
                    } else if (o instanceof Pe) {
                        if (a(o.body)) break;
                        t.condition = V(t, [ o.body, t.condition ]);
                        i.splice(r, 1);
                    } else if (!z(o)) {
                        break;
                    }
                }
                t.body = f(t.body);
            }
            if (t.body instanceof Fe) return he(We, t, t).optimize(e);
            if (t.body instanceof Pe) return he(We, t, {
                condition: V(t.condition, [ t.body.body, t.condition ]),
                body: he(Fe, t)
            }).optimize(e);
            return t;
            function a(e) {
                var n = false;
                e.walk(new ft(function(e) {
                    if (n) return true;
                    if (e instanceof Jn) {
                        if (!ke(e.definition(), t.enclosed)) n = true;
                        return true;
                    }
                }));
                return n;
            }
        });
        function v(n, t) {
            var e = a(n.body);
            if (t.option("dead_code") && (e instanceof fn || e instanceof un && s(e) || e instanceof rn)) {
                var i = [];
                if (n.init instanceof je) {
                    i.push(n.init);
                } else if (n.init) {
                    i.push(he(Pe, n.init, {
                        body: n.init
                    }));
                }
                var r = s(e) || e instanceof rn;
                if (n.condition && r) {
                    i.push(he(cn, n, {
                        condition: n.condition,
                        body: e,
                        alternative: null
                    }));
                } else if (n.condition) {
                    i.push(he(Pe, n.condition, {
                        body: n.condition
                    }));
                } else if (r) {
                    i.push(e);
                }
                k(t, n.body, i);
                return he(Re, n, {
                    body: i
                });
            }
            if (e instanceof cn) {
                var o = a(e.body);
                if (o instanceof fn && !s(o)) {
                    if (n.condition) {
                        n.condition = he(qn, n.condition, {
                            left: n.condition,
                            operator: "&&",
                            right: e.condition.negate(t)
                        });
                    } else {
                        n.condition = e.condition.negate(t);
                    }
                    var i = D(e.alternative);
                    k(t, e.body, i);
                    return f(i);
                }
                o = a(e.alternative);
                if (o instanceof fn && !s(o)) {
                    if (n.condition) {
                        n.condition = he(qn, n.condition, {
                            left: n.condition,
                            operator: "&&",
                            right: e.condition
                        });
                    } else {
                        n.condition = e.condition;
                    }
                    var i = D(e.body);
                    k(t, e.alternative, i);
                    return f(i);
                }
            }
            return n;
            function a(e) {
                return e instanceof Re ? e.body[0] : e;
            }
            function s(e) {
                return t.loopcontrol_target(e) !== t.self();
            }
            function f(e) {
                if (n.body instanceof Re) {
                    n.body = n.body.clone();
                    n.body.body = e.concat(n.body.body.slice(1));
                    n.body = n.body.transform(t);
                } else {
                    n.body = he(Re, n.body, {
                        body: e
                    }).transform(t);
                }
                return v(n, t);
            }
        }
        e(We, function(e, n) {
            if (!n.option("loops")) return e;
            if (n.option("side_effects")) {
                if (e.init) e.init = e.init.drop_side_effect_free(n);
                if (e.step) e.step = e.step.drop_side_effect_free(n);
            }
            if (e.condition) {
                var t = e.condition.evaluate(n);
                if (t instanceof qe) {
                    t = e.condition.is_truthy() || e.condition.evaluate(n, true);
                } else if (t) {
                    e.condition = null;
                } else if (!n.option("dead_code")) {
                    var i = e.condition;
                    e.condition = S(t, e.condition);
                    e.condition = Q(e.condition.transform(n), i);
                }
                if (!t) {
                    if (n.option("dead_code")) {
                        var r = [];
                        if (e.init instanceof je) {
                            r.push(e.init);
                        } else if (e.init) {
                            r.push(he(Pe, e.init, {
                                body: e.init
                            }));
                        }
                        r.push(he(Pe, e.condition, {
                            body: e.condition
                        }));
                        k(n, e.body, r);
                        return he(Re, e, {
                            body: r
                        }).optimize(n);
                    }
                } else if (e.condition && !(t instanceof qe)) {
                    e.body = he(Re, e.body, {
                        body: [ he(Pe, e.condition, {
                            body: e.condition
                        }), e.body ]
                    });
                    e.condition = null;
                }
            }
            return v(e, n);
        });
        function j(e, n, t) {
            if (!(e instanceof qn)) return;
            if (!(e.left instanceof Kn)) {
                switch (e.operator) {
                  case "&&":
                    j(e.left, n);
                    j(e.right, n);
                    break;

                  case "||":
                    j(f(e.left), t);
                    j(f(e.right), t);
                    break;
                }
                return;
            }
            if (!(e.right instanceof zn)) return;
            if (e.right.operator != "typeof") return;
            var i = e.right.expression;
            if (!X(i)) return;
            var r;
            var o = e.left.value == "undefined";
            switch (e.operator) {
              case "==":
                r = o ? t : n;
                break;

              case "!=":
                r = o ? n : t;
                break;

              default:
                return;
            }
            if (!r) return;
            var a = i.definition();
            var s = new ft(function(e) {
                if (e instanceof Xe) {
                    var n = s.parent();
                    if (n instanceof kn && n.expression === e) return;
                    return true;
                }
                if (e instanceof Jn && e.definition() === a) e.defined = true;
            });
            r.walk(s);
            function f(e) {
                if (!(e instanceof qn)) return;
                switch (e.operator) {
                  case "==":
                    e = e.clone();
                    e.operator = "!=";
                    return e;

                  case "!=":
                    e = e.clone();
                    e.operator = "==";
                    return e;
                }
            }
        }
        e(cn, function(e, f) {
            if (J(e.alternative)) e.alternative = null;
            if (!f.option("conditionals")) return e;
            var n = e.condition.evaluate(f);
            if (!f.option("dead_code") && !(n instanceof qe)) {
                var t = e.condition;
                e.condition = S(n, t);
                e.condition = Q(e.condition.transform(f), t);
            }
            if (f.option("dead_code")) {
                if (n instanceof qe) {
                    n = e.condition.is_truthy() || e.condition.evaluate(f, true);
                }
                if (!n) {
                    qe.warn("Condition always false [{file}:{line},{col}]", e.condition.start);
                    var i = [ he(Pe, e.condition, {
                        body: e.condition
                    }) ];
                    k(f, e.body, i);
                    if (e.alternative) i.push(e.alternative);
                    return he(Re, e, {
                        body: i
                    }).optimize(f);
                } else if (!(n instanceof qe)) {
                    qe.warn("Condition always true [{file}:{line},{col}]", e.condition.start);
                    var i = [ he(Pe, e.condition, {
                        body: e.condition
                    }), e.body ];
                    if (e.alternative) k(f, e.alternative, i);
                    return he(Re, e, {
                        body: i
                    }).optimize(f);
                }
            }
            var r = e.condition.negate(f);
            var o = e.condition.print_to_string().length;
            var a = r.print_to_string().length;
            var s = a < o;
            if (e.alternative && s) {
                s = false;
                e.condition = r;
                var u = e.body;
                e.body = e.alternative || he(Fe, e);
                e.alternative = u;
            }
            var i = [], c = [], l = [];
            var p = _(e.body, i, c, l);
            var d = _(e.alternative, i, c, l);
            if (p && d) {
                if (c.length > 0) i.push(he(wn, e, {
                    definitions: c
                }));
                if (p.length == 0) {
                    i.push(he(Pe, e.condition, {
                        body: d.length > 0 ? he(qn, e, {
                            operator: "||",
                            left: e.condition,
                            right: V(e.alternative, d)
                        }).transform(f) : e.condition.clone()
                    }).optimize(f));
                } else if (d.length == 0) {
                    if (o === a && !s && e.condition instanceof qn && e.condition.operator == "||") {
                        s = true;
                    }
                    i.push(he(Pe, e, {
                        body: he(qn, e, {
                            operator: s ? "||" : "&&",
                            left: s ? r : e.condition,
                            right: V(e.body, p)
                        }).transform(f)
                    }).optimize(f));
                } else {
                    i.push(he(Pe, e, {
                        body: he(jn, e, {
                            condition: e.condition,
                            consequent: V(e.body, p),
                            alternative: V(e.alternative, d)
                        })
                    }).optimize(f));
                }
                l.forEach(function(e) {
                    e.definition().references.push(e);
                });
                return he(Re, e, {
                    body: i
                }).optimize(f);
            }
            if (J(e.body)) {
                e = he(cn, e, {
                    condition: r,
                    body: e.alternative,
                    alternative: null
                });
            }
            if (e.body instanceof rn && e.alternative instanceof rn && e.body.TYPE == e.alternative.TYPE) {
                var h = he(e.body.CTOR, e, {
                    value: he(jn, e, {
                        condition: e.condition,
                        consequent: e.body.value || he(tt, e.body).transform(f),
                        alternative: e.alternative.value || he(tt, e.alternative).transform(f)
                    })
                });
                if (h instanceof on) {
                    h.in_bool = e.body.in_bool || e.alternative.in_bool;
                }
                return h;
            }
            if (e.body instanceof cn && !e.body.alternative && !e.alternative) {
                e = he(cn, e, {
                    condition: he(qn, e.condition, {
                        operator: "&&",
                        left: e.condition,
                        right: e.body.condition
                    }),
                    body: e.body.body,
                    alternative: null
                });
            }
            if (q(e.body)) {
                if (e.alternative) {
                    var v = e.alternative;
                    e.alternative = null;
                    return he(Re, e, {
                        body: [ e, v ]
                    }).optimize(f);
                }
            }
            if (q(e.alternative)) {
                var i = e.body;
                e.body = e.alternative;
                e.condition = s ? r : e.condition.negate(f);
                e.alternative = null;
                return he(Re, e, {
                    body: [ e, i ]
                }).optimize(f);
            }
            if (f.option("typeofs")) j(e.condition, e.body, e.alternative);
            return e;
            function _(e, n, t, i) {
                if (e == null) return [];
                if (e instanceof Re) {
                    var r = [];
                    for (var o = 0; o < e.body.length; o++) {
                        var a = e.body[o];
                        if (a instanceof nn) {
                            n.push(a);
                        } else if (a instanceof Fe) {
                            continue;
                        } else if (a instanceof Pe) {
                            if (!f.option("sequences") && r.length > 0) return;
                            r.push(a.body);
                        } else if (a instanceof wn) {
                            if (!f.option("sequences") && r.length > 0) return;
                            a.definitions.forEach(s);
                        } else {
                            return;
                        }
                    }
                    return r;
                }
                if (e instanceof nn) {
                    n.push(e);
                    return [];
                }
                if (e instanceof Fe) return [];
                if (e instanceof Pe) return [ e.body ];
                if (e instanceof wn) {
                    var r = [];
                    e.definitions.forEach(s);
                    return r;
                }
                function s(e) {
                    t.push(he(xn, e, {
                        name: e.name,
                        value: null
                    }));
                    if (!e.value) return;
                    var n = he(Jn, e.name, e.name);
                    r.push(he(Mn, e, {
                        operator: "=",
                        left: n,
                        right: e.value
                    }));
                    i.push(n);
                }
            }
        });
        e(ln, function(i, t) {
            if (!t.option("switches")) return i;
            var e;
            var n = i.expression.evaluate(t);
            if (!(n instanceof qe)) {
                var r = i.expression;
                i.expression = S(n, r);
                i.expression = Q(i.expression.transform(t), r);
            }
            if (!t.option("dead_code")) return i;
            if (n instanceof qe) {
                n = i.expression.evaluate(t, true);
            }
            var o = [];
            var a = [];
            var s;
            var f;
            for (var u = 0, c = i.body.length; u < c && !f; u++) {
                e = i.body[u];
                if (e instanceof dn) {
                    var l = a[a.length - 1];
                    if (s || b(e.body[0], t) && (!l || q(l))) {
                        w(e, l);
                        continue;
                    } else {
                        s = e;
                    }
                } else if (!(n instanceof qe)) {
                    var p = e.expression.evaluate(t);
                    if (!(p instanceof qe) && p !== n) {
                        w(e, a[a.length - 1]);
                        continue;
                    }
                    if (p instanceof qe) p = e.expression.evaluate(t, true);
                    if (p === n) {
                        f = e;
                        if (s) {
                            var d = a.indexOf(s);
                            a.splice(d, 1);
                            w(s, a[d - 1]);
                            s = null;
                        }
                    }
                }
                if (q(e)) {
                    var l = a[a.length - 1];
                    if (q(l) && l.body.length == e.body.length && he(Re, l, l).equivalent_to(he(Re, e, e))) {
                        l.body = [];
                    }
                }
                a.push(e);
            }
            while (u < c) w(i.body[u++], a[a.length - 1]);
            while (e = a[a.length - 1]) {
                var h = e.body[e.body.length - 1];
                if (b(h, t)) e.body.pop();
                if (e === s) {
                    if (!x(e)) break;
                } else if (e.expression.has_side_effects(t)) {
                    break;
                } else if (s) {
                    if (!x(s)) break;
                    if (a[a.length - 2] !== s) break;
                    s.body = s.body.concat(e.body);
                    e.body = [];
                } else if (!x(e)) break;
                w(e);
                if (a.pop() === s) s = null;
            }
            if (a.length == 0) {
                return he(Re, i, {
                    body: o.concat(he(Pe, i.expression, {
                        body: i.expression
                    }))
                }).optimize(t);
            }
            a[0].body = o.concat(a[0].body);
            i.body = a;
            if (t.option("conditionals")) switch (a.length) {
              case 1:
                if (!y(a[0])) break;
                var p = a[0].expression;
                var v = a[0].body.slice();
                if (a[0] !== s && a[0] !== f) return he(cn, i, {
                    condition: he(qn, i, {
                        operator: "===",
                        left: i.expression,
                        right: p
                    }),
                    body: he(Re, i, {
                        body: v
                    }),
                    alternative: null
                }).optimize(t);
                if (p) v.unshift(he(Pe, p, {
                    body: p
                }));
                v.unshift(he(Pe, i.expression, {
                    body: i.expression
                }));
                return he(Re, i, {
                    body: v
                }).optimize(t);

              case 2:
                if (!ke(s, a) || !y(a[1])) break;
                var v = a[0].body.slice();
                var _ = v.length && b(v[v.length - 1], t);
                if (_) v.pop();
                if (!De(v, y)) break;
                var m = a[1].body.length && he(Re, a[1], a[1]);
                var g = he(cn, i, {
                    condition: he(qn, i, a[0] === s ? {
                        operator: "!==",
                        left: i.expression,
                        right: a[1].expression
                    } : {
                        operator: "===",
                        left: i.expression,
                        right: a[0].expression
                    }),
                    body: he(Re, a[0], {
                        body: v
                    }),
                    alternative: _ && m || null
                });
                if (!_ && m) g = he(Re, i, {
                    body: [ g, m ]
                });
                return g.optimize(t);
            }
            return i;
            function b(e, n) {
                return e instanceof fn && n.loopcontrol_target(e) === i;
            }
            function y(e) {
                var n = false;
                var t = new ft(function(e) {
                    if (n || e instanceof Qe || e instanceof Pe) return true;
                    if (b(e, t)) n = true;
                });
                t.push(i);
                e.walk(t);
                return !n;
            }
            function w(e, n) {
                if (n && !q(n)) {
                    n.body = n.body.concat(e.body);
                } else {
                    k(t, e, o);
                }
            }
        });
        e(vn, function(e, n) {
            e.body = c(e.body, n);
            if (n.option("dead_code")) {
                if (x(e)) {
                    var t = [];
                    if (e.bcatch) {
                        k(n, e.bcatch, t);
                        t.forEach(function(e) {
                            if (!(e instanceof wn)) return;
                            e.definitions.forEach(function(e) {
                                var n = e.name.definition().redefined();
                                if (!n) return;
                                e.name = e.name.clone();
                                e.name.thedef = n;
                            });
                        });
                    }
                    t.unshift(he(Re, e, e).optimize(n));
                    if (e.bfinally) {
                        t.push(he(Re, e.bfinally, e.bfinally).optimize(n));
                    }
                    return he(Re, e, {
                        body: t
                    }).optimize(n);
                }
                if (e.bfinally && x(e.bfinally)) {
                    var t = he(Re, e.bfinally, e.bfinally).optimize(n);
                    t = e.body.concat(t);
                    if (!e.bcatch) return he(Re, e, {
                        body: t
                    }).optimize(n);
                    e.body = t;
                    e.bfinally = null;
                }
            }
            return e;
        });
        bn.DEFMETHOD("remove_initializers", function(n) {
            this.definitions.forEach(function(e) {
                e.value = he(tt, e).optimize(n);
            });
        });
        yn.DEFMETHOD("remove_initializers", function() {
            this.definitions.forEach(function(e) {
                e.value = null;
            });
        });
        wn.DEFMETHOD("remove_initializers", function() {
            this.definitions.forEach(function(e) {
                e.value = null;
            });
        });
        gn.DEFMETHOD("to_assignments", function(e) {
            var i = e.option("reduce_vars");
            var n = this.definitions.reduce(function(e, n) {
                if (n.value) {
                    var t = he(Jn, n.name, n.name);
                    e.push(he(Mn, n, {
                        operator: "=",
                        left: t,
                        right: n.value
                    }));
                    if (i) t.definition().fixed = false;
                }
                n = n.name.definition();
                n.eliminated++;
                n.replaced--;
                return e;
            }, []);
            if (n.length == 0) return null;
            return V(this, n);
        });
        function y(e, o) {
            return o.option("varify") && De(e.definitions, function(e) {
                var n = e.name;
                if (!n.fixed_value()) return false;
                var t = n.definition();
                if (o.exposed(t)) return false;
                var i = t.scope.resolve();
                for (var r = t.scope; r !== i; ) {
                    r = r.parent_scope;
                    if (r.var_names()[n.name]) return false;
                }
                return true;
            }) ? he(wn, e, {
                definitions: e.definitions.map(function(e) {
                    var n = he(Bn, e.name, e.name);
                    var t = n.definition();
                    t.orig[t.orig.indexOf(e.name)] = n;
                    var i = t.scope.resolve();
                    if (t.scope !== i) i.variables.set(t.name, t);
                    return he(xn, e, {
                        name: n,
                        value: e.value
                    });
                })
            }) : e;
        }
        e(bn, y);
        e(yn, y);
        function te(e, n) {
            var t = e.expression;
            if (!(t instanceof Sn)) return e;
            var i = t.expressions.slice();
            var r = e.clone();
            r.expression = i.pop();
            i.push(r);
            return V(e, i);
        }
        function ie(e, n, t) {
            var i = e.expression;
            var r = i instanceof Jn ? i.fixed_value() : i;
            if (!(r instanceof Qe)) return;
            if (r.uses_arguments) return;
            if (r.pinned()) return;
            if (t && t.indexOf(r) < 0) return;
            var o = e.args;
            var a = 0, s = 0;
            var f = r === i && !r.name && n.drop_fargs(r, e);
            var u = [];
            for (var c = 0; c < o.length; c++) {
                var l = c >= r.argnames.length;
                if (l || "__unused" in r.argnames[c]) {
                    var p = o[c].drop_side_effect_free(n);
                    if (f && (l || r.argnames[c].__unused)) {
                        if (!l) r.argnames.splice(c, 1);
                        o.splice(c, 1);
                        if (p) u.push(p);
                        c--;
                        continue;
                    } else if (p) {
                        u.push(p);
                        o[a++] = V(e, u);
                        u = [];
                    } else if (!l) {
                        if (u.length) {
                            o[a++] = V(e, u);
                            u = [];
                        } else {
                            o[a++] = he(Qn, o[c], {
                                value: 0
                            });
                            continue;
                        }
                    }
                } else {
                    u.push(o[c]);
                    o[a++] = V(e, u);
                    u = [];
                }
                s = a;
            }
            if (f) for (;c < r.argnames.length; c++) {
                if (r.argnames[c].__unused) r.argnames.splice(c--, 1);
            }
            o.length = s;
            if (!u.length) return;
            var d = V(e, u);
            o.push(o.length < r.argnames.length ? he(zn, e, {
                operator: "void",
                expression: d
            }) : d);
        }
        e(kn, function(f, u) {
            var o = f.expression;
            if (u.option("sequences")) {
                if (o instanceof Tn) {
                    var e = te(o, u);
                    if (e !== o) {
                        var n = f.clone();
                        n.expression = e.expressions.pop();
                        e.expressions.push(n);
                        return e.optimize(u);
                    }
                } else if (!W(u, o.tail_node())) {
                    var e = te(f, u);
                    if (e !== f) return e.optimize(u);
                }
            }
            if (u.option("unused")) ie(f, u);
            if (u.option("unsafe")) {
                if (X(o)) switch (o.name) {
                  case "Array":
                    if (f.args.length == 1) {
                        var t = f.args[0];
                        if (t instanceof Qn) try {
                            var i = t.value;
                            if (i > 6) break;
                            var r = Array(i);
                            for (var a = 0; a < i; a++) r[a] = he(it, f);
                            return he(Cn, f, {
                                elements: r
                            });
                        } catch (e) {
                            qe.warn("Invalid array length: {length} [{file}:{line},{col}]", {
                                length: i,
                                file: f.start.file,
                                line: f.start.line,
                                col: f.start.col
                            });
                            break;
                        }
                        if (!t.is_boolean(u) && !t.is_string(u)) break;
                    }
                    return he(Cn, f, {
                        elements: f.args
                    });

                  case "Object":
                    if (f.args.length == 0) {
                        return he(Fn, f, {
                            properties: []
                        });
                    }
                    break;

                  case "String":
                    if (f.args.length == 0) return he(Kn, f, {
                        value: ""
                    });
                    if (f.args.length <= 1) return he(qn, f, {
                        left: f.args[0],
                        operator: "+",
                        right: he(Kn, f, {
                            value: ""
                        })
                    }).optimize(u);
                    break;

                  case "Number":
                    if (f.args.length == 0) return he(Qn, f, {
                        value: 0
                    });
                    if (f.args.length == 1) return he(zn, f, {
                        expression: f.args[0],
                        operator: "+"
                    }).optimize(u);

                  case "Boolean":
                    if (f.args.length == 0) return he(at, f);
                    if (f.args.length == 1) return he(zn, f, {
                        expression: he(zn, f, {
                            expression: f.args[0],
                            operator: "!"
                        }),
                        operator: "!"
                    }).optimize(u);
                    break;

                  case "RegExp":
                    var s = [];
                    if (De(f.args, function(e) {
                        var n = e.evaluate(u);
                        s.unshift(n);
                        return e !== n;
                    })) {
                        try {
                            return Z(u, f, he(Zn, f, {
                                value: RegExp.apply(RegExp, s)
                            }));
                        } catch (e) {
                            qe.warn("Error converting {expr} [{file}:{line},{col}]", {
                                expr: f.print_to_string(),
                                file: f.start.file,
                                line: f.start.line,
                                col: f.start.col
                            });
                        }
                    }
                    break;
                } else if (o instanceof On) switch (o.property) {
                  case "toString":
                    if (f.args.length == 0 && !o.expression.may_throw_on_access(u)) {
                        return he(qn, f, {
                            left: he(Kn, f, {
                                value: ""
                            }),
                            operator: "+",
                            right: o.expression
                        }).optimize(u);
                    }
                    break;

                  case "join":
                    if (o.expression instanceof Cn) e: {
                        var c;
                        if (f.args.length > 0) {
                            c = f.args[0].evaluate(u);
                            if (c === f.args[0]) break e;
                        }
                        var r = [];
                        var l = [];
                        o.expression.elements.forEach(function(e) {
                            var n = e.evaluate(u);
                            if (n !== e) {
                                l.push(n);
                            } else {
                                if (l.length > 0) {
                                    r.push(he(Kn, f, {
                                        value: l.join(c)
                                    }));
                                    l.length = 0;
                                }
                                r.push(e);
                            }
                        });
                        if (l.length > 0) {
                            r.push(he(Kn, f, {
                                value: l.join(c)
                            }));
                        }
                        if (r.length == 0) return he(Kn, f, {
                            value: ""
                        });
                        if (r.length == 1) {
                            if (r[0].is_string(u)) {
                                return r[0];
                            }
                            return he(qn, r[0], {
                                operator: "+",
                                left: he(Kn, f, {
                                    value: ""
                                }),
                                right: r[0]
                            });
                        }
                        if (c == "") {
                            var t;
                            if (r[0].is_string(u) || r[1].is_string(u)) {
                                t = r.shift();
                            } else {
                                t = he(Kn, f, {
                                    value: ""
                                });
                            }
                            return r.reduce(function(e, n) {
                                return he(qn, n, {
                                    operator: "+",
                                    left: e,
                                    right: n
                                });
                            }, t).optimize(u);
                        }
                        var p = f.clone();
                        p.expression = p.expression.clone();
                        p.expression.expression = p.expression.expression.clone();
                        p.expression.expression.elements = r;
                        return Z(u, f, p);
                    }
                    break;

                  case "charAt":
                    if (f.args.length < 2) {
                        var p = he(Dn, f, {
                            expression: o.expression,
                            property: f.args.length ? he(qn, f.args[0], {
                                operator: "|",
                                left: he(Qn, f, {
                                    value: 0
                                }),
                                right: f.args[0]
                            }) : he(Qn, f, {
                                value: 0
                            })
                        });
                        p.is_string = se;
                        return p.optimize(u);
                    }
                    break;

                  case "apply":
                    if (f.args.length == 2 && f.args[1] instanceof Cn) {
                        var d = f.args[1].elements.slice();
                        d.unshift(f.args[0]);
                        return he(kn, f, {
                            expression: he(On, o, {
                                expression: o.expression,
                                property: "call"
                            }),
                            args: d
                        }).optimize(u);
                    }
                    break;

                  case "call":
                    var h = o.expression;
                    if (h instanceof Jn) {
                        h = h.fixed_value();
                    }
                    if (h instanceof Qe && !h.contains_this()) {
                        return (f.args.length ? V(this, [ f.args[0], he(kn, f, {
                            expression: o.expression,
                            args: f.args.slice(1)
                        }) ]) : he(kn, f, {
                            expression: o.expression,
                            args: []
                        })).optimize(u);
                    }
                    break;
                }
            }
            if (u.option("unsafe_Function") && X(o) && o.name == "Function") {
                if (f.args.length == 0) return he(en, f, {
                    argnames: [],
                    body: []
                }).init_vars(o.scope);
                if (De(f.args, function(e) {
                    return e instanceof Kn;
                })) {
                    try {
                        var v = "n(function(" + f.args.slice(0, -1).map(function(e) {
                            return e.value;
                        }).join(",") + "){" + f.args[f.args.length - 1].value + "})";
                        var _ = dt(v);
                        var m = {
                            ie8: u.option("ie8")
                        };
                        _.figure_out_scope(m);
                        var g = new _t(u.options);
                        _ = _.transform(g);
                        _.figure_out_scope(m);
                        _.compute_char_frequency(m);
                        _.mangle_names(m);
                        var b;
                        _.walk(new ft(function(e) {
                            if (b) return true;
                            if (e instanceof Qe) {
                                b = e;
                                return true;
                            }
                        }));
                        var v = vt();
                        Re.prototype._codegen.call(b, v);
                        f.args = [ he(Kn, f, {
                            value: b.argnames.map(function(e) {
                                return e.print_to_string();
                            }).join(",")
                        }), he(Kn, f.args[f.args.length - 1], {
                            value: v.get().replace(/^\{|\}$/g, "")
                        }) ];
                        return f;
                    } catch (e) {
                        if (e instanceof ct) {
                            qe.warn("Error parsing code passed to new Function [{file}:{line},{col}]", f.args[f.args.length - 1].start);
                            qe.warn(e.toString());
                        } else {
                            throw e;
                        }
                    }
                }
            }
            var y = o instanceof Jn ? o.fixed_value() : o;
            var w = y instanceof Qe;
            var x = w && y.first_statement();
            var k = u.option("inline") && !f.is_expr_pure(u);
            if (k && x instanceof on) {
                var E = x.value;
                if (o === y && (!E || E.is_constant_expression())) {
                    var d = f.args.concat(E || he(tt, f));
                    return V(f, d).optimize(u);
                }
            }
            if (w) {
                var S, E, T = false;
                if (k && !y.uses_arguments && !y.pinned() && !(y.name && y instanceof en) && (o === y || !xe(u, S = o.definition()) && y.is_constant_expression(L(u))) && (E = M(x)) && !y.contains_this()) {
                    var O = o === y || S.single_use && S.references.length - S.replaced == 1;
                    if (F()) {
                        var d = f.args.slice();
                        var D = [];
                        d.push(E.clone(true).transform(new ht(function(e) {
                            if (e instanceof Jn) {
                                var n = e.definition();
                                if (y.variables.get(e.name) !== n) {
                                    D.push(e);
                                    return e;
                                }
                                var t = C(n);
                                var i = d[t];
                                if (!i) return he(tt, f);
                                d[t] = null;
                                var r = this.parent();
                                return r ? ve(u, r, e, i) : i;
                            }
                        })));
                        var p = V(f, d.filter(function(e) {
                            return e;
                        })).optimize(u);
                        p = ve(u, u.parent(), u.self(), p);
                        if (O || Q(p, f) === p) {
                            D.forEach(function(e) {
                                var n = e.definition();
                                n.references.push(e);
                                if (O) n.replaced++;
                            });
                            return p;
                        }
                    }
                    var A, z, $;
                    if (O && I()) {
                        y._squeezed = true;
                        if (o !== y) y.parent_scope = o.scope;
                        var p = V(f, Y()).optimize(u);
                        return ve(u, u.parent(), u.self(), p);
                    }
                }
                if (u.option("side_effects") && De(y.body, J) && (y !== o || ne(y, u))) {
                    var d = f.args.concat(he(tt, f));
                    return V(f, d).optimize(u);
                }
            }
            if (u.option("drop_console")) {
                if (o instanceof Tn) {
                    var q = o.expression;
                    while (q.expression) {
                        q = q.expression;
                    }
                    if (X(q) && q.name == "console") {
                        return he(tt, f).optimize(u);
                    }
                }
            }
            if (u.option("negate_iife") && u.parent() instanceof Pe && G(f)) {
                return f.negate(u, true);
            }
            return ee(u, f);
            function j(e) {
                if (!e) return he(tt, f);
                if (e instanceof on) return e.value || he(tt, f);
                if (e instanceof Pe) return he(zn, e, {
                    operator: "void",
                    expression: e.body
                });
            }
            function M(e) {
                var n = y.body.length;
                if (u.option("inline") < 3) {
                    return n == 1 && j(e);
                }
                e = null;
                for (var t = 0; t < n; t++) {
                    var i = y.body[t];
                    if (i instanceof wn) {
                        var r = T || !De(i.definitions, function(e) {
                            return !e.value;
                        });
                        if (r) {
                            T = true;
                            if (e) return false;
                        }
                    } else if (i instanceof nn || i instanceof Fe) {
                        continue;
                    } else if (e) {
                        return false;
                    } else {
                        e = i;
                    }
                }
                return j(e);
            }
            function C(e) {
                for (var n = y.argnames.length; --n >= 0; ) {
                    if (y.argnames[n].definition() === e) return n;
                }
            }
            function F() {
                if (T) return;
                if (u.option("inline") < 2 && y.argnames.length) return;
                if (!y.variables.all(function(e) {
                    return e.references.length - e.replaced < 2 && e.orig[0] instanceof Yn;
                })) return;
                var r = false;
                var o;
                var a = [];
                var s = false;
                E.walk(new ft(function(e, n) {
                    if (r) return true;
                    if (e instanceof qn && ge[e.operator] || e instanceof jn) {
                        a = null;
                        return;
                    }
                    if (e instanceof Xe) return r = true;
                    if (e instanceof Jn) {
                        var t = e.definition();
                        if (y.variables.get(e.name) !== t) {
                            a = null;
                            return;
                        }
                        if (t.init instanceof nn) return r = true;
                        if (ye(e, this.parent())) return r = true;
                        var i = C(t);
                        if (!(o < i)) o = i;
                        if (!a) return;
                        if (s) {
                            a = null;
                        } else {
                            a.push(y.argnames[i]);
                        }
                        return;
                    }
                    if (e.has_side_effects(u)) {
                        n();
                        s = true;
                        return true;
                    }
                }));
                if (r) return;
                var e = f.args.length;
                if (a && y.argnames.length >= e) {
                    e = y.argnames.length;
                    while (e-- > o && y.argnames[e] === a.pop()) ;
                    e++;
                }
                var n = s && !a && u.find_parent(Xe);
                return e <= o || De(f.args.slice(o, e), n ? function(e) {
                    return e.is_constant_expression(n);
                } : function(e) {
                    return !e.has_side_effects(u);
                });
            }
            function P(e, n) {
                return e[n] || K[n] || $.var_names()[n];
            }
            function N(e, n, t) {
                for (var i = 0; i < y.argnames.length; i++) {
                    var r = y.argnames[i];
                    if (r.__unused) continue;
                    if (!t || P(e, r.name)) return false;
                    n[r.name] = true;
                    if (z) z.push(r.definition());
                }
                return true;
            }
            function H(n, e, t) {
                for (var i = 0; i < y.body.length; i++) {
                    var r = y.body[i];
                    if (r instanceof nn) {
                        if (!t || P(e, r.name.name)) return false;
                        if (!De(r.enclosed, function(e) {
                            return e.scope === r || !n[e.name];
                        })) return false;
                        continue;
                    }
                    if (!(r instanceof wn)) continue;
                    if (!t) return false;
                    for (var o = r.definitions.length; --o >= 0; ) {
                        var a = r.definitions[o].name;
                        if (P(n, a.name)) return false;
                        if (z) z.push(a.definition());
                    }
                }
                return true;
            }
            function I() {
                var n = Object.create(null);
                var e = 0;
                $ = u.self();
                while (!($ instanceof Xe)) {
                    if ($.variables) $.variables.each(function(e) {
                        n[e.name] = true;
                    });
                    A = $;
                    $ = u.parent(e++);
                    if ($ instanceof Ye) {
                        z = [];
                    } else if ($ instanceof We) {
                        if ($.init === A) continue;
                        z = [];
                    } else if ($ instanceof Je) {
                        if ($.init === A) continue;
                        if ($.object === A) continue;
                        z = [];
                    } else if ($ instanceof Jn) {
                        if ($.fixed_value() instanceof Xe) return false;
                    }
                }
                var t = (!($ instanceof Ke) || u.toplevel.vars) && (o !== y || y.parent_scope.resolve() === u.find_parent(Xe));
                var i = u.option("inline");
                var r = Object.create(n);
                if (!N(n, r, i >= 2 && t)) return false;
                if (!H(n, r, i >= 3 && t)) return false;
                return !z || z.length == 0 || !re(y, z);
            }
            function R(e, n, t, i) {
                var r = t.definition();
                $.variables.set(t.name, r);
                $.enclosed.push(r);
                if (!$.var_names()[t.name]) {
                    $.var_names()[t.name] = true;
                    e.push(he(xn, t, {
                        name: t,
                        value: null
                    }));
                }
                if (!i) return;
                var o = he(Jn, t, t);
                r.references.push(o);
                n.push(he(Mn, f, {
                    operator: "=",
                    left: o,
                    right: i
                }));
            }
            function U(e, n) {
                var t = y.argnames.length;
                for (var i = f.args.length; --i >= t; ) {
                    n.push(f.args[i]);
                }
                for (i = t; --i >= 0; ) {
                    var r = y.argnames[i];
                    var o = f.args[i];
                    if (r.__unused || $.var_names()[r.name]) {
                        if (o) n.push(o);
                    } else {
                        var a = he(Bn, r, r);
                        r.definition().orig.push(a);
                        if (!o && z) o = he(tt, f);
                        if ("__unused" in r) {
                            R(e, n, a);
                            if (o) n.push(o);
                        } else {
                            R(e, n, a, o);
                        }
                    }
                }
                e.reverse();
                n.reverse();
            }
            function B(e, n) {
                var t = n.length;
                for (var i = 0; i < y.body.length; i++) {
                    var r = y.body[i];
                    if (!(r instanceof wn)) continue;
                    for (var o = 0; o < r.definitions.length; o++) {
                        var a = r.definitions[o];
                        var s = a.name;
                        var f = s.definition().redefined();
                        if (f) {
                            s = s.clone();
                            s.thedef = f;
                        }
                        R(e, n, s, a.value);
                        if (z && De(y.argnames, function(e) {
                            return e.name != s.name;
                        })) {
                            var u = y.variables.get(s.name);
                            var c = he(Jn, s, s);
                            u.references.push(c);
                            n.splice(t++, 0, he(Mn, a, {
                                operator: "=",
                                left: c,
                                right: he(tt, s)
                            }));
                        }
                    }
                }
            }
            function Y() {
                var e = [];
                var n = [];
                U(e, n);
                B(e, n);
                n.push(E);
                var t = y.body.filter(function(e) {
                    if (e instanceof nn) {
                        var n = e.name.definition();
                        $.functions.set(n.name, n);
                        $.variables.set(n.name, n);
                        $.enclosed.push(n);
                        $.var_names()[n.name] = true;
                        return true;
                    }
                });
                t.unshift($.body.indexOf(A) + 1, 0);
                if (e.length) t.push(he(wn, y, {
                    definitions: e
                }));
                [].splice.apply($.body, t);
                y.enclosed.forEach(function(e) {
                    if ($.var_names()[e.name]) return;
                    $.enclosed.push(e);
                    $.var_names()[e.name] = true;
                });
                return n;
            }
        });
        e(En, function(e, n) {
            if (n.option("sequences")) {
                var t = te(e, n);
                if (t !== e) return t.optimize(n);
            }
            if (n.option("unsafe")) {
                var i = e.expression;
                if (X(i)) {
                    switch (i.name) {
                      case "Object":
                      case "RegExp":
                      case "Function":
                      case "Error":
                      case "Array":
                        return he(kn, e, e).transform(n);
                    }
                }
            }
            return e;
        });
        function w(t, i, e, n) {
            if (!(n instanceof qn)) return;
            if (!ge[n.operator]) return;
            if (!(n.right instanceof Mn)) return;
            if (n.right.operator != "=") return;
            if (!(n.right.left instanceof Jn)) return;
            if (n.right.left.definition() !== i) return;
            if (e.has_side_effects(t)) return;
            if (!r(n.left)) return;
            if (!r(n.right.right)) return;
            i.replaced++;
            return n.operator == "&&" ? he(jn, n, {
                condition: n.left,
                consequent: n.right.right,
                alternative: e
            }) : he(jn, n, {
                condition: n.left,
                consequent: e,
                alternative: n.right.right
            });
            function r(e) {
                if (e.has_side_effects(t)) return;
                var n = false;
                e.walk(new ft(function(e) {
                    if (n) return true;
                    if (e instanceof Jn && e.definition() === i) return n = true;
                }));
                return !n;
            }
        }
        e(Sn, function(e, o) {
            var r = n();
            var a = r.length - 1;
            i();
            t();
            if (a == 0) {
                e = ve(o, o.parent(), o.self(), r[0]);
                if (!(e instanceof Sn)) e = e.optimize(o);
                return e;
            }
            e.expressions = r;
            return e;
            function n() {
                if (!o.option("side_effects")) return e.expressions;
                var t = [];
                var i = $e(o);
                var r = e.expressions.length - 1;
                e.expressions.forEach(function(e, n) {
                    if (n < r) e = e.drop_side_effect_free(o, i);
                    if (e) {
                        _(t, e);
                        i = false;
                    }
                });
                return t;
            }
            function t() {
                if (!o.option("side_effects")) return;
                while (a > 0 && $(r[a], o)) a--;
                if (a < r.length - 1) {
                    r[a] = he(zn, e, {
                        operator: "void",
                        expression: r[a]
                    });
                    r.length = a + 1;
                }
            }
            function i() {
                if (!o.option("conditionals")) return;
                for (var e = 1; e < a; e++) {
                    var n = r[e - 1];
                    if (!(n instanceof Mn)) continue;
                    if (n.operator != "=") continue;
                    if (!(n.left instanceof Jn)) continue;
                    var t = n.left.definition();
                    var i = w(o, t, n.right, r[e]);
                    if (!i) continue;
                    n.right = i;
                    r.splice(e, 1);
                    a--;
                }
            }
        });
        e($n, function(e, n) {
            if (n.option("sequences")) {
                var t = te(e, n);
                if (t !== e) return t.optimize(n);
            }
            return ee(n, e);
        });
        var M = Oe("+ -");
        var C = Oe("* / %");
        e(zn, function(e, n) {
            var t = e.operator;
            var i = e.expression;
            if (n.option("evaluate") && t == "delete" && !(i instanceof Jn || i instanceof Tn || o(i))) {
                if (i instanceof Sn) {
                    i = i.expressions.slice();
                    i.push(he(st, e));
                    return V(e, i).optimize(n);
                }
                return V(e, [ i, he(st, e) ]).optimize(n);
            }
            if (n.option("sequences") && !(t == "typeof" && X(i.tail_node()))) {
                var r = te(e, n);
                if (r !== e) return r.optimize(n);
            }
            if (n.option("side_effects") && t == "void") {
                i = i.drop_side_effect_free(n);
                if (!i) return he(tt, e).optimize(n);
                e.expression = i;
                return e;
            }
            if (n.option("booleans")) {
                if (t == "!" && i.is_truthy()) {
                    return V(e, [ i, he(at, e) ]).optimize(n);
                } else if (n.in_boolean_context()) switch (t) {
                  case "!":
                    if (i instanceof zn && i.operator == "!") {
                        return i.expression;
                    }
                    if (i instanceof qn) {
                        e = Z(n, e, i.negate(n, $e(n)));
                    }
                    break;

                  case "typeof":
                    qe.warn("Boolean expression always true [{file}:{line},{col}]", e.start);
                    return (i instanceof Jn ? he(st, e) : V(e, [ i, he(st, e) ])).optimize(n);
                }
            }
            if (t == "-" && i instanceof rt) i = i.transform(n);
            if (n.option("evaluate") && i instanceof qn && M[t] && C[i.operator] && (i.left.is_constant() || !i.right.has_side_effects(n))) {
                return he(qn, e, {
                    operator: i.operator,
                    left: he(zn, i.left, {
                        operator: t,
                        expression: i.left
                    }),
                    right: i.right
                });
            }
            return t == "-" && (i instanceof Qn || i instanceof rt) ? e : ee(n, e);
        });
        qn.DEFMETHOD("lift_sequences", function(e) {
            if (this.left instanceof Tn) {
                if (!(this.left.expression instanceof Sn)) return this;
                var n = this.left.expression.expressions.slice();
                var t = this.clone();
                t.left = t.left.clone();
                t.left.expression = n.pop();
                n.push(t);
                return V(this, n);
            }
            if (this.left instanceof Sn) {
                var n = this.left.expressions.slice();
                var t = this.clone();
                t.left = n.pop();
                n.push(t);
                return V(this, n);
            }
            if (this.right instanceof Sn) {
                if (this.left.has_side_effects(e)) return this;
                var i = this.operator == "=" && this.left instanceof Jn;
                var n = this.right.expressions;
                var r = n.length - 1;
                for (var o = 0; o < r; o++) {
                    if (!i && n[o].has_side_effects(e)) break;
                }
                if (o == r) {
                    n = n.slice();
                    var t = this.clone();
                    t.right = n.pop();
                    n.push(t);
                    return V(this, n);
                }
                if (o > 0) {
                    var t = this.clone();
                    t.right = V(this.right, n.slice(o));
                    n = n.slice(0, o);
                    n.push(t);
                    return V(this, n);
                }
            }
            return this;
        });
        var F = Oe("indexOf lastIndexOf");
        var P = Oe("== === != !== * & | ^");
        function we(e) {
            if (e instanceof Mn) return e.operator == "=" && we(e.right);
            if (e instanceof Sn) return we(e.tail_node());
            if (e instanceof Jn) return we(e.fixed_value());
            return e instanceof Cn || e instanceof Qe || e instanceof En || e instanceof Fn;
        }
        function N(e, n) {
            if (n instanceof On) return N(e, n.expression);
            if (n instanceof Dn) {
                return N(e, n.expression) && N(e, n.property);
            }
            if (n instanceof Hn) return true;
            return !n.has_side_effects(e);
        }
        e(qn, function(i, a) {
            function t() {
                return i.left.is_constant() || i.right.is_constant() || !i.left.has_side_effects(a) && !i.right.has_side_effects(a);
            }
            function e(e) {
                if (t()) {
                    if (e) i.operator = e;
                    var n = i.left;
                    i.left = i.right;
                    i.right = n;
                }
            }
            function n() {
                var e = i.right;
                i.left = he(qn, i, {
                    operator: i.operator,
                    left: i.left,
                    right: e.left,
                    start: i.left.start,
                    end: e.left.end
                });
                i.right = e.right;
                i.left = i.left.transform(a);
            }
            if (P[i.operator] && i.right.is_constant() && !i.left.is_constant() && !(i.left instanceof qn && lt[i.left.operator] >= lt[i.operator])) {
                e();
            }
            if (a.option("sequences")) {
                var r = i.lift_sequences(a);
                if (r !== i) return r.optimize(a);
            }
            if (a.option("assignments") && ge[i.operator]) {
                var o = i.right;
                if (i.left instanceof Jn && o instanceof Mn && o.operator == "=" && i.left.equivalent_to(o.left)) {
                    i.right = o.right;
                    o.right = i;
                    return o;
                }
            }
            if (a.option("comparisons")) switch (i.operator) {
              case "===":
              case "!==":
                if ($(i.left, a) && i.right.is_defined(a)) {
                    qe.warn("Expression always defined [{file}:{line},{col}]", i.start);
                    return V(i, [ i.right, he(i.operator == "===" ? at : st, i) ]).optimize(a);
                }
                var s = true;
                if (i.left.is_string(a) && i.right.is_string(a) || i.left.is_number(a) && i.right.is_number(a) || i.left.is_boolean(a) && i.right.is_boolean(a) || N(a, i.left) && i.left.equivalent_to(i.right)) {
                    i.operator = i.operator.slice(0, 2);
                }

              case "==":
              case "!=":
                if (!s && $(i.left, a)) {
                    i.left = he(et, i.left);
                } else if (a.option("typeofs") && i.left instanceof Kn && i.left.value == "undefined" && i.right instanceof zn && i.right.operator == "typeof") {
                    var f = i.right.expression;
                    if (f instanceof Jn ? f.is_declared(a) : !(f instanceof Tn && a.option("ie8"))) {
                        i.right = f;
                        i.left = he(tt, i.left).optimize(a);
                        if (i.operator.length == 2) i.operator += "=";
                    }
                } else if (i.left instanceof Jn && i.right instanceof Jn && i.left.definition() === i.right.definition() && we(i.left)) {
                    return he(i.operator[0] == "=" ? st : at, i).optimize(a);
                }
                break;

              case "&&":
              case "||":
                var u = i.left;
                if (u.operator == i.operator) {
                    u = u.right;
                }
                if (u instanceof qn && u.operator == (i.operator == "&&" ? "!==" : "===") && i.right instanceof qn && u.operator == i.right.operator && ($(u.left, a) && i.right.left instanceof et || u.left instanceof et && $(i.right.left, a)) && !u.right.has_side_effects(a) && u.right.equivalent_to(i.right.right)) {
                    var c = he(qn, i, {
                        operator: u.operator.slice(0, -1),
                        left: he(et, i),
                        right: u.right
                    });
                    if (u !== i.left) {
                        c = he(qn, i, {
                            operator: i.operator,
                            left: i.left.left,
                            right: c
                        });
                    }
                    return c;
                }
                break;
            }
            var l = a.option("booleans") && a.in_boolean_context();
            if (l) switch (i.operator) {
              case "+":
                var p = i.left.evaluate(a);
                var d = i.right.evaluate(a);
                if (p && typeof p == "string") {
                    qe.warn("+ in boolean context always true [{file}:{line},{col}]", i.start);
                    return V(i, [ i.right, he(st, i) ]).optimize(a);
                }
                if (d && typeof d == "string") {
                    qe.warn("+ in boolean context always true [{file}:{line},{col}]", i.start);
                    return V(i, [ i.left, he(st, i) ]).optimize(a);
                }
                break;

              case "==":
                if (i.left instanceof Kn && i.left.value == "" && i.right.is_string(a)) {
                    return he(zn, i, {
                        operator: "!",
                        expression: i.right
                    }).optimize(a);
                }
                break;

              case "!=":
                if (i.left instanceof Kn && i.left.value == "" && i.right.is_string(a)) {
                    return i.right.optimize(a);
                }
                break;
            }
            var h = a.parent();
            if (a.option("comparisons") && i.is_boolean(a)) {
                if (!(h instanceof qn) || h instanceof Mn) {
                    var v = Z(a, i, he(zn, i, {
                        operator: "!",
                        expression: i.negate(a, $e(a))
                    }));
                    if (v !== i) return v;
                }
                switch (i.operator) {
                  case ">":
                    e("<");
                    break;

                  case ">=":
                    e("<=");
                    break;
                }
            }
            if (a.option("conditionals") && ge[i.operator] && i.right instanceof qn && i.operator == i.right.operator) {
                n();
            }
            if (a.option("strings") && i.operator == "+") {
                if (i.right instanceof Kn && i.right.value == "" && i.left.is_string(a)) {
                    return i.left.optimize(a);
                }
                if (i.left instanceof Kn && i.left.value == "" && i.right.is_string(a)) {
                    return i.right.optimize(a);
                }
                if (i.left instanceof qn && i.left.operator == "+" && i.left.left instanceof Kn && i.left.left.value == "" && i.right.is_string(a)) {
                    i.left = i.left.right;
                    return i.optimize(a);
                }
                if (i.right instanceof qn && i.operator == i.right.operator && (i.left.is_string(a) && i.right.is_string(a) || i.right.left.is_string(a) && (i.left.is_constant() || !i.right.right.has_side_effects(a)))) {
                    n();
                }
            }
            if (a.option("evaluate")) {
                var _ = true;
                switch (i.operator) {
                  case "&&":
                    var p = T(i.left);
                    if (!p) {
                        qe.warn("Condition left of && always false [{file}:{line},{col}]", i.start);
                        return ve(a, h, a.self(), i.left).optimize(a);
                    } else if (!(p instanceof qe)) {
                        qe.warn("Condition left of && always true [{file}:{line},{col}]", i.start);
                        return V(i, [ i.left, i.right ]).optimize(a);
                    }
                    var d = i.right.evaluate(a);
                    if (!d) {
                        if (l) {
                            qe.warn("Boolean && always false [{file}:{line},{col}]", i.start);
                            return V(i, [ i.left, he(at, i) ]).optimize(a);
                        } else i.falsy = true;
                    } else if (!(d instanceof qe)) {
                        if (l || h.operator == "&&" && h.left === a.self()) {
                            qe.warn("Dropping side-effect-free && [{file}:{line},{col}]", i.start);
                            return i.left.optimize(a);
                        }
                    }
                    if (i.left.operator == "||") {
                        var m = i.left.right.evaluate(a, true);
                        if (!m) return he(jn, i, {
                            condition: i.left.left,
                            consequent: i.right,
                            alternative: i.left.right
                        }).optimize(a);
                    }
                    break;

                  case "||":
                    var p = T(i.left);
                    if (!p) {
                        qe.warn("Condition left of || always false [{file}:{line},{col}]", i.start);
                        return V(i, [ i.left, i.right ]).optimize(a);
                    } else if (!(p instanceof qe)) {
                        qe.warn("Condition left of || always true [{file}:{line},{col}]", i.start);
                        return ve(a, h, a.self(), i.left).optimize(a);
                    }
                    var d = i.right.evaluate(a);
                    if (!d) {
                        if (l || h.operator == "||" && h.left === a.self()) {
                            qe.warn("Dropping side-effect-free || [{file}:{line},{col}]", i.start);
                            return i.left.optimize(a);
                        }
                    } else if (!(d instanceof qe)) {
                        if (l) {
                            qe.warn("Boolean || always true [{file}:{line},{col}]", i.start);
                            return V(i, [ i.left, he(st, i) ]).optimize(a);
                        } else i.truthy = true;
                    }
                    if (i.left.operator == "&&") {
                        var m = i.left.right.is_truthy() || i.left.right.evaluate(a, true);
                        if (m && !(m instanceof qe)) return he(jn, i, {
                            condition: i.left.left,
                            consequent: i.left.right,
                            alternative: i.right
                        }).optimize(a);
                    }
                    break;

                  case "+":
                    if (i.left instanceof Xn && i.right instanceof qn && i.right.operator == "+" && i.right.left instanceof Xn && i.right.is_string(a)) {
                        i = he(qn, i, {
                            operator: "+",
                            left: he(Kn, i.left, {
                                value: "" + i.left.value + i.right.left.value,
                                start: i.left.start,
                                end: i.right.left.end
                            }),
                            right: i.right.right
                        });
                    }
                    if (i.right instanceof Xn && i.left instanceof qn && i.left.operator == "+" && i.left.right instanceof Xn && i.left.is_string(a)) {
                        i = he(qn, i, {
                            operator: "+",
                            left: i.left.left,
                            right: he(Kn, i.right, {
                                value: "" + i.left.right.value + i.right.value,
                                start: i.left.right.start,
                                end: i.right.end
                            })
                        });
                    }
                    if (i.right instanceof zn && i.right.operator == "-" && i.left.is_number(a)) {
                        i = he(qn, i, {
                            operator: "-",
                            left: i.left,
                            right: i.right.expression
                        });
                        break;
                    }
                    if (i.left instanceof zn && i.left.operator == "-" && t() && i.right.is_number(a)) {
                        i = he(qn, i, {
                            operator: "-",
                            left: i.right,
                            right: i.left.expression
                        });
                        break;
                    }
                    if (a.option("unsafe_math") && i.left instanceof qn && lt[i.left.operator] == lt[i.operator] && i.right.is_constant() && (i.right.is_boolean(a) || i.right.is_number(a)) && i.left.is_number(a) && !i.left.right.is_constant() && (i.left.left.is_boolean(a) || i.left.left.is_number(a))) {
                        i = he(qn, i, {
                            operator: i.left.operator,
                            left: he(qn, i, {
                                operator: i.operator,
                                left: i.right,
                                right: i.left.left
                            }),
                            right: i.left.right
                        });
                        break;
                    }

                  case "-":
                    if (i.right instanceof zn && i.right.operator == "-" && i.left.is_number(a) && i.right.expression.is_number(a)) {
                        i = he(qn, i, {
                            operator: "+",
                            left: i.left,
                            right: i.right.expression
                        });
                        break;
                    }

                  case "*":
                  case "/":
                    _ = a.option("unsafe_math");
                    if (i.operator != "+") [ "left", "right" ].forEach(function(e) {
                        var n = i[e];
                        if (n instanceof zn && n.operator == "+") {
                            var t = n.expression;
                            if (t.is_boolean(a) || t.is_number(a) || t.is_string(a)) {
                                i[e] = t;
                            }
                        }
                    });

                  case "&":
                  case "|":
                  case "^":
                    if (i.operator != "-" && i.operator != "/" && (i.left.is_boolean(a) || i.left.is_number(a)) && (i.right.is_boolean(a) || i.right.is_number(a)) && t() && !(i.left instanceof qn && i.left.operator != i.operator && lt[i.left.operator] >= lt[i.operator])) {
                        var g = he(qn, i, {
                            operator: i.operator,
                            left: i.right,
                            right: i.left
                        });
                        if (i.right instanceof Xn && !(i.left instanceof Xn)) {
                            i = Z(a, g, i);
                        } else {
                            i = Z(a, i, g);
                        }
                    }
                    if (!_ || !i.is_number(a)) break;
                    if (i.right instanceof qn && i.right.operator != "%" && lt[i.right.operator] == lt[i.operator] && i.right.is_number(a) && (i.operator != "+" || i.right.left.is_boolean(a) || i.right.left.is_number(a)) && (i.operator != "-" || !i.left.is_negative_zero()) && (i.right.left.is_constant_expression() || !i.right.right.has_side_effects(a))) {
                        i = he(qn, i, {
                            operator: E(i.operator, i.right.operator),
                            left: he(qn, i.left, {
                                operator: i.operator,
                                left: i.left,
                                right: i.right.left,
                                start: i.left.start,
                                end: i.right.left.end
                            }),
                            right: i.right.right
                        });
                        if (i.operator == "+" && !i.right.is_boolean(a) && !i.right.is_number(a)) {
                            i.right = he(zn, i.right, {
                                operator: "+",
                                expression: i.right
                            });
                        }
                    }
                    if (i.right instanceof Xn && i.left instanceof qn && i.left.operator != "%" && lt[i.left.operator] == lt[i.operator] && i.left.is_number(a)) {
                        if (i.left.left instanceof Xn) {
                            var u = S(i.left, i.operator, i.left.left, i.right, i.left.left.start, i.right.end);
                            i = S(i, i.left.operator, ee(a, u), i.left.right);
                        } else if (i.left.right instanceof Xn) {
                            var b = E(i.left.operator, i.operator);
                            var y = ee(a, S(i.left, b, i.left.right, i.right));
                            if (y.is_constant() && !(i.left.operator == "-" && i.right.value != 0 && +y.value == 0 && i.left.left.is_negative_zero())) {
                                i = S(i, i.left.operator, i.left.left, y);
                            }
                        }
                    }
                    break;
                }
                if (!(h instanceof zn && h.operator == "delete")) {
                    if (i.left instanceof Qn && !i.right.is_constant()) switch (i.operator) {
                      case "+":
                        if (i.left.value == 0) {
                            if (i.right.is_boolean(a)) return he(zn, i, {
                                operator: "+",
                                expression: i.right
                            }).optimize(a);
                            if (i.right.is_number(a) && !i.right.is_negative_zero()) return i.right;
                        }
                        break;

                      case "*":
                        if (i.left.value == 1) {
                            return i.right.is_number(a) ? i.right : he(zn, i, {
                                operator: "+",
                                expression: i.right
                            }).optimize(a);
                        }
                        break;
                    }
                    if (i.right instanceof Qn && !i.left.is_constant()) switch (i.operator) {
                      case "+":
                        if (i.right.value == 0) {
                            if (i.left.is_boolean(a)) return he(zn, i, {
                                operator: "+",
                                expression: i.left
                            }).optimize(a);
                            if (i.left.is_number(a) && !i.left.is_negative_zero()) return i.left;
                        }
                        break;

                      case "-":
                        if (i.right.value == 0) {
                            return i.left.is_number(a) ? i.left : he(zn, i, {
                                operator: "+",
                                expression: i.left
                            }).optimize(a);
                        }
                        break;

                      case "/":
                        if (i.right.value == 1) {
                            return i.left.is_number(a) ? i.left : he(zn, i, {
                                operator: "+",
                                expression: i.left
                            }).optimize(a);
                        }
                        break;
                    }
                }
            }
            if (a.option("typeofs")) switch (i.operator) {
              case "&&":
                j(i.left, i.right, null);
                break;

              case "||":
                j(i.left, null, i.right);
                break;
            }
            if (a.option("unsafe")) {
                var w = O(i.right);
                if (l && w && (i.operator == "==" || i.operator == "!=") && i.left instanceof Qn && i.left.value == 0) {
                    return (i.operator == "==" ? he(zn, i, {
                        operator: "!",
                        expression: i.right
                    }) : i.right).optimize(a);
                }
                var x = O(i.left);
                if (a.option("comparisons") && D()) {
                    var k = he(zn, i, {
                        operator: "!",
                        expression: he(zn, i, {
                            operator: "~",
                            expression: x ? i.left : i.right
                        })
                    });
                    switch (i.operator) {
                      case "<":
                        if (x) break;

                      case "<=":
                      case "!=":
                        k = he(zn, i, {
                            operator: "!",
                            expression: k
                        });
                        break;
                    }
                    return k.optimize(a);
                }
            }
            return ee(a, i);
            function E(e, n) {
                switch (e) {
                  case "-":
                    return n == "+" ? "-" : "+";

                  case "/":
                    return n == "*" ? "/" : "*";

                  default:
                    return n;
                }
            }
            function S(e, n, t, i, r, o) {
                if (n == "+") {
                    if (!t.is_boolean(a) && !t.is_number(a)) {
                        t = he(zn, t, {
                            operator: "+",
                            expression: t
                        });
                    }
                    if (!i.is_boolean(a) && !i.is_number(a)) {
                        i = he(zn, i, {
                            operator: "+",
                            expression: i
                        });
                    }
                }
                return he(qn, e, {
                    operator: n,
                    left: t,
                    right: i,
                    start: r,
                    end: o
                });
            }
            function T(e) {
                if (e.truthy) return true;
                if (e.falsy) return false;
                if (e.is_truthy()) return true;
                return e.evaluate(a, true);
            }
            function O(e) {
                return e.TYPE == "Call" && e.expression instanceof On && F[e.expression.property];
            }
            function D() {
                switch (i.operator) {
                  case "<=":
                    return w && i.left instanceof Qn && i.left.value == 0;

                  case "<":
                    if (x && i.right instanceof Qn && i.right.value == 0) return true;

                  case "==":
                  case "!=":
                    if (!w) return false;
                    return i.left instanceof Qn && i.left.value == -1 || i.left instanceof zn && i.left.operator == "-" && i.left.expression instanceof Qn && i.left.expression.value == 1;
                }
            }
        });
        function xe(e, n) {
            var t = 0, i = e.self();
            do {
                if (i instanceof Qe && i.name && i.name.definition() === n) return i;
            } while (i = e.parent(t++));
        }
        e(Jn, function(e, n) {
            if (!n.option("ie8") && X(e) && !(e.scope.resolve().uses_with && n.find_parent(Ge))) {
                switch (e.name) {
                  case "undefined":
                    return he(tt, e).optimize(n);

                  case "NaN":
                    return he(nt, e).optimize(n);

                  case "Infinity":
                    return he(rt, e).optimize(n);
                }
            }
            var t = n.parent();
            if (n.option("reduce_vars") && ye(n.self(), t) !== n.self()) {
                var i = e.definition();
                var r = e.fixed_value();
                var o = i.single_use && !(t instanceof kn && t.is_expr_pure(n));
                if (o) {
                    if (r instanceof Qe) {
                        if ((i.scope !== e.scope.resolve() || i.in_loop) && (!n.option("reduce_funcs") || i.escaped.depth == 1 || r.inlined)) {
                            o = false;
                        } else if (xe(n, i)) {
                            o = false;
                        } else if (r.name && r.name.definition() !== i) {
                            o = false;
                        } else if (r.parent_scope !== e.scope.resolve() || i.orig[0] instanceof Yn) {
                            o = r.is_constant_expression(e.scope);
                            if (o == "f") {
                                var a = e.scope;
                                do {
                                    if (a instanceof nn || a instanceof en) {
                                        a.inlined = true;
                                    }
                                } while (a = a.parent_scope);
                            }
                        }
                        if (o) r.parent_scope = e.scope;
                    } else if (!r || !r.is_constant_expression()) {
                        o = false;
                    }
                }
                if (o) {
                    i.single_use = false;
                    r._squeezed = true;
                    r.single_use = true;
                    if (r instanceof nn) {
                        r = he(en, r, r);
                        r.name = he(Vn, r.name, r.name);
                    }
                    if (r instanceof Qe) {
                        var a = e.scope;
                        r.enclosed.forEach(function(e) {
                            if (r.variables.has(e.name)) return;
                            if (a.var_names()[e.name]) return;
                            a.enclosed.push(e);
                            a.var_names()[e.name] = true;
                        });
                    }
                    var s;
                    if (i.recursive_refs > 0) {
                        s = r.clone(true);
                        var f = s.name.definition();
                        var u = s.variables.get(s.name.name);
                        var c = u && u.orig[0];
                        if (!(c instanceof Vn)) {
                            c = he(Vn, s.name, s.name);
                            c.scope = s;
                            s.name = c;
                            u = s.def_function(c);
                            u.recursive_refs = i.recursive_refs;
                        }
                        s.walk(new ft(function(e) {
                            if (!(e instanceof Jn)) return;
                            var n = e.definition();
                            if (n === f) {
                                e.thedef = u;
                                u.references.push(e);
                            } else {
                                n.single_use = false;
                                var t = e.fixed_value();
                                if (!(t instanceof Qe)) return;
                                if (!t.name) return;
                                if (t.name.definition() !== n) return;
                                if (n.scope !== t.name.scope) return;
                                if (r.variables.get(t.name.name) !== n) return;
                                t.name = t.name.clone();
                                var i = s.variables.get(t.name.name) || s.def_function(t.name);
                                e.thedef = i;
                                i.references.push(e);
                            }
                        }));
                    } else {
                        s = r.optimize(n);
                        if (s === r) s = s.transform(new ht(function(e, n) {
                            if (e instanceof Xe) return e;
                            e = e.clone();
                            n(e, this);
                            return e;
                        }));
                    }
                    i.replaced++;
                    return s;
                }
                var l = e.fixed !== i.fixed;
                if (r && (l || i.should_replace !== false)) {
                    var p;
                    if (r instanceof Gn) {
                        if (!(i.orig[0] instanceof Yn) && g(i)) {
                            p = r;
                        }
                    } else {
                        var d = r.evaluate(n, true);
                        if (d !== r && typeof d != "function" && (typeof d != "object" || d instanceof RegExp && n.option("unsafe_regexp") && !i.cross_loop && g(i))) {
                            p = S(d, r);
                        }
                    }
                    if (p) {
                        if (!l && i.should_replace === undefined) {
                            var h = p.optimize(n).print_to_string().length;
                            if (!b(r)) {
                                h = Math.min(h, r.print_to_string().length);
                            }
                            var v = i.name.length;
                            if (n.option("unused") && !n.exposed(i)) {
                                var _ = i.references.length - i.replaced;
                                v += (v + 2 + h) / (_ - i.assignments);
                            }
                            var m = h - Math.floor(v);
                            i.should_replace = m < n.eval_threshold;
                        }
                        if (l || i.should_replace) {
                            var s;
                            if (b(r)) {
                                s = p.optimize(n);
                                if (s === p) s = s.clone(true);
                            } else {
                                s = Q(p.optimize(n), r);
                                if (s === p || s === r) s = s.clone(true);
                            }
                            i.replaced++;
                            return s;
                        }
                    }
                }
            }
            return e;
            function g(e) {
                var n = e.scope.resolve();
                return De(e.references, function(e) {
                    return n === e.scope.resolve();
                });
            }
            function b(e) {
                var n;
                e.walk(new ft(function(e) {
                    if (e instanceof Jn) n = true;
                    if (n) return true;
                }));
                return n;
            }
        });
        function H(e, n) {
            return e instanceof Jn || e.TYPE === n.TYPE;
        }
        e(tt, function(e, n) {
            if (n.option("unsafe_undefined")) {
                var t = L(n).find_variable("undefined");
                if (t) {
                    var i = he(Jn, e, {
                        name: "undefined",
                        scope: t.scope,
                        thedef: t
                    });
                    i.is_undefined = true;
                    return i;
                }
            }
            var r = ye(n.self(), n.parent());
            if (r && H(r, e)) return e;
            return he(zn, e, {
                operator: "void",
                expression: he(Qn, e, {
                    value: 0
                })
            });
        });
        e(rt, function(e, n) {
            var t = ye(n.self(), n.parent());
            if (t && H(t, e)) return e;
            if (n.option("keep_infinity") && !(t && !H(t, e)) && !L(n).find_variable("Infinity")) return e;
            return he(qn, e, {
                operator: "/",
                left: he(Qn, e, {
                    value: 1
                }),
                right: he(Qn, e, {
                    value: 0
                })
            });
        });
        e(nt, function(e, n) {
            var t = ye(n.self(), n.parent());
            if (t && !H(t, e) || L(n).find_variable("NaN")) {
                return he(qn, e, {
                    operator: "/",
                    left: he(Qn, e, {
                        value: 0
                    }),
                    right: he(Qn, e, {
                        value: 0
                    })
                });
            }
            return e;
        });
        function re(t, n) {
            var i = false;
            var r = new ft(function(e) {
                if (i) return true;
                if (e instanceof Jn && ke(e.definition(), n)) {
                    return i = true;
                }
            });
            var o = new ft(function(e) {
                if (i) return true;
                if (e instanceof Xe && e !== t) {
                    var n = o.parent();
                    if (n instanceof kn && n.expression === e) return;
                    e.walk(r);
                    return true;
                }
            });
            t.walk(o);
            return i;
        }
        var I = Oe("+ - * / % >> << >>> | ^ &");
        var U = Oe("* | ^ &");
        e(Mn, function(o, a) {
            if (a.option("dead_code")) {
                if (o.left instanceof Tn) {
                    if (o.operator == "=") {
                        if (o.__drop) {
                            var e = [ o.left.expression ];
                            if (o.left instanceof Dn) e.push(o.left.property);
                            e.push(o.right);
                            return V(o, e).optimize(a);
                        }
                        if (o.left.equivalent_to(o.right) && !o.left.has_side_effects(a)) {
                            return o.right;
                        }
                        var n = o.left.expression;
                        if (n instanceof Qe || !a.has_directive("use strict") && n instanceof Xn && !n.may_throw_on_access(a)) {
                            return o.left instanceof On ? o.right : V(o, [ o.left.property, o.right ]).optimize(a);
                        }
                    }
                } else if (o.left instanceof Jn && De(o.left.definition().orig, function(e) {
                    return !(e instanceof Rn);
                })) {
                    var t;
                    if (o.operator == "=" && o.left.equivalent_to(o.right) && !((t = a.parent()) instanceof zn && t.operator == "delete")) {
                        return o.right;
                    }
                    if (o.left.is_immutable()) return d();
                    var i = o.left.definition();
                    var s = i.scope.resolve();
                    var r = s === a.find_parent(Qe);
                    var f = 0, u;
                    t = o;
                    do {
                        u = t;
                        t = a.parent(f++);
                        if (t instanceof Mn) {
                            if (t.left instanceof Tn) break;
                            if (!(t.left instanceof Jn)) continue;
                            if (t.left.definition() !== i) continue;
                            if (p(f, t)) break;
                            i.fixed = false;
                            return d();
                        } else if (t instanceof rn) {
                            if (!r) break;
                            if (p(f, t)) break;
                            if (re(s, [ i ])) break;
                            i.fixed = false;
                            return d();
                        } else if (t instanceof xn) {
                            if (t.name.definition() !== i) continue;
                            if (p(f, t)) break;
                            i.fixed = false;
                            return d();
                        }
                    } while (t instanceof qn && t.right === u || t instanceof Sn && t.tail_node() === u || t instanceof zn);
                }
            }
            if (a.option("sequences")) {
                var c = o.lift_sequences(a);
                if (c !== o) return c.optimize(a);
            }
            if (a.option("assignments")) {
                if (o.operator == "=" && o.left instanceof Jn && o.right instanceof qn) {
                    if (o.right.left instanceof Jn && o.right.left.name == o.left.name && I[o.right.operator]) {
                        return he(Mn, o, {
                            operator: o.right.operator + "=",
                            left: o.left,
                            right: o.right.right
                        }).optimize(a);
                    } else if (o.right.right instanceof Jn && o.right.right.name == o.left.name && U[o.right.operator] && !o.right.left.has_side_effects(a)) {
                        return he(Mn, o, {
                            operator: o.right.operator + "=",
                            left: o.left,
                            right: o.right.left
                        }).optimize(a);
                    }
                }
                if ((o.operator == "-=" || o.operator == "+=" && (o.left.is_boolean(a) || o.left.is_number(a))) && o.right instanceof Qn && o.right.value == 1) {
                    var l = o.operator.slice(0, -1);
                    return he(zn, o, {
                        operator: l + l,
                        expression: o.left
                    });
                }
            }
            return ee(a, o);
            function p(e, n) {
                var t = o.right;
                o.right = he(et, t);
                var i = n.may_throw(a);
                o.right = t;
                var r;
                while (r = a.parent(e++)) {
                    if (r === s) return false;
                    if (r instanceof vn) {
                        if (r.bfinally) return true;
                        if (i && r.bcatch) return true;
                    }
                }
            }
            function d() {
                return (o.operator != "=" ? he(qn, o, {
                    operator: o.operator.slice(0, -1),
                    left: o.left,
                    right: o.right
                }) : ve(a, a.parent(), o, o.right)).optimize(a);
            }
        });
        e(jn, function(o, n) {
            if (n.option("sequences") && o.condition instanceof Sn) {
                var e = o.condition.expressions.slice();
                o.condition = e.pop();
                e.push(o);
                return V(o, e);
            }
            if (!n.option("conditionals")) return o;
            var a = o.condition.is_truthy() || o.condition.evaluate(n, true);
            if (!a) {
                qe.warn("Condition always false [{file}:{line},{col}]", o.start);
                return V(o, [ o.condition, o.alternative ]).optimize(n);
            } else if (!(a instanceof qe)) {
                qe.warn("Condition always true [{file}:{line},{col}]", o.start);
                return V(o, [ o.condition, o.consequent ]).optimize(n);
            }
            var t = a.negate(n, $e(n));
            if (Z(n, a, t) === t) {
                o = he(jn, o, {
                    condition: t,
                    consequent: o.alternative,
                    alternative: o.consequent
                });
                t = a;
                a = o.condition;
            }
            var i = o.consequent;
            var r = o.alternative;
            if (N(n, a)) {
                if (a.equivalent_to(i)) return he(qn, o, {
                    operator: "||",
                    left: a,
                    right: r
                }).optimize(n);
                if (a.equivalent_to(r)) return he(qn, o, {
                    operator: "&&",
                    left: a,
                    right: i
                }).optimize(n);
            }
            var s = i.tail_node();
            if (s instanceof Mn) {
                var f = s.operator == "=";
                var u = f ? r.tail_node() : r;
                if ((f || i === s) && u instanceof Mn && s.operator == u.operator && s.left.equivalent_to(u.left) && (f && s.left instanceof Jn || !a.has_side_effects(n) && y(i) && y(r))) {
                    return he(Mn, o, {
                        operator: s.operator,
                        left: s.left,
                        right: he(jn, o, {
                            condition: a,
                            consequent: w(i),
                            alternative: w(r)
                        })
                    });
                }
            }
            if (i.equivalent_to(r)) return V(o, [ a, i ]).optimize(n);
            var c = b(i, r, true);
            if (c) return c;
            var l;
            if (i instanceof kn && r.TYPE == i.TYPE && (l = m(i, r)) >= 0 && i.expression.equivalent_to(r.expression) && !a.has_side_effects(n) && !i.expression.has_side_effects(n)) {
                var p = i.clone();
                p.args[l] = he(jn, o, {
                    condition: a,
                    consequent: i.args[l],
                    alternative: r.args[l]
                });
                return p;
            }
            if (i instanceof jn && i.alternative.equivalent_to(r)) {
                return he(jn, o, {
                    condition: he(qn, o, {
                        left: a,
                        operator: "&&",
                        right: i.condition
                    }),
                    consequent: i.consequent,
                    alternative: r
                });
            }
            if (i instanceof jn && i.consequent.equivalent_to(r)) {
                return he(jn, o, {
                    condition: he(qn, o, {
                        left: t,
                        operator: "||",
                        right: i.condition
                    }),
                    consequent: r,
                    alternative: i.alternative
                });
            }
            if (r instanceof jn && i.equivalent_to(r.consequent)) {
                return he(jn, o, {
                    condition: he(qn, o, {
                        left: a,
                        operator: "||",
                        right: r.condition
                    }),
                    consequent: i,
                    alternative: r.alternative
                });
            }
            if (r instanceof jn && i.equivalent_to(r.alternative)) {
                return he(jn, o, {
                    condition: he(qn, o, {
                        left: t,
                        operator: "&&",
                        right: r.condition
                    }),
                    consequent: r.consequent,
                    alternative: i
                });
            }
            if ((i instanceof Sn || r instanceof Sn) && i.tail_node().equivalent_to(r.tail_node())) {
                return V(o, [ he(jn, o, {
                    condition: a,
                    consequent: x(i),
                    alternative: x(r)
                }), i.tail_node() ]).optimize(n);
            }
            if (i instanceof qn && i.operator == "&&" && i.right.equivalent_to(r)) {
                return he(qn, o, {
                    operator: "&&",
                    left: he(qn, o, {
                        operator: "||",
                        left: t,
                        right: i.left
                    }),
                    right: r
                }).optimize(n);
            }
            if (i instanceof qn && i.operator == "||" && i.right.equivalent_to(r)) {
                return he(qn, o, {
                    operator: "||",
                    left: he(qn, o, {
                        operator: "&&",
                        left: a,
                        right: i.left
                    }),
                    right: r
                }).optimize(n);
            }
            if (r instanceof qn && r.operator == "&&" && r.right.equivalent_to(i)) {
                return he(qn, o, {
                    operator: "&&",
                    left: he(qn, o, {
                        operator: "||",
                        left: a,
                        right: r.left
                    }),
                    right: i
                }).optimize(n);
            }
            if (r instanceof qn && r.operator == "||" && r.right.equivalent_to(i)) {
                return he(qn, o, {
                    operator: "||",
                    left: he(qn, o, {
                        operator: "&&",
                        left: t,
                        right: r.left
                    }),
                    right: i
                }).optimize(n);
            }
            var d = n.option("booleans") && n.in_boolean_context();
            if (v(i)) {
                if (_(r)) {
                    return h(a);
                }
                return he(qn, o, {
                    operator: "||",
                    left: h(a),
                    right: r
                });
            }
            if (_(i)) {
                if (v(r)) {
                    return h(a.negate(n));
                }
                return he(qn, o, {
                    operator: "&&",
                    left: h(a.negate(n)),
                    right: r
                });
            }
            if (v(r)) {
                return he(qn, o, {
                    operator: "||",
                    left: h(a.negate(n)),
                    right: i
                });
            }
            if (_(r)) {
                return he(qn, o, {
                    operator: "&&",
                    left: h(a),
                    right: i
                });
            }
            if (n.option("typeofs")) j(a, i, r);
            return o;
            function h(e) {
                if (e.is_boolean(n)) return e;
                return he(zn, e, {
                    operator: "!",
                    expression: e.negate(n)
                });
            }
            function v(e) {
                return e instanceof st || d && e instanceof Xn && e.value || e instanceof zn && e.operator == "!" && e.expression instanceof Xn && !e.expression.value;
            }
            function _(e) {
                return e instanceof at || d && (e instanceof Xn && !e.value || e instanceof zn && e.operator == "void" && !e.expression.has_side_effects(n)) || e instanceof zn && e.operator == "!" && e.expression instanceof Xn && e.expression.value;
            }
            function m(e, n) {
                var t = e.args;
                var i = n.args;
                var r = t.length;
                if (r != i.length) return -2;
                for (var o = 0; o < r; o++) {
                    if (!t[o].equivalent_to(i[o])) {
                        for (var a = o + 1; a < r; a++) {
                            if (!t[a].equivalent_to(i[a])) return -2;
                        }
                        return o;
                    }
                }
                return -1;
            }
            function g(e, n) {
                if (e.TYPE != n.TYPE) return;
                if (e instanceof kn) {
                    if (m(e, n) != -1) return;
                    return e.TYPE != "Call" || !(e.expression instanceof Tn || n.expression instanceof Tn) || g(e.expression, n.expression);
                }
                if (e instanceof On) return e.property == n.property;
                if (e instanceof Dn) return e.property.equivalent_to(n.property);
            }
            function b(e, n, t) {
                if (!g(e, n)) return !t && he(jn, o, {
                    condition: a,
                    consequent: e,
                    alternative: n
                });
                var i = b(e.expression, n.expression);
                if (!i) return;
                var r = e.clone();
                r.expression = i;
                return r;
            }
            function y(e) {
                return e === e.tail_node() || De(e.expressions.slice(0, -1), function(e) {
                    return !e.has_side_effects(n);
                });
            }
            function w(e) {
                if (!(e instanceof Sn)) return e.right;
                var n = e.expressions.slice();
                n.push(n.pop().right);
                return V(e, n);
            }
            function x(e) {
                if (!(e instanceof Sn)) return he(Qn, e, {
                    value: 0
                });
                return V(e, e.expressions.slice(0, -1));
            }
        });
        e(ot, function(e, n) {
            if (!n.option("booleans")) return e;
            if (n.in_boolean_context()) return he(Qn, e, {
                value: +e.value
            });
            var t = n.parent();
            if (t instanceof qn && (t.operator == "==" || t.operator == "!=")) {
                qe.warn("Non-strict equality against boolean: {operator} {value} [{file}:{line},{col}]", {
                    operator: t.operator,
                    value: e.value,
                    file: t.start.file,
                    line: t.start.line,
                    col: t.start.col
                });
                return he(Qn, e, {
                    value: +e.value
                });
            }
            return he(zn, e, {
                operator: "!",
                expression: he(Qn, e, {
                    value: 1 - e.value
                })
            });
        });
        function B(e, n) {
            if (e instanceof Jn) {
                e = e.fixed_value();
            }
            if (!e) return false;
            if (!(e instanceof Qe)) return true;
            var t = n.parent();
            if (t.TYPE != "Call") return true;
            if (t.expression !== n.self()) return true;
            return !e.contains_this();
        }
        e(Dn, function(e, t) {
            var n = e.expression;
            var i = e.property;
            if (t.option("properties")) {
                var r = i.evaluate(t);
                if (r !== i) {
                    if (typeof r == "string") {
                        if (r == "undefined") {
                            r = undefined;
                        } else {
                            var o = parseFloat(r);
                            if (o.toString() == r) {
                                r = o;
                            }
                        }
                    }
                    i = e.property = Q(i, S(r, i).transform(t));
                    var a = "" + r;
                    if (ut(a) && a.length <= i.print_to_string().length + 1) {
                        return he(On, e, {
                            expression: n,
                            property: a
                        }).optimize(t);
                    }
                }
            }
            var s = t.parent();
            var f, u, c;
            if (t.option("arguments") && n instanceof Jn && pe(f = n.definition()) && i instanceof Qn && (u = n.scope.resolve()) === k()) {
                var l = i.value;
                if (s instanceof zn && s.operator == "delete") {
                    if (!f.deleted) f.deleted = [];
                    f.deleted[l] = true;
                }
                var p = u.argnames[l];
                if (f.deleted && f.deleted[l]) {
                    p = null;
                } else if (p && (t.has_directive("use strict") || !(c instanceof kn && l < c.args.length))) {
                    var d = p.definition();
                    if (!t.option("reduce_vars") || f.reassigned || d.assignments || d.orig.length > 1) {
                        p = null;
                    }
                } else if (!p && l < u.argnames.length + 5 && t.drop_fargs(u, c)) {
                    while (l >= u.argnames.length) {
                        p = he(Yn, u, {
                            name: u.make_var_name("argument_" + u.argnames.length),
                            scope: u
                        });
                        u.argnames.push(p);
                        u.enclosed.push(u.def_variable(p));
                    }
                }
                if (p && oe(function(e) {
                    return e.name === p.name;
                }, u.argnames) === p) {
                    f.reassigned = false;
                    var h = he(Jn, e, p);
                    h.reference({});
                    delete p.__unused;
                    return h;
                }
            }
            if (ye(t.self(), s)) return e;
            if (t.option("sequences") && s.TYPE != "Call" && !(s instanceof Je && s.init === e)) {
                var v = te(e, t);
                if (v !== e) return v.optimize(t);
            }
            if (r !== i) {
                var _ = e.flatten_object(a, t);
                if (_) {
                    n = e.expression = _.expression;
                    i = e.property = _.property;
                }
            }
            if (t.option("properties") && t.option("side_effects") && i instanceof Qn && n instanceof Cn) {
                var l = i.value;
                var m = n.elements;
                var g = m[l];
                if (B(g, t)) {
                    var b = g instanceof it;
                    var y = !b;
                    var w = [];
                    for (var x = m.length; --x > l; ) {
                        var o = m[x].drop_side_effect_free(t);
                        if (o) {
                            w.unshift(o);
                            if (y && o.has_side_effects(t)) y = false;
                        }
                    }
                    if (!y) w.unshift(g);
                    while (--x >= 0) {
                        var o = m[x].drop_side_effect_free(t);
                        if (o) {
                            w.unshift(o);
                        } else if (b) {
                            w.unshift(he(it, m[x]));
                        } else {
                            l--;
                        }
                    }
                    if (y) {
                        w.push(g);
                        return V(e, w).optimize(t);
                    } else return he(Dn, e, {
                        expression: he(Cn, n, {
                            elements: w
                        }),
                        property: he(Qn, i, {
                            value: l
                        })
                    });
                }
            }
            return ee(t, e);
            function k() {
                var e = 0, n;
                while (n = t.parent(e++)) {
                    if (n instanceof Qe) {
                        if (n instanceof Ze) return;
                        c = t.parent(e);
                        return n;
                    }
                }
            }
        });
        Xe.DEFMETHOD("contains_this", function() {
            var n;
            var t = this;
            t.walk(new ft(function(e) {
                if (n) return true;
                if (e instanceof Gn) return n = true;
                if (e !== t && e instanceof Xe) return true;
            }));
            return n;
        });
        Tn.DEFMETHOD("flatten_object", function(e, n) {
            if (!n.option("properties")) return;
            var t = this.expression;
            if (t instanceof Fn) {
                var i = t.properties;
                for (var r = i.length; --r >= 0; ) {
                    var o = i[r];
                    if ("" + o.key == e) {
                        if (!De(i, function(e) {
                            return e instanceof Nn;
                        })) break;
                        if (!B(o.value, n)) break;
                        return he(Dn, this, {
                            expression: he(Cn, t, {
                                elements: i.map(function(e) {
                                    return e.value;
                                })
                            }),
                            property: he(Qn, this, {
                                value: r
                            })
                        });
                    }
                }
            }
        });
        e(On, function(e, n) {
            if (e.property == "arguments" || e.property == "caller") {
                qe.warn("Function.prototype.{prop} not supported [{file}:{line},{col}]", {
                    prop: e.property,
                    file: e.start.file,
                    line: e.start.line,
                    col: e.start.col
                });
            }
            var t = n.parent();
            if (ye(n.self(), t)) return e;
            if (n.option("sequences") && t.TYPE != "Call" && !(t instanceof Je && t.init === e)) {
                var i = te(e, n);
                if (i !== e) return i.optimize(n);
            }
            if (n.option("unsafe_proto") && e.expression instanceof On && e.expression.property == "prototype") {
                var r = e.expression.expression;
                if (X(r)) switch (r.name) {
                  case "Array":
                    e.expression = he(Cn, e.expression, {
                        elements: []
                    });
                    break;

                  case "Function":
                    e.expression = he(en, e.expression, {
                        argnames: [],
                        body: []
                    }).init_vars(r.scope);
                    break;

                  case "Number":
                    e.expression = he(Qn, e.expression, {
                        value: 0
                    });
                    break;

                  case "Object":
                    e.expression = he(Fn, e.expression, {
                        properties: []
                    });
                    break;

                  case "RegExp":
                    e.expression = he(Zn, e.expression, {
                        value: /t/
                    });
                    break;

                  case "String":
                    e.expression = he(Kn, e.expression, {
                        value: ""
                    });
                    break;
                }
            }
            var o = e.flatten_object(e.property, n);
            if (o) return o.optimize(n);
            return ee(n, e);
        });
        e(Fn, function(t, n) {
            if (!n.option("objects") || n.has_directive("use strict")) return t;
            var i = new Ae();
            var r = [];
            t.properties.forEach(function(e) {
                if (typeof e.key != "string") {
                    o();
                    r.push(e);
                    return;
                }
                if (e.value.has_side_effects(n)) {
                    o();
                }
                i.add(e.key, e.value);
            });
            o();
            if (t.properties.length != r.length) {
                return he(Fn, t, {
                    properties: r
                });
            }
            return t;
            function o() {
                i.each(function(e, n) {
                    r.push(he(Nn, t, {
                        key: n,
                        value: V(t, e)
                    }));
                });
                i = new Ae();
            }
        });
        e(on, function(e, n) {
            if (e.value && $(e.value, n)) {
                e.value = null;
            }
            return e;
        });
    })(function(e, i) {
        e.DEFMETHOD("optimize", function(e) {
            var n = this;
            if (n._optimized) return n;
            if (e.has_directive("use asm")) return n;
            var t = i(n, e);
            t._optimized = true;
            return t;
        });
    });
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    var x = e("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/");
    var k = x.reduce(function(e, n, t) {
        e[n] = t;
        return e;
    }, Object.create(null));
    function E(e, n) {
        var t = 0;
        var i = 0;
        for (var r = 0, o = 0; r < n.length; r++) {
            var a = k[n[r]];
            t += (a & 31) << i;
            if (a & 32) {
                i += 5;
            } else {
                e[o++] += t & 1 ? 2147483648 | -(t >> 1) : t >> 1;
                t = i = 0;
            }
        }
        return o;
    }
    function S(e) {
        var n = "";
        e = Math.abs(e) << 1 | e >>> 31;
        do {
            var t = e & 31;
            if (e >>>= 5) t |= 32;
            n += x[t];
        } while (e);
        return n;
    }
    function T() {
        var n = Object.create(null);
        var t = [];
        t.index = function(e) {
            if (!ze(n, e)) {
                n[e] = t.length;
                t.push(e);
            }
            return n[e];
        };
        return t;
    }
    function O(l) {
        var f = T();
        var o = l.includeSources && Object.create(null);
        var u = T();
        var c = "";
        if (l.orig) Object.keys(l.orig).forEach(function(e) {
            var n = l.orig[e];
            var t = [ 0, 0, 1, 0, 0 ];
            l.orig[e] = {
                names: n.names,
                mappings: n.mappings.split(/;/).map(function(e) {
                    t[0] = 0;
                    return e.split(/,/).map(function(e) {
                        return t.slice(0, E(t, e));
                    });
                }),
                sources: n.sources
            };
            if (!o || !n.sourcesContent) return;
            for (var i = 0; i < n.sources.length; i++) {
                var r = n.sourcesContent[i];
                if (r) o[n.sources[i]] = r;
            }
        });
        var p;
        var d = 1;
        var h = 0;
        var v = 0;
        var _ = 1;
        var m = 0;
        var g = 0;
        return {
            add: l.orig ? function(e, n, t, i, r, o) {
                var a = l.orig[e];
                if (a) {
                    var s = a.mappings[i - 1];
                    if (!s) return;
                    var f;
                    for (var u = 0; u < s.length; u++) {
                        var c = s[u][0];
                        if (r >= c) f = s[u];
                        if (r <= c) break;
                    }
                    if (!f || f.length < 4) {
                        e = null;
                    } else {
                        e = a.sources[f[1]];
                        i = f[2];
                        r = f[3];
                        if (f.length > 4) o = a.names[f[4]];
                    }
                }
                b(e, n, t, i, r, o);
            } : b,
            setSourceContent: o ? function(e, n) {
                o[e] = n;
            } : ae,
            toString: function() {
                return JSON.stringify({
                    version: 3,
                    file: l.filename || undefined,
                    sourceRoot: l.root || undefined,
                    sources: f,
                    sourcesContent: o ? f.map(function(e) {
                        return o[e] || null;
                    }) : undefined,
                    names: u,
                    mappings: c
                });
            }
        };
        function b(e, n, t, i, r, o) {
            if (p == null && e == null) return;
            p = e;
            if (d < n) {
                h = 0;
                do {
                    c += ";";
                } while (++d < n);
            } else if (c) {
                c += ",";
            }
            c += S(t - h);
            h = t;
            if (e == null) return;
            var a = f.index(e);
            c += S(a - v);
            v = a;
            c += S(i - _);
            _ = i;
            c += S(r - m);
            m = r;
            if (l.names && o != null) {
                var s = u.index(o);
                c += S(s - g);
                g = s;
            }
        }
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    (function() {
        function n(e) {
            var n = true;
            for (var t = 0; t < e.length; t++) {
                if (n && e[t] instanceof je && e[t].body instanceof Kn) {
                    e[t] = new Ce({
                        start: e[t].start,
                        end: e[t].end,
                        value: e[t].body.value
                    });
                } else if (n && !(e[t] instanceof je && e[t].body instanceof Kn)) {
                    n = false;
                }
            }
            return e;
        }
        var i = {
            Program: function(e) {
                return new Ke({
                    start: s(e),
                    end: f(e),
                    body: n(e.body.map(u))
                });
            },
            FunctionDeclaration: function(e) {
                return new nn({
                    start: s(e),
                    end: f(e),
                    name: u(e.id),
                    argnames: e.params.map(u),
                    body: n(u(e.body).body)
                });
            },
            FunctionExpression: function(e) {
                return new en({
                    start: s(e),
                    end: f(e),
                    name: u(e.id),
                    argnames: e.params.map(u),
                    body: n(u(e.body).body)
                });
            },
            ExpressionStatement: function(e) {
                return new Pe({
                    start: s(e),
                    end: f(e),
                    body: u(e.expression)
                });
            },
            TryStatement: function(e) {
                var n = e.handlers || [ e.handler ];
                if (n.length > 1 || e.guardedHandlers && e.guardedHandlers.length) {
                    throw new Error("Multiple catch clauses are not supported.");
                }
                return new vn({
                    start: s(e),
                    end: f(e),
                    body: u(e.block).body,
                    bcatch: u(n[0]),
                    bfinally: e.finalizer ? new mn(u(e.finalizer)) : null
                });
            },
            Property: function(e) {
                var n = e.key;
                var t = {
                    start: s(n),
                    end: f(e.value),
                    key: "" + n[n.type == "Identifier" ? "name" : "value"],
                    value: u(e.value)
                };
                if (e.kind == "init") return new Nn(t);
                t.key = new de({
                    name: t.key
                });
                t.value = new Ze(t.value);
                if (e.kind == "get") return new pe(t);
                if (e.kind == "set") return new le(t);
            },
            ArrayExpression: function(e) {
                return new Cn({
                    start: s(e),
                    end: f(e),
                    elements: e.elements.map(function(e) {
                        return e === null ? new it() : u(e);
                    })
                });
            },
            ObjectExpression: function(e) {
                return new Fn({
                    start: s(e),
                    end: f(e),
                    properties: e.properties.map(function(e) {
                        e.type = "Property";
                        return u(e);
                    })
                });
            },
            SequenceExpression: function(e) {
                return new Sn({
                    start: s(e),
                    end: f(e),
                    expressions: e.expressions.map(u)
                });
            },
            MemberExpression: function(e) {
                return new (e.computed ? Dn : On)({
                    start: s(e),
                    end: f(e),
                    property: e.computed ? u(e.property) : e.property.name,
                    expression: u(e.object)
                });
            },
            SwitchCase: function(e) {
                return new (e.test ? hn : dn)({
                    start: s(e),
                    end: f(e),
                    expression: u(e.test),
                    body: e.consequent.map(u)
                });
            },
            VariableDeclaration: function(e) {
                return new wn({
                    start: s(e),
                    end: f(e),
                    definitions: e.declarations.map(u)
                });
            },
            Literal: function(e) {
                var n = e.value, t = {
                    start: s(e),
                    end: f(e)
                };
                if (n === null) return new et(t);
                var i = e.regex;
                if (i && i.pattern) {
                    t.value = new RegExp(i.pattern, i.flags);
                    t.value.raw_source = i.pattern;
                    return new Zn(t);
                } else if (i) {
                    t.value = e.regex && e.raw ? e.raw : n;
                    return new Zn(t);
                }
                switch (typeof n) {
                  case "string":
                    t.value = n;
                    return new Kn(t);

                  case "number":
                    t.value = n;
                    return new Qn(t);

                  case "boolean":
                    return new (n ? st : at)(t);
                }
            },
            Identifier: function(e) {
                var n = o[o.length - 2];
                return new (n.type == "LabeledStatement" ? he : n.type == "VariableDeclarator" && n.id === e ? Bn : n.type == "FunctionExpression" ? n.id === e ? Vn : Yn : n.type == "FunctionDeclaration" ? n.id === e ? Ln : Yn : n.type == "CatchClause" ? Wn : n.type == "BreakStatement" || n.type == "ContinueStatement" ? ve : Jn)({
                    start: s(e),
                    end: f(e),
                    name: e.name
                });
            },
            ThisExpression: function(e) {
                return new Gn({
                    start: s(e),
                    end: f(e),
                    name: "this"
                });
            }
        };
        i.UpdateExpression = i.UnaryExpression = function e(n) {
            var t = "prefix" in n ? n.prefix : n.type == "UnaryExpression" ? true : false;
            return new (t ? zn : $n)({
                start: s(n),
                end: f(n),
                operator: n.operator,
                expression: u(n.argument)
            });
        };
        e("EmptyStatement", Fe);
        e("BlockStatement", Re, "body@body");
        e("IfStatement", cn, "test>condition, consequent>body, alternate>alternative");
        e("LabeledStatement", Ue, "label>label, body>body");
        e("BreakStatement", fn, "label>label");
        e("ContinueStatement", un, "label>label");
        e("WithStatement", Ge, "object>expression, body>body");
        e("SwitchStatement", ln, "discriminant>expression, cases@body");
        e("ReturnStatement", on, "argument>value");
        e("ThrowStatement", an, "argument>value");
        e("WhileStatement", Ve, "test>condition, body>body");
        e("DoWhileStatement", Le, "test>condition, body>body");
        e("ForStatement", We, "init>init, test>condition, update>step, body>body");
        e("ForInStatement", Je, "left>init, right>object, body>body");
        e("DebuggerStatement", Me);
        e("VariableDeclarator", xn, "id>name, init>value");
        e("CatchClause", _n, "param>argname, body%body");
        e("BinaryExpression", qn, "operator=operator, left>left, right>right");
        e("LogicalExpression", qn, "operator=operator, left>left, right>right");
        e("AssignmentExpression", Mn, "operator=operator, left>left, right>right");
        e("ConditionalExpression", jn, "test>condition, consequent>consequent, alternate>alternative");
        e("NewExpression", En, "callee>expression, arguments@args");
        e("CallExpression", kn, "callee>expression, arguments@args");
        c(Ke, function e(n) {
            return d("Program", n);
        });
        c(nn, function e(n) {
            return {
                type: "FunctionDeclaration",
                id: l(n.name),
                params: n.argnames.map(l),
                body: d("BlockStatement", n)
            };
        });
        c(en, function e(n) {
            return {
                type: "FunctionExpression",
                id: l(n.name),
                params: n.argnames.map(l),
                body: d("BlockStatement", n)
            };
        });
        c(Ce, function e(n) {
            return {
                type: "ExpressionStatement",
                expression: {
                    type: "Literal",
                    value: n.value
                }
            };
        });
        c(Pe, function e(n) {
            return {
                type: "ExpressionStatement",
                expression: l(n.body)
            };
        });
        c(pn, function e(n) {
            return {
                type: "SwitchCase",
                test: l(n.expression),
                consequent: n.body.map(l)
            };
        });
        c(vn, function e(n) {
            return {
                type: "TryStatement",
                block: p(n),
                handler: l(n.bcatch),
                guardedHandlers: [],
                finalizer: l(n.bfinally)
            };
        });
        c(_n, function e(n) {
            return {
                type: "CatchClause",
                param: l(n.argname),
                guard: null,
                body: p(n)
            };
        });
        c(gn, function e(n) {
            return {
                type: "VariableDeclaration",
                kind: "var",
                declarations: n.definitions.map(l)
            };
        });
        c(Sn, function e(n) {
            return {
                type: "SequenceExpression",
                expressions: n.expressions.map(l)
            };
        });
        c(Tn, function e(n) {
            var t = n instanceof Dn;
            return {
                type: "MemberExpression",
                object: l(n.expression),
                computed: t,
                property: t ? l(n.property) : {
                    type: "Identifier",
                    name: n.property
                }
            };
        });
        c(An, function e(n) {
            return {
                type: n.operator == "++" || n.operator == "--" ? "UpdateExpression" : "UnaryExpression",
                operator: n.operator,
                prefix: n instanceof zn,
                argument: l(n.expression)
            };
        });
        c(qn, function e(n) {
            return {
                type: n.operator == "&&" || n.operator == "||" ? "LogicalExpression" : "BinaryExpression",
                left: l(n.left),
                operator: n.operator,
                right: l(n.right)
            };
        });
        c(Cn, function e(n) {
            return {
                type: "ArrayExpression",
                elements: n.elements.map(l)
            };
        });
        c(Fn, function e(n) {
            return {
                type: "ObjectExpression",
                properties: n.properties.map(l)
            };
        });
        c(Pn, function e(n) {
            var t = {
                type: "Literal",
                value: n.key instanceof de ? n.key.name : n.key
            };
            var i;
            if (n instanceof Nn) {
                i = "init";
            } else if (n instanceof pe) {
                i = "get";
            } else if (n instanceof le) {
                i = "set";
            }
            return {
                type: "Property",
                kind: i,
                key: t,
                value: l(n.value)
            };
        });
        c(Hn, function e(n) {
            var t = n.definition();
            return {
                type: "Identifier",
                name: t && t.mangled_name || n.name
            };
        });
        c(Gn, function e() {
            return {
                type: "ThisExpression"
            };
        });
        c(Zn, function e(n) {
            var t = n.value.toString().match(/[gimuy]*$/)[0];
            var i = "/" + n.value.raw_source + "/" + t;
            return {
                type: "Literal",
                value: i,
                raw: i,
                regex: {
                    pattern: n.value.raw_source,
                    flags: t
                }
            };
        });
        c(Xn, function e(n) {
            var t = n.value;
            if (typeof t === "number" && (t < 0 || t === 0 && 1 / t < 0)) {
                return {
                    type: "UnaryExpression",
                    operator: "-",
                    prefix: true,
                    argument: {
                        type: "Literal",
                        value: -t,
                        raw: n.start.raw
                    }
                };
            }
            return {
                type: "Literal",
                value: t,
                raw: n.start.raw
            };
        });
        c(v, function e(n) {
            return {
                type: "Identifier",
                name: String(n.value)
            };
        });
        ot.DEFMETHOD("to_mozilla_ast", Xn.prototype.to_mozilla_ast);
        et.DEFMETHOD("to_mozilla_ast", Xn.prototype.to_mozilla_ast);
        it.DEFMETHOD("to_mozilla_ast", function e() {
            return null;
        });
        Ie.DEFMETHOD("to_mozilla_ast", Re.prototype.to_mozilla_ast);
        Qe.DEFMETHOD("to_mozilla_ast", en.prototype.to_mozilla_ast);
        function r(e) {
            if (e.type == "Literal") {
                return e.raw != null ? e.raw : e.value + "";
            }
        }
        function s(e) {
            var n = e.loc, t = n && n.start;
            var i = e.range;
            return new Q({
                file: n && n.source,
                line: t && t.line,
                col: t && t.column,
                pos: i ? i[0] : e.start,
                endline: t && t.line,
                endcol: t && t.column,
                endpos: i ? i[0] : e.start,
                raw: r(e)
            });
        }
        function f(e) {
            var n = e.loc, t = n && n.end;
            var i = e.range;
            return new Q({
                file: n && n.source,
                line: t && t.line,
                col: t && t.column,
                pos: i ? i[1] : e.end,
                endline: t && t.line,
                endcol: t && t.column,
                endpos: i ? i[1] : e.end,
                raw: r(e)
            });
        }
        function e(e, n, t) {
            var o = "function From_Moz_" + e + "(M){\n";
            o += "return new U2." + n.name + "({\n" + "start: my_start_token(M),\n" + "end: my_end_token(M)";
            var a = "function To_Moz_" + e + "(M){\n";
            a += "return {\n" + "type: " + JSON.stringify(e);
            if (t) t.split(/\s*,\s*/).forEach(function(e) {
                var n = /([a-z0-9$_]+)(=|@|>|%)([a-z0-9$_]+)/i.exec(e);
                if (!n) throw new Error("Can't understand property map: " + e);
                var t = n[1], i = n[2], r = n[3];
                o += ",\n" + r + ": ";
                a += ",\n" + t + ": ";
                switch (i) {
                  case "@":
                    o += "M." + t + ".map(from_moz)";
                    a += "M." + r + ".map(to_moz)";
                    break;

                  case ">":
                    o += "from_moz(M." + t + ")";
                    a += "to_moz(M." + r + ")";
                    break;

                  case "=":
                    o += "M." + t;
                    a += "M." + r;
                    break;

                  case "%":
                    o += "from_moz(M." + t + ").body";
                    a += "to_moz_block(M)";
                    break;

                  default:
                    throw new Error("Can't understand operator in propmap: " + e);
                }
            });
            o += "\n})\n}";
            a += "\n}\n}";
            o = new Function("U2", "my_start_token", "my_end_token", "from_moz", "return(" + o + ")")(h, s, f, u);
            a = new Function("to_moz", "to_moz_block", "to_moz_scope", "return(" + a + ")")(l, p, d);
            i[e] = o;
            c(n, a);
        }
        var o = null;
        function u(e) {
            o.push(e);
            var n = e != null ? i[e.type](e) : null;
            o.pop();
            return n;
        }
        qe.from_mozilla_ast = function(e) {
            var n = o;
            o = [];
            var t = u(e);
            o = n;
            t.walk(new ft(function(e) {
                if (e instanceof ve) {
                    for (var n = 0, t; t = this.parent(n); n++) {
                        if (t instanceof Xe) break;
                        if (t instanceof Ue && t.label.name == e.name) {
                            e.thedef = t.label;
                            break;
                        }
                    }
                    if (!e.thedef) {
                        var i = e.start;
                        me("Undefined label " + e.name, i.file, i.line, i.col, i.pos);
                    }
                }
            }));
            return t;
        };
        function t(e, n, t) {
            var i = e.start;
            var r = e.end;
            if (i.pos != null && r.endpos != null) {
                n.range = [ i.pos, r.endpos ];
            }
            if (i.line) {
                n.loc = {
                    start: {
                        line: i.line,
                        column: i.col
                    },
                    end: r.endline ? {
                        line: r.endline,
                        column: r.endcol
                    } : null
                };
                if (i.file) {
                    n.loc.source = i.file;
                }
            }
            return n;
        }
        function c(e, n) {
            e.DEFMETHOD("to_mozilla_ast", function() {
                return t(this, n(this));
            });
        }
        function l(e) {
            return e != null ? e.to_mozilla_ast() : null;
        }
        function p(e) {
            return {
                type: "BlockStatement",
                body: e.body.map(l)
            };
        }
        function d(e, n) {
            var t = n.body.map(l);
            if (n.body[0] instanceof Pe && n.body[0].body instanceof Kn) {
                t.unshift(l(new Fe(n.body[0])));
            }
            return {
                type: e,
                body: t
            };
        }
    })();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    var D = function() {
        var n = [];
        [ "null", "true", "false", "Infinity", "-Infinity", "undefined" ].forEach(t);
        [ Array, Boolean, Date, Error, Function, Math, Number, Object, RegExp, String ].forEach(function(e) {
            Object.getOwnPropertyNames(e).map(t);
            if (e.prototype) {
                Object.getOwnPropertyNames(new e()).map(t);
                Object.getOwnPropertyNames(e.prototype).map(t);
            }
        });
        return Oe(n);
        function t(e) {
            n.push(e);
        }
    }();
    function A(e, n) {
        e.walk(new ft(function(e) {
            if (e instanceof Nn) {
                if (e.quote) t(e.key);
            } else if (e instanceof Dn) {
                z(e.property, t);
            }
        }));
        function t(e) {
            ue(n, e);
        }
    }
    function z(e, n) {
        if (e instanceof jn) {
            z(e.consequent, n);
            z(e.alternative, n);
        } else if (e instanceof Sn) {
            z(e.tail_node(), n);
        } else if (e instanceof Kn) {
            n(e.value);
        }
    }
    function $(e, t) {
        t = re(t, {
            builtins: false,
            cache: null,
            debug: false,
            keep_quoted: false,
            regex: null,
            reserved: null
        }, true);
        var n = Object.create(t.builtins ? null : D);
        if (Array.isArray(t.reserved)) t.reserved.forEach(function(e) {
            n[e] = true;
        });
        var i = -1;
        var r;
        if (t.cache) {
            r = t.cache.props;
            r.each(function(e) {
                n[e] = true;
            });
        } else {
            r = new Ae();
        }
        var o = t.regex;
        var a = t.debug !== false;
        var s;
        if (a) s = t.debug === true ? "" : t.debug;
        var f = Object.create(null);
        var u = Object.create(n);
        e.walk(new ft(function(e) {
            if (e instanceof qn) {
                if (e.operator == "in") z(e.left, p);
            } else if (e.TYPE == "Call") {
                var n = e.expression;
                if (n instanceof On) switch (n.property) {
                  case "defineProperty":
                  case "getOwnPropertyDescriptor":
                    if (e.args.length < 2) break;
                    n = n.expression;
                    if (!(n instanceof Jn)) break;
                    if (n.name != "Object") break;
                    if (!n.definition().undeclared) break;
                    z(e.args[1], p);
                    break;

                  case "hasOwnProperty":
                    if (e.args.length < 1) break;
                    z(e.args[0], p);
                    break;
                }
            } else if (e instanceof On) {
                p(e.property);
            } else if (e instanceof Nn) {
                p(e.key);
            } else if (e instanceof Pn) {
                p(e.key.name);
            } else if (e instanceof Dn) {
                z(e.property, p);
            }
        }));
        e.walk(new ft(function(e) {
            if (e instanceof qn) {
                if (e.operator == "in") h(e.left);
            } else if (e.TYPE == "Call") {
                var n = e.expression;
                if (n instanceof On) switch (n.property) {
                  case "defineProperty":
                  case "getOwnPropertyDescriptor":
                    if (e.args.length < 2) break;
                    n = n.expression;
                    if (!(n instanceof Jn)) break;
                    if (n.name != "Object") break;
                    if (!n.definition().undeclared) break;
                    h(e.args[1]);
                    break;

                  case "hasOwnProperty":
                    if (e.args.length < 1) break;
                    h(e.args[0]);
                    break;
                }
            } else if (e instanceof On) {
                e.property = d(e.property);
            } else if (e instanceof Nn) {
                e.key = d(e.key);
            } else if (e instanceof Pn) {
                e.key.name = d(e.key.name);
            } else if (e instanceof Dn) {
                if (!t.keep_quoted) h(e.property);
            }
        }));
        function c(e) {
            if (u[e]) return false;
            if (/^-?[0-9]+(\.[0-9]+)?(e[+-][0-9]+)?$/.test(e)) return false;
            return true;
        }
        function l(e) {
            if (n[e]) return false;
            if (o && !o.test(e)) return false;
            return r.has(e) || f[e];
        }
        function p(e) {
            if (c(e)) f[e] = true;
            if (!l(e)) u[e] = true;
        }
        function d(e) {
            if (!l(e)) {
                return e;
            }
            var n = r.get(e);
            if (!n) {
                if (a) {
                    var t = "_$" + e + "$" + s + "_";
                    if (c(t)) n = t;
                }
                if (!n) do {
                    n = b(++i);
                } while (!c(n));
                r.set(e, n);
            }
            return n;
        }
        function h(e) {
            if (e instanceof Sn) {
                h(e.expressions.tail_node());
            } else if (e instanceof Kn) {
                e.value = d(e.value);
            } else if (e instanceof jn) {
                h(e.consequent);
                h(e.alternative);
            }
        }
    }
    "use strict";
    var L, V;
    if (typeof Buffer == "undefined") {
        L = atob;
        V = btoa;
    } else if (typeof Buffer.alloc == "undefined") {
        L = function(e) {
            return new Buffer(e, "base64").toString();
        };
        V = function(e) {
            return new Buffer(e).toString("base64");
        };
    } else {
        L = function(e) {
            return Buffer.from(e, "base64").toString();
        };
        V = function(e) {
            return Buffer.from(e).toString("base64");
        };
    }
    function W(e, n) {
        var t = n.end.comments_after;
        for (var i = t.length; --i >= 0; ) {
            var r = t[i];
            if (r.type != "comment1") break;
            var o = /^# ([^\s=]+)=(\S+)\s*$/.exec(r.value);
            if (!o) break;
            if (o[1] == "sourceMappingURL") {
                o = /^data:application\/json(;.*?)?;base64,(\S+)$/.exec(o[2]);
                if (!o) break;
                return L(o[2]);
            }
        }
        qe.warn("inline source map not found: " + e);
    }
    function J(n) {
        try {
            return JSON.parse(n);
        } catch (e) {
            throw new Error("invalid input source map: " + n);
        }
    }
    function G(n, t, e) {
        if (t[n]) {
            e.forEach(function(e) {
                if (t[e]) {
                    if (typeof t[e] != "object") t[e] = {};
                    if (!(n in t[e])) t[e][n] = t[n];
                }
            });
        }
    }
    function X(e) {
        if (!e) return;
        if (!("props" in e)) {
            e.props = new Ae();
        } else if (!(e.props instanceof Ae)) {
            e.props = Ae.fromObject(e.props);
        }
    }
    function ie(e) {
        return {
            props: e.props.toObject()
        };
    }
    function mt(i, r) {
        try {
            r = re(r, {
                compress: {},
                enclose: false,
                ie8: false,
                keep_fnames: false,
                mangle: {},
                nameCache: null,
                output: {},
                parse: {},
                rename: undefined,
                sourceMap: false,
                timings: false,
                toplevel: false,
                validate: false,
                warnings: false,
                wrap: false
            }, true);
            if (r.validate) qe.enable_validation();
            var e = r.timings && {
                start: Date.now()
            };
            if (r.rename === undefined) {
                r.rename = r.compress && r.mangle;
            }
            G("ie8", r, [ "compress", "mangle", "output" ]);
            G("keep_fnames", r, [ "compress", "mangle" ]);
            G("toplevel", r, [ "compress", "mangle" ]);
            var n;
            if (r.mangle) {
                r.mangle = re(r.mangle, {
                    cache: r.nameCache && (r.nameCache.vars || {}),
                    eval: false,
                    ie8: false,
                    keep_fnames: false,
                    properties: false,
                    reserved: [],
                    toplevel: false
                }, true);
                if (r.mangle.properties) {
                    if (typeof r.mangle.properties != "object") {
                        r.mangle.properties = {};
                    }
                    if (r.mangle.properties.keep_quoted) {
                        n = r.mangle.properties.reserved;
                        if (!Array.isArray(n)) n = [];
                        r.mangle.properties.reserved = n;
                    }
                    if (r.nameCache && !("cache" in r.mangle.properties)) {
                        r.mangle.properties.cache = r.nameCache.props || {};
                    }
                }
                X(r.mangle.cache);
                X(r.mangle.properties.cache);
            }
            if (r.sourceMap) {
                r.sourceMap = re(r.sourceMap, {
                    content: null,
                    filename: null,
                    includeSources: false,
                    names: true,
                    root: null,
                    url: null
                }, true);
            }
            var t = [];
            if (r.warnings) qe.log_function(function(e) {
                t.push(e);
            }, r.warnings == "verbose");
            if (e) e.parse = Date.now();
            var o;
            if (i instanceof Ke) {
                o = i;
            } else {
                if (typeof i == "string") {
                    i = [ i ];
                }
                r.parse = r.parse || {};
                r.parse.toplevel = null;
                var a = r.sourceMap && r.sourceMap.content;
                if (typeof a == "string" && a != "inline") {
                    a = J(a);
                }
                if (a) r.sourceMap.orig = Object.create(null);
                for (var s in i) if (ze(i, s)) {
                    r.parse.filename = s;
                    r.parse.toplevel = o = dt(i[s], r.parse);
                    if (a == "inline") {
                        var f = W(s, o);
                        if (f) {
                            r.sourceMap.orig[s] = J(f);
                        }
                    } else if (a) {
                        r.sourceMap.orig[s] = a;
                    }
                }
            }
            if (n) {
                A(o, n);
            }
            [ "enclose", "wrap" ].forEach(function(e) {
                var n = r[e];
                if (!n) return;
                var t = o.print_to_string().slice(0, -1);
                o = o[e](n);
                i[o.start.file] = o.print_to_string().replace(t, "");
            });
            if (r.validate) o.validate_ast();
            if (e) e.rename = Date.now();
            if (r.rename) {
                o.figure_out_scope(r.mangle);
                o.expand_names(r.mangle);
            }
            if (e) e.compress = Date.now();
            if (r.compress) {
                o = new _t(r.compress).compress(o);
                if (r.validate) o.validate_ast();
            }
            if (e) e.scope = Date.now();
            if (r.mangle) o.figure_out_scope(r.mangle);
            if (e) e.mangle = Date.now();
            if (r.mangle) {
                o.compute_char_frequency(r.mangle);
                o.mangle_names(r.mangle);
            }
            if (e) e.properties = Date.now();
            if (r.mangle && r.mangle.properties) $(o, r.mangle.properties);
            if (e) e.output = Date.now();
            var u = {};
            if (r.output.ast) {
                u.ast = o;
            }
            if (!ze(r.output, "code") || r.output.code) {
                if (r.sourceMap) {
                    r.output.source_map = O(r.sourceMap);
                    if (r.sourceMap.includeSources) {
                        if (i instanceof Ke) {
                            throw new Error("original source content unavailable");
                        } else for (var s in i) if (ze(i, s)) {
                            r.output.source_map.setSourceContent(s, i[s]);
                        }
                    }
                }
                delete r.output.ast;
                delete r.output.code;
                var c = vt(r.output);
                o.print(c);
                u.code = c.get();
                if (r.sourceMap) {
                    u.map = r.output.source_map.toString();
                    var l = r.sourceMap.url;
                    if (l) {
                        u.code = u.code.replace(/\n\/\/# sourceMappingURL=\S+\s*$/, "");
                        if (l == "inline") {
                            u.code += "\n//# sourceMappingURL=data:application/json;charset=utf-8;base64," + V(u.map);
                        } else {
                            u.code += "\n//# sourceMappingURL=" + l;
                        }
                    }
                }
            }
            if (r.nameCache && r.mangle) {
                if (r.mangle.cache) r.nameCache.vars = ie(r.mangle.cache);
                if (r.mangle.properties && r.mangle.properties.cache) {
                    r.nameCache.props = ie(r.mangle.properties.cache);
                }
            }
            if (e) {
                e.end = Date.now();
                u.timings = {
                    parse: .001 * (e.rename - e.parse),
                    rename: .001 * (e.compress - e.rename),
                    compress: .001 * (e.scope - e.compress),
                    scope: .001 * (e.mangle - e.scope),
                    mangle: .001 * (e.properties - e.mangle),
                    properties: .001 * (e.output - e.properties),
                    output: .001 * (e.end - e.output),
                    total: .001 * (e.end - e.start)
                };
            }
            if (t.length) {
                u.warnings = t;
            }
            return u;
        } catch (e) {
            return {
                error: e
            };
        } finally {
            qe.disable_validation();
        }
    }
    h["Dictionary"] = Ae;
    h["List"] = Se;
    h["minify"] = mt;
    h["parse"] = dt;
    h["push_uniq"] = ue;
    h["TreeTransformer"] = ht;
    h["TreeWalker"] = ft;
})(typeof UglifyJS == "undefined" ? UglifyJS = {} : UglifyJS);
// @license-end
